#pragma GCC optimize("Ofast,O2,O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define MP make_pair
#define all(x) (x).begin(), (x).end()

const int N = 1e6 + 3e2;

struct edge{
    int u, x, y;
    edge(int _u, int _x, int _y){
        u = _u;
        x = _x;
        y = _y;
    }

};

vector<edge> g[N];

int a[N], b[N];

int d[N];
int mxa[N], mxb[N];
void add(int x, int y){
    while (d[x] != 1){
        int p = d[x];
        a[p]++;
        mxa[p] = max(mxa[p], a[p] - b[p]);
        x /= p;
    }
    while (d[y] != 1){
        int p = d[y];
        b[p]++;
        mxb[p] = max(mxb[p], b[p] - a[p]);
        y /= p;
    }
}

void del(int x, int y){
    while (d[x] != 1){
        int p = d[x];
        a[p]--;
        x /= p;
    }
    while (d[y] != 1){
        int p = d[y];
        b[p]--;
        y /= p;
    }
}

const int MOD = 998244353;

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    ll x = binpow(n, k / 2);
    x = x * x % MOD;
    if (k % 2) x = x * n % MOD;
    return x;
}


ll val[N];
void dfs(int v, int p){
    for (auto e : g[v]){
        int u = e.u, x = e.x, y = e.y;
        if (u == p) continue;

        add(x, y);

        val[u] = val[v] * x % MOD * binpow(y, MOD - 2) % MOD;
        dfs(u, v);

        del(x, y);
    }
}

void solve(int test) {
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++){
        d[i] = i;
        g[i].clear();
        a[i] = b[i] = 0;
        mxa[i] = mxb[i] = 0;
        val[i] = 0;
    }

    for (int i = 2; i <= n; i++){
        if (d[i] != i || 1ll * i * i > n) continue;
        for (int j = i * i; j <= n; j += i) d[j] = i;
    }

    for (int i = 1; i < n; i++){
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        int gcd = __gcd(x, y);
        x /= gcd, y /= gcd;
        g[u].emplace_back(v, y, x);
        g[v].emplace_back(u, x, y);
    }

    val[1] = 1;
    dfs(1, 1);

    for (int i = 1; i <= n; i++){
        while (mxb[i] > 0){
            val[1] = val[1] * i % MOD;
            mxb[i]--;
        }
    }

    ll ans = val[1];
    for (int i = 2; i <= n; i++){
        ans += val[1] * val[i] % MOD;
        ans %= MOD;
    }

    cout << ans << endl;

}

int main() {
    ios_base::sync_with_stdio(false);

#ifdef dddxxz
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tests = 1;
    cin >> tests;

    for (int test = 1; test <= tests; test++) {
        solve(test);
    }

    return 0;
}
