#include <iostream>
#include <vector>

using namespace std;

vector<bool> resh;
vector<int> min_p;

void get_resh() {
    resh.resize(2e5 + 100, 1);
    min_p.resize(2e5 + 100);
    resh[0] = resh[1] = 0;
    for (int i = 0; i < min_p.size(); i++) {
        min_p[i] = i;
    }
    for (int j = 2; j * j < min_p.size(); j++) {
        if (resh[j]) {
            for (int i = j * j; i < min_p.size(); i += j) {
                resh[i] = 0;
                min_p[i] = min(min_p[i], j);
            }
        }
    }
}

const int MOD = 998244353;

int add(int a, int b) {
    a += b;
    if (a >= MOD) a -= MOD;
    if (a < 0) a += MOD;
    return a;
}

int mul(long long a, int b) {
    return a * b % MOD;
}

int gcd(int a, int b) {
    while (a != 0) {
        b %= a;
        swap(a, b);
    }
    return b;
}

int bin_pow(int a, int p) {
    if (p == 0) return 1;
    if (p % 2 == 0) {
        int k = bin_pow(a, p / 2);
        return mul(k, k);
    }
    return mul(a, bin_pow(a, p - 1));
}

vector<int> chisl;
vector<int> znam;
vector<int> nok;
vector<int> chisl_num;
vector<int> znam_num;
vector<vector<pair<pair<int, int>, int>>> g;
vector<bool> used;

vector<int> get_fact(int n) {
    vector<int> fact;
    while (n != 1) {
        fact.push_back(min_p[n]);
        n /= min_p[n];
    }
    return fact;
}

void dfs(int v) {
//    cout << v << endl;
//    for (int i = 0; i < chisl.size(); i++) {
//        cout << chisl[i] << " ";
//    }
//    cout << endl;
//    for (int i = 0; i < znam.size(); i++) {
//        cout << znam[i] << " ";
//    }
//    cout << endl;
//    cout << chisl_num[v] << " " << znam_num[v] << endl;
    used[v] = 1;
    for (auto i : g[v]) {
        if (!used[i.second]) {
            auto t = i.first;
            auto u = i.second;
            vector<int> fact_c = get_fact(t.first);
            vector<int> fact_z = get_fact(t.second);
            znam_num[u] = znam_num[v];
            chisl_num[u] = chisl_num[v];
            for (int j : fact_c) {
                chisl[j]++;
                chisl_num[u] = mul(chisl_num[u], j);
            }
            for (int j : fact_z) {
                znam[j]++;
                znam_num[u] = mul(znam_num[u], j);
                nok[j] = max(nok[j], znam[j] - chisl[j]);
            }
            dfs(u);
            for (int j : fact_c) {
                chisl[j]--;
            }
            for (int j : fact_z) {
                znam[j]--;
                //nok[j] = max(nok[j], znam[j] - chisl[j]);
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    g.clear();
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        u--, v--;
        int d = gcd(x, y);
        x /= d;
        y /= d;
        g[u].push_back({{y, x}, v});
        g[v].push_back({{x, y}, u});
    }
    used.assign(n, 0);
    chisl.assign(n + 1, 0);
    znam.assign(n + 1, 0);
    nok.assign(n + 1, 0);
    chisl_num.assign(n, 1);
    znam_num.assign(n, 1);
    dfs(0);
    int ans = 0;
    int x = 1;
    for (int i = 0; i <= n; i++) {
        x = mul(x, bin_pow(i, nok[i]));
    }
//    cout << "nok" << endl;
//    for (int i : nok) {
//        cout << i << " ";
//    }
//    cout << endl;
//    cout << x << endl;
    for (int i = 0; i < n; i++) {
        ans = add(ans, mul(mul(x, chisl_num[i]), bin_pow(znam_num[i], MOD - 2)));
    }
    cout << ans << endl;
}

int main() {
    get_resh();
//    for (int i = 0; i < 30; i++) {
//        cout << resh[i] << " " << min_p[i] << endl;
//    }
    int t;
    cin >> t;
    while (t--) solve();
}
