#include <iostream>
#include <vector>
#include <map>

const int maxN = 2e5, mod = 998244353;

struct Edge {
	int v, mul, div;
	Edge(int v = 0, int mul = 0, int div = 1) : v(v), mul(mul), div(div) {}
};

int t, n, u, v, x, y, ans;
std::vector<Edge> gr[maxN];
std::map<int, int> dict;

int binpow(int a, int b) {
	int res = 1;
	while (b) {
		if (b & 1)
			res = 1LL * res * a % mod;
		a = 1LL * a * a % mod;
		b >>= 1;
	}
	return res;
}

int inv(int a) {
	return binpow(a, mod - 2);
}

std::map<int, int> dfs(int u, int p, int x) {
	ans += x;
	if (ans >= mod)
		ans -= mod;
	std::map<int, int> dict;
	for (Edge& e : gr[u])
		if (e.v != p) {
			int x1 = 1LL * x * e.mul % mod * inv(e.div) % mod;
			std::map<int, int> temp = dfs(e.v, u, x1);
			int cur = e.div;
			for (int i = 2, cnt = 0; i * i <= cur; i++)
				if (cur % i == 0) {
					cnt = 0;
					while (cur % i == 0) {
						cur /= i;
						cnt++;
					}
					temp[i] += cnt;
				}
			if (cur > 1)
				temp[cur]++;
			cur = e.mul;
			for (int i = 2, cnt = 0; i * i <= cur; i++)
				if (cur % i == 0) {
					cnt = 0;
					while (cur % i == 0) {
						cur /= i;
						cnt++;
					}
					temp[i] = std::max(0, temp[i] - cnt);
				}
			if (cur > 1)
				temp[cur] = std::max(0, temp[cur] - 1);
			if (temp.size() > dict.size())
				std::swap(temp, dict);
			for (std::pair<int, int> it : temp)
				dict[it.first] = std::max(dict[it.first], it.second);
			temp.clear();
		}
	return dict;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> t;
	while (t--) {
		ans = 0;
		dict.clear();
		std::cin >> n;
		for (int i = 0; i < n; i++)
			gr[i].clear();
		for (int i = 1; i < n; i++) {
			std::cin >> u >> v >> x >> y; u--; v--;
			gr[u].push_back(Edge(v, y, x));
			gr[v].push_back(Edge(u, x, y));
		}
		dict = dfs(0, 0, 1);
		int temp = 1;
		for (std::pair<int, int> it : dict)
			temp = 1LL * temp * binpow(it.first, it.second) % mod;
		std::cout << 1LL * temp * ans % mod << "\n";
	}
	return 0;
}