#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <vector>
#include <string>
#include <map>
#include <queue>
#include <deque>
#include <random>
#define _CRT_SECURE_NO_WARNINGS
using namespace std;
mt19937 rnd(228337);

using ll = long long;
#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const ll INF = 1e9 + 9;
const int N = 1e6 + 9, M = 998244353;

int a[N];


int rev(int a)
{
    int ans = 1;
    int x = a;
    int n = M - 2;
    for (int i = 0; i < 40; i++)
    {
        if ((n >> i) & 1)
            ans = (ans * x) % M;
        x = (x * x) % M;
    }
    return ans;
}

struct Edge
{
    int u, x, y;
};

vector<Edge> g[N];
int b[N];

int gcd(int x, int y)
{
    if (x > y)
        swap(x, y);
    while (x != 0)
    {
        y %= x;
        swap(x, y);
    }
    return y;
}

void dfs(int v, int p)
{
    for (auto to : g[v])
    {
        if (to.u == p)
            continue;
        if (to.u == 5)
        {
            to = to;
        }
        a[to.u] = (a[v] * to.y) % M;
        b[to.u] = (b[v] * to.x) % M;
        int g = gcd(a[to.u], b[to.u]);
        a[to.u] = (a[to.u] * rev(g)) % M;
        b[to.u] = (b[to.u] * rev(g)) % M;
        dfs(to.u, v);
    }
}


signed main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif


    
    
    int t;
    cin >> t;
    
    for (int i = 0; i < t; i++)
    {
        int n;
        cin >> n;
        for (int i = 0; i <= n; i++)
        {
            g[i].clear();
        }
        for (int i = 0; i < n - 1; i++)
        {
            int v, u, x, y;
            cin >> v >> u >> x >> y;
            g[v].push_back({ u, x, y });
            g[u].push_back({ v, y, x });
        }
        a[1] = 1;
        b[1] = 1;
        dfs(1, 0);
        int k = 1;
        for (int i = 1; i <= n; i++)
        {
            k = (k * b[i] * rev(gcd(k, b[i]))) % M;
        }
        int ans = 0;
        for (int i = 1; i <= n; i++)
        {
            ans = (ans + (((a[i] * k) % M)  * rev(b[i])) % M) % M;
        }
        cout << ans << endl;
    }
}