#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <vector>
#include <string>
#include <map>
#include <queue>
#include <deque>
#include <random>
#define _CRT_SECURE_NO_WARNINGS
using namespace std;
mt19937 rnd(228337);

using ll = long long;
#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const ll INF = 1e9 + 9;
const int N = 1e6 + 9, M = 998244353;

int a[N];


int rev(int a)
{
    int ans = 1;
    int x = a;
    int n = M - 2;
    for (int i = 0; i < 40; i++)
    {
        if ((n >> i) & 1)
            ans = (ans * x) % M;
        x = (x * x) % M;
    }
    return ans;
}

struct Edge
{
    int u;
    vector<int> x, y;
};

vector<int> get(int x)
{
    vector<int> v;
    for (int i = 2; x > 1 && i * i <= x; i++)
    {
        while (x % i == 0)
        {
            v.push_back(i);
            x /= i;
        }
    }
    if (x != 1)
        v.push_back(x);
    return v;
}

vector<Edge> g[N];
int b[N];

int gcd(int x, int y)
{
    if (x > y)
        swap(x, y);
    while (x != 0)
    {
        y %= x;
        swap(x, y);
    }
    return y;
}
int cnt[N];
int minval[N];
int k;
void dfs_k(int v, int p)
{
    for (auto to : g[v])
    {
        if (to.u == p)
            continue;
        for (auto d : to.y)
        {
            cnt[d] = cnt[d] + 1;
        }
        for (auto d : to.x)
        {
            cnt[d] = cnt[d] - 1;
            if (minval[d] > cnt[d])
                minval[d] = cnt[d];
        }
        dfs_k(to.u, v);
        for (auto d : to.y)
        {
            cnt[d] = cnt[d] - 1;
        }
        for (auto d : to.x)
        {
            cnt[d] = cnt[d] + 1;
        }
    }
}
int ans[N];
void dfs(int v, int p)
{
    for (auto to : g[v])
    {
        if (to.u == p)
            continue;
        a[to.u] = a[v];
        b[to.u] = b[v];
        for (auto d : to.y)
        {
            a[to.u] = (a[to.u] * d) % M;
        }
        for (auto d : to.x)
        {
            b[to.u] = (b[to.u] * d) % M;
        }
        ans[to.u] = (a[to.u] * k) % M * rev(b[to.u]) % M;
        dfs(to.u, v);
    }
}


signed main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif




    int t;
    cin >> t;

    for (int i = 0; i < t; i++)
    {
        int n;
        cin >> n;
        
        for (int i = 0; i <= n; i++)
        {
            g[i].clear();
            cnt[i] = 0;
            minval[i] = 0;
        }
        for (int i = 0; i < n - 1; i++)
        {
            int v, u, x, y;
            cin >> v >> u >> x >> y;
            g[v].push_back({ u, get(x), get(y) });
            g[u].push_back({ v, get(y), get(x) });
        }
        a[1] = 1;
        b[1] = 1;
        dfs_k(1, 0);
        k = 1;
        for (int p = 0; p <= n; p++)
        {
            for (int i = 0; i < -minval[p]; i++)
                k = (k * p) % M;
        }
        ans[1] = k;
        dfs(1, 0);
        int sum = 0;
        for (int i = 1; i <= n; i++)
        {
            sum = (sum + ans[i]) % M;
        }
        cout << sum << endl;
    }
}