#include <iostream>
#include <tuple>
#include <vector>
#include <algorithm>
#include <random>
#include <ctime>
#include <iomanip>
#include <unordered_map>
#include <set>
#include <cstring>


using namespace std;

typedef uint32_t uint;
typedef int64_t ll;
typedef uint64_t ull;
mt19937 rnd((uint)time(0));

#define all(x) x.begin(),x.end()

constexpr uint MAXN = 200001;
constexpr uint MOD = 998244353;
uint rv[MAXN];

ull bpow(ull x, ull p) {
    ull res = 1;
    for (uint i = 0; i < 31; ++i) {
        if (p & (1 << i)) res = res * x % MOD;
        x = x * x % MOD;
    }
    return res;
}

typedef array<uint, 3> edge;
ull mval[MAXN];
vector<vector<int>> decomp(MAXN);
bool prime[MAXN];
vector<int> primes;
uint rpnum[MAXN];
//vector<unordered_map<int, int>> pmap;
int ntake[17984 + 1];
int cmap[17984 + 1];
void dfs(uint v, vector<vector<edge>> &a, vector<bool> &used) {
    used[v] = true;
    for (edge &e : a[v]) {
        if (!used[e[0]]) {
//            mval[e[0]] = mval[v] * e[2] % MOD * rv[e[1]] % MOD;
//            dfs(e[0], a, used);
//            unordered_map<int, int> &tmap = pmap[e[0]];
//            for (uint pm : decomp[e[2]]) tmap[pm]++;
//            for (uint pm : decomp[e[1]]) tmap[pm]--;
//            for (auto &[x, y] : tmap) {
//                ntake[x] = min(ntake[x], pmap[v][x] = min(pmap[v][x], y));
//            }
            mval[e[0]] = mval[v] * e[2] % MOD * rv[e[1]] % MOD;
//            pmap[e[0]] = pmap[v];
//            unordered_map<int, int> &tmap = pmap[e[0]];
//            for (uint pm : decomp[e[2]]) tmap[pm]++;
//            for (uint pm : decomp[e[1]]) tmap[pm]--;
//            for (auto &[x, y] : tmap) {
//                ntake[x] = min(ntake[x], tmap[x]);
//            }

            for (uint pm : decomp[e[2]]) cmap[rpnum[pm]]++;
            for (uint pm : decomp[e[1]]) {
                ntake[rpnum[pm]] = min(ntake[rpnum[pm]], --cmap[rpnum[pm]]);
            }


            dfs(e[0], a, used);
            for (uint pm : decomp[e[2]]) --cmap[rpnum[pm]];
            for (uint pm : decomp[e[1]]) ++cmap[rpnum[pm]];
        }
    }
}

void solve() {
    memset(cmap, 0, sizeof(cmap));
    memset(ntake, 0, sizeof(ntake));
    uint n;
    cin >> n;
    vector<vector<edge>> a(n);
    for (uint i = 0; i + 1 < n; ++i) {
        ull u, v, x, y;
        cin >> u >> v >> x >> y;
        --u, --v;
        a[u].push_back(edge{v, x, y}); // div mul
        a[v].push_back(edge{u, y, x});
    }
    vector<bool> used(n);
//    pmap = vector<unordered_map<int, int>>(n);
//    cmap.clear();

    for (uint i = 0; i < n; ++i) used[i] = false;
    mval[0] = 1;
    dfs(0, a, used);
    ull sm = 0;
    for (uint i = 0; i < n; ++i) {
        sm += mval[i];
        if (sm >= MOD) sm -= MOD;
    }
//    for (auto &[x, y] : ntake) {
//        if (y < 0) sm = sm * bpow(x, -y) % MOD;
//    }
    for (uint i = 0; i < 17984 + 1; ++i) {
        if (ntake[i] < 0) sm = sm * bpow(primes[i], -ntake[i]) % MOD;
    }
    cout << sm << '\n';
}


int main() {
    for (ull i = 0; i < MAXN; ++i) {
        rv[i] = bpow(i, MOD - 2);
    }
    for (bool &p : prime) p = true;
    primes.push_back(2);
    decomp[2] = vector<int>{2};
    decomp[4] = vector<int>{2, 2};
    prime[0] = prime[1] = prime[4] = false;
    for (int i = 3; i < (int)MAXN; ++i) {
        if (prime[i]) {
            primes.push_back(i);
            decomp[i].push_back(i);
        }
        for (int j : primes) {
            if (j > decomp[i].back() || (ll)i * j >= MAXN) break;
            decomp[i * j] = decomp[i];
            decomp[i * j].push_back(j);
            prime[i * j] = false;
        }
    }
    for (uint i = 0; i < primes.size(); ++i) rpnum[primes[i]] = i;
    for (int &i : cmap) i = 0;
    decomp[1] = vector<int>{1};
//    for (uint i = 2; i < 100; ++i) {
//        cout << i << '\n';
//        for (auto &x : decomp[i]) cout << x << ' ';
//        cout << '\n';
//        cout << prime[i] << '\n';
//    }
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) solve();
}
