#include <iostream>
#include <algorithm>
#include <cstdio>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <random>
#include <chrono>
#include <bitset>
#include <vector>
#include <immintrin.h>
#include <stack>
#include <deque>
#include <queue>

#define BASE 97
#define MOD 1'000'000'007
#define MOD2 1'000'000'009

int32_t* base_powers1;
int32_t* base_powers2;

struct Hash {
    int32_t val1, val2;

    bool operator==(Hash other) {
        return val1 == other.val1 && val2 == other.val2;
    }

    Hash combine(int32_t x, Hash other) {
        return {(int32_t)(((int64_t)val1 * base_powers1[x] + other.val1) % MOD), (int32_t)(((int64_t)val2 * base_powers2[x] + other.val2) % MOD2)};
    }
};

std::vector<Hash>* segtree;

void build(int32_t node, int32_t left, int32_t right, std::string& str) {
    segtree[node].resize(right - left);
    if(right - left == 1) {
        segtree[node][0] = {str[left] - 'a' + 1, str[left] - 'a' + 1};
        return;
    }
    int32_t m = (left + right) / 2;
    build(node * 2 + 1, left, m, str);
    build(node * 2 + 2, m, right, str);
    for(int32_t i = 0; i < (right - left) / 2; i++)
        segtree[node][i] = segtree[node * 2 + 1][i].combine((right - left) / 2, segtree[node * 2 + 2][i]);
    for(int32_t i = (right - left) / 2; i < right - left; i++)
        segtree[node][i] = segtree[node * 2 + 2][i - (right - left) / 2].combine((right - left) / 2, segtree[node * 2 + 1][i - (right - left) / 2]);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    
    base_powers1 = new int32_t[1'000'005];
    base_powers1[0] = 1;
    for(int32_t i = 1; i < 1'000'005; i++)
        base_powers1[i] = ((int64_t)base_powers1[i - 1] * BASE) % MOD;
    base_powers2 = new int32_t[1'000'005];
    base_powers2[0] = 1;
    for(int32_t i = 1; i < 1'000'005; i++)
        base_powers2[i] = ((int64_t)base_powers2[i - 1] * BASE) % MOD2;

    int32_t n;
    std::cin >> n;

    std::string str;
    std::cin >> str;

    segtree = new std::vector<Hash>[4 * (1 << n)];
    build(0, 0, 1 << n, str);

    int32_t ans = 0;
    for(int32_t i = 1; i < (1 << n); i++) {
        if(segtree[0][i] == segtree[0][ans])
            continue;

        int32_t node1 = 0, node2 = 0;
        int32_t matches = 0;
        int32_t mask = (1 << (n - 1)) - 1;
        for(int32_t j = n - 1; j >= 0; j--) {
            Hash full1 = (ans & (1 << j)) ? segtree[node1 * 2 + 2][ans & mask] : segtree[node1 * 2 + 1][ans & mask];
            Hash full2 = (i   & (1 << j)) ? segtree[node2 * 2 + 2][i & mask] : segtree[node2 * 2 + 1][i & mask];
            if(full1 == full2) {
                matches += 1 << j;
                node1 = (ans & (1 << j)) ? (node1 * 2 + 1) : (node1 * 2 + 2);
                node2 = (i   & (1 << j)) ? (node2 * 2 + 1) : (node2 * 2 + 2);
            } else {
                node1 = (ans & (1 << j)) ? (node1 * 2 + 2) : (node1 * 2 + 1);
                node2 = (i   & (1 << j)) ? (node2 * 2 + 2) : (node2 * 2 + 1);
            }
            mask ^= 1 << (j - 1);
        }

        if(str[matches ^ ans] > str[matches ^ i])
            ans = i;
    }

    for(int32_t i = 0; i < (1 << n); i++)
        std::cout << str[i ^ ans];
    return 0;
}


//abdbdccacbdbdccb
//abdbdccacbdbdccb

//cccccffffcccccffccfcffcccccfffff
//cccccffffcccccffccfcffcccccfffff


