#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

#define endl '\n'

const int Base = 3e5;
const long long Mod = 998244353;

int t;
int n;
vector<pair<int, pair<int, int>>> e[Base];
vector<long long> primes[2 * Base];
long long cnt[Base];
long long mult = 1;
long long ans = 0;

long long gcd(long long a, long long b)
{
	while (a != 0 && b != 0)
	{
		if (a > b)
		{
			a %= b;
		}
		else
		{
			b %= a;
		}
	}

	return a + b;
}

void fillPrimes(long long x, int id)
{
	long long k = 2;
	while (k * k <= x)
	{
		if (x % k == 0)
		{
			x /= k;
			primes[id].push_back(k);
		}
		else
		{
			k++;
		}
	}

	primes[id].push_back(x);
}

void dfs(int x, int p)
{
	for (auto v : e[x])
	{
		if (v.first != p)
		{
			int u = v.first;
			int idAdd = v.second.first;
			int idDel = v.second.second;

			for (auto k : primes[idAdd])
			{
				cnt[k]++;
			}

			for (auto k : primes[idDel])
			{
				if (cnt[k] > 0)
				{
					cnt[k]--;
				}
				else
				{
					mult *= k;
					mult %= Mod;
				}
			}

			dfs(u, x);

			for (auto k : primes[idAdd])
			{
				cnt[k]--;
			}

			for (auto k : primes[idDel])
			{
				cnt[k]++;
			}
		}
	}
}

long long r(long long x)
{
	long long res = 1LL;
	long long deg = Mod - 2LL;
	long long val = x;
	while (deg > 0)
	{
		if (deg & 1LL)
		{
			res *= val;
			res %= Mod;
		}
		val *= val;
		val %= Mod;
		deg /= 2LL;
	}

	return res;
}

void calcAns(int x, int p, long long res)
{
	ans += res;
	ans %= Mod;

	for (auto v : e[x])
	{
		if (v.first != p)
		{
			int u = v.first;
			int idAdd = v.second.first;
			int idDel = v.second.second;
			long long passRes = res;

			for (auto k : primes[idAdd])
			{
				passRes *= k;
				passRes %= Mod;
			}

			for (auto k : primes[idDel])
			{
				passRes *= r(k);
				passRes %= Mod;
			}

			calcAns(u, x, passRes);
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("Text.txt", "w", stdout);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n;

		for (int i = 0; i <= n + 2; i++)
		{
			e[i].clear();
			cnt[i] = 0;
		}
		for (int i = 0; i <= 2 * n + 4; i++)
		{
			primes[i].clear();
		}
		int cl = 0;
		ans = 0;
		mult = 1;

		for (int i = 0; i < n - 1; i++)
		{
			int u, v;
			long long x, y;
			cin >> u >> v >> x >> y;
			u--;
			v--;
			long long d = gcd(x, y);
			x /= d;
			y /= d;

			fillPrimes(x, cl);
			fillPrimes(y, cl + 1);

			e[u].push_back(make_pair(v, make_pair(cl + 1, cl)));
			e[v].push_back(make_pair(u, make_pair(cl, cl + 1)));

			cl += 2;
		}

		dfs(0, -1);

		calcAns(0, -1, mult);

		cout << ans << endl;
	}
}