#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using vi = vector<ll>;
using pi = pair<ll, ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
struct SegTree {
    int size;
    vi tree;

    void init(int sz) {
        size = 1;
        while (size <= sz) {
            size *= 2;
        }
        tree = vi(2 * size, 0);
    }

    void set(int v, int tl, int tr, int ind, ll val) {
        if (tr - tl == 1) {
            tree[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        if (tm > ind) {
            set(2 * v + 1, tl, tm, ind, val);
        } else {
            set(2 * v + 2, tm, tr, ind, val);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void set(int ind, ll val) {
        set(0, 0, size, ind, val);
    }

    ll get(int v, int tl, int tr, int l, int r) {
        if (l >= r) {
            return 0;
        }
        if (tl == l && tr == r) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return get(2 * v + 1, tl, tm, l, min(r, tm)) + get(2 * v + 2, tm, tr, max(tm, l), r);
    }

    ll get(int l, int r) {
        return get(0, 0, size, l, r + 1);
    }
};


void solution() {
    int n;
    cin >> n;
    vi mass(n);
    ll total = 0;
    multiset<int> values;
    for (int i = 0; i < n; i++) {
        cin >> mass[i];
        values.insert(mass[i]);
        total += mass[i];
    }
    deque<int> to_delete;
    to_delete.push_back(total);
    while (!to_delete.empty()) {
        ll val = to_delete.front();
        if (val == 0) {
            cout << "NO" << endl;
            return;
        }
        to_delete.pop_front();
        if (values.count(val)) {
            values.erase(values.find(val));
            continue;
        }

        to_delete.push_back((val + 1) / 2);
        to_delete.push_back((val) / 2);
    }
    cout << "YES" << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solution();
    }
    return 0;
}
