#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using vi = vector<ll>;
using pi = pair<ll, ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const ll MOD = 998244353;
const ll INF = 1e18;
struct SegTree {
    int size;
    vi tree;

    void init(int sz) {
        size = 1;
        while (size <= sz) {
            size *= 2;
        }
        tree = vi(2 * size, 0);
    }

    void set(int v, int tl, int tr, int ind, ll val) {
        if (tr - tl == 1) {
            tree[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        if (tm > ind) {
            set(2 * v + 1, tl, tm, ind, val);
        } else {
            set(2 * v + 2, tm, tr, ind, val);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void set(int ind, ll val) {
        set(0, 0, size, ind, val);
    }

    ll get(int v, int tl, int tr, int l, int r) {
        if (l >= r) {
            return 0;
        }
        if (tl == l && tr == r) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return get(2 * v + 1, tl, tm, l, min(r, tm)) + get(2 * v + 2, tm, tr, max(tm, l), r);
    }

    ll get(int l, int r) {
        return get(0, 0, size, l, r + 1);
    }
};

ll binpow(ll n, ll a) {
    if (a == 0) {
        return 1;
    }
    if (a & 1) {
        return binpow(n, a - 1) * n % MOD;
    } else {
        ll val = binpow(n, a / 2);
        return val * val % MOD;
    }
}

ll inv(ll c) {
    return binpow(c, MOD - 2);
}

map<int, map<int, pi>> gr;
vector<ll> ans;



vector<int> sieve(3e5 + 10, 0);

map<int, int> factorize(ll numb) {
    map<int, int> values;
    if (numb == 1) {
        return values;
    }
    while (numb != 1) {
        values[sieve[numb]]++;
        numb /= sieve[numb];
    }
    return values;
}
map<int, int> deaf_diviner;

void calc(ll node, map<int, int> &stored, int anc = -1) {
   // cout << node << endl;
    for (auto i : gr[node]) {
        if (i.first == anc) continue;
        for (auto j : factorize(i.second.first)) {
            stored[j.first] -= j.second;
            deaf_diviner[j.first] = max(deaf_diviner[j.first], stored[j.first]);
        }
        for (auto j : factorize(i.second.second)) {
            stored[j.first] += j.second;
            deaf_diviner[j.first] = max(deaf_diviner[j.first], stored[j.first]);
        }
        calc(i.first, stored, node);
        for (auto j : factorize(i.second.second)) {
            stored[j.first] -= j.second;
            deaf_diviner[j.first] = max(deaf_diviner[j.first], stored[j.first]);
        }
        for (auto j : factorize(i.second.first)) {
            stored[j.first] += j.second;
            deaf_diviner[j.first] = max(deaf_diviner[j.first], stored[j.first]);
        }
    }
}

void dfs(int v, ll val, int anc = -1) {
    ans[v] = val;
    for (auto i : gr[v]) {
        if (i.first == anc) continue;
        ll new_val = (val * i.second.first) % MOD;
        new_val = (new_val * inv(i.second.second)) % MOD;
        dfs(i.first, new_val, v);
    }
}


void solution() {
    gr.clear();
    deaf_diviner.clear();
    int n;
    cin >> n;
    ans = vi(n + 1, 0);
    for (int k = 0; k < n - 1; k++) {
        ll i, j, x, y;
        cin >> i >> j >> y >> x;
        ll c = __gcd(x, y);
        x /= c;
        y /= c;
        gr[i][j] = {x, y};
        gr[j][i] = {y, x};
    }
    map<int, int> bla;
    calc(1, bla);
    ll val = 1;
    for (auto i : deaf_diviner) {
        val = (val * binpow(i.first, i.second)) % MOD;
    }
   // cout << "val is - ";
   // cout << val << endl;
    dfs(1, val);
    ll main = 0;
    for (auto i : ans) {
     //   cout << i << ' ';
        main = (main + i) % MOD;
    }
    cout << main << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for (int i = 2; i <= 3e5; i++ ) {
        if (sieve[i] != 0) continue;
        for (int j = i; j <= 2e5; j += i) {
            if (sieve[j] == 0)
                sieve[j] = i;
        }
    }
    int t = 1;
    cin >> t;
    while (t--) {
        solution();
    }
    return 0;
}
