#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using vi = vector<ll>;
using pi = pair<ll, ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const ll MOD = 998244353;
const ll INF = 1e18;
struct SegTree {
    int size;
    vi tree;

    void init(int sz) {
        size = 1;
        while (size <= sz) {
            size *= 2;
        }
        tree = vi(2 * size, 0);
    }

    void set(int v, int tl, int tr, int ind, ll val) {
        if (tr - tl == 1) {
            tree[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        if (tm > ind) {
            set(2 * v + 1, tl, tm, ind, val);
        } else {
            set(2 * v + 2, tm, tr, ind, val);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void set(int ind, ll val) {
        set(0, 0, size, ind, val);
    }

    ll get(int v, int tl, int tr, int l, int r) {
        if (l >= r) {
            return 0;
        }
        if (tl == l && tr == r) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return get(2 * v + 1, tl, tm, l, min(r, tm)) + get(2 * v + 2, tm, tr, max(tm, l), r);
    }

    ll get(int l, int r) {
        return get(0, 0, size, l, r + 1);
    }
};

ll binpow(ll n, ll a) {
    if (a == 0) {
        return 1;
    }
    if (a & 1) {
        return binpow(n, a - 1) * n % MOD;
    } else {
        ll val = binpow(n, a / 2);
        return val * val % MOD;
    }
}

ll inv(ll c) {
    return binpow(c, MOD - 2);
}



void solution() {
    int n;
    cin >> n;
    vector<int> mass(n);
    for (int i = 0; i < n; i++) {
        cin >> mass[i];
    }
    int max_sub = 1;
    vector<int> real_counter(5e7, 0);
    for (int dist = -240; dist <= 240; dist++) {
        vector<int> del_pos;
        for (int i = 0, cur_dist = 0; i < n; i++, cur_dist += dist) {
            real_counter[mass[i] - cur_dist + 2e7 + 5e6]++;
            del_pos.push_back(mass[i] - cur_dist + 2e7 + 5e6);
        }
        for (auto i : del_pos) {
            max_sub = max(max_sub, real_counter[i]);
            real_counter[i] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        unordered_map<int, int> counter;
        for (int j = i + 1; j < min(n, i + 450); j++) {
            if ((mass[j] - mass[i]) % (j - i) == 0) {
                counter[(mass[j] - mass[i]) / (j - i)]++;
            }
        }
        for (auto i : counter) {
            max_sub = max(max_sub, i.second + 1);
        }
    }


    cout << n - max_sub << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--) {
        solution();
    }
    return 0;
}
