#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>

#define int long long
#define sz(x) (int)x.size()
#define pw(x) (1LL<<x)
#define sqr(x) ((x)*(x))
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pii pair<int,int>
#define fi first
#define se second
#define p_b push_back
#define m_p make_pair

using namespace std;

const int INF = 998244353;
struct edges
{
    int u;
    int x;
    int y;
};
vector < edges > edge[200005];
int sum[200005], r[200005], pr[200005], comp[200005];
unordered_map < int, int > cnt[200005];

void fact(int n, vector < pii > &d)
{
    while(n > 1)
    {
        if(!sz(d) || d.back().fi != r[n])
            d.p_b({r[n], 0});
        d.back().se++;
        n /= r[n];
    }
}

int fast_pow(int a, int b)
{
    if(!b)
        return 1;
    if(b % 2)
        return (fast_pow(a, b - 1) * a) % INF;
    int x = fast_pow(a, b / 2);
    return (x * x) % INF;
}

int dfs(int v = 0, int p = -1)
{
    sum[v] = 0;
    comp[v] = 1;
    pr[v] = v;
    cnt[v].clear();
    for(auto &[to, x, y] : edge[v])
    {
        if(to == p)
            continue;
        dfs(to, v);
        vector < pii > dx, dy;
        fact(x, dx);
        fact(y, dy);
        int u = pr[to];
        for(auto &[val, kol] : dy)
        {
            sum[to] = (sum[to] * fast_pow(val, max(0LL, kol - cnt[u][val]))) % INF;
            comp[to] = (comp[to] * fast_pow(val, max(0LL, kol - cnt[u][val]))) % INF;
            cnt[u][val] = max(0LL, cnt[u][val] - kol);
        }
        for(auto &[val, kol] : dx)
            cnt[u][val] += kol;
        comp[to] = (((comp[to] * x) % INF) * fast_pow(y, INF - 2)) % INF;
        if(pr[v] == v || sz(cnt[u]) > sz(cnt[pr[v]]))
        {
            pr[v] = u;
            comp[v] = comp[to];
        }
    }
    int u = pr[v];
    for(auto &[to, x, y] : edge[v])
    {
        if(to == p || pr[to] == u)
            continue;
        for(auto i : cnt[pr[to]])
        {
            int val = i.fi;
            int kol = i.se;
            if(kol <= cnt[u][val])
                continue;
            comp[v] = (comp[v] * fast_pow(val, kol - cnt[u][val])) % INF;
            cnt[u][val] = kol;
        }
    }
    sum[v] = comp[v];
    for(auto &[to, x, y] : edge[v])
    {
        if(to == p)
            continue;
        sum[v] = (sum[v] + ((((sum[to] * comp[v]) % INF) * fast_pow(comp[to], INF - 2)) % INF)) % INF;
    }
    return sum[v];
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for(int i = 2; i <= 200000; i++)
    {
        if(r[i])
            continue;
        r[i] = i;
        for(int j = i * i; j <= 200000; j += i)
            if(!r[j])
                r[j] = i;
    }
    int T;
    cin >> T;
    while(T--)
    {
        int n;
        cin >> n;
        for(int i = 0; i < n; i++)
            edge[i].clear();
        for(int i = 0; i < n - 1; i++)
        {
            int v, u, x, y;
            cin >> v >> u >> x >> y;
            v--;
            u--;
            int gcd = __gcd(x, y);
            x /= gcd;
            y /= gcd;
            edge[v].p_b({u, x, y});
            edge[u].p_b({v, y, x});
        }
        cout << dfs() << '\n';
    }
    return 0;
}

