#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <random>
#include <vector>
#include <queue>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,mmx,abm,popcnt,tune=native")

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll cst = 3e5 + 5;
const ll inf = (ll)1e18 + 228;
const ll mod = 998244353;

void operator delete(void*);

ll pw(ll a, ll b) {
	if (b == 0) return 1;
	ll rt = pw(a, b / 2);
	rt = (rt * rt) % mod;
	if (b & 1) rt = (rt * a) % mod;
	return rt;
}

vector<pair<ll, pair<ll, ll>>> g[cst];

ll dp[cst];

ll ps[cst];
ll ms[cst];

vector<ll> primes;

ll er[cst];
ll rev[cst];

void appl(ll q, ll sg) {
	while (q > 1) {
		ll x = er[q];
		ps[x] += sg;
		ms[x] = max(ms[x], ps[x]);
		q /= x;
	}
}

void dfs(ll v, ll pr = -1) {
	dp[v] = 1;
	for (auto i : g[v]) {
		ll u = i.first; // av / au == x / y
		ll x = i.second.first;
		ll y = i.second.second;
		if (u == pr) continue;
		appl(x, -1);
		appl(y, 1);
		dfs(u, v);
		dp[v] = (dp[v] + ((dp[u] * x) % mod) * rev[y]) % mod;
		appl(y, -1);
		appl(x, 1);
	}
}

inline void solve() {
	ll n;
	cin >> n;
	for (ll i = 1; i <= n; i++) {
		g[i].clear();
		dp[i] = 0;
		ms[i] = 0;
	}
	for(ll i = 1; i < n; i++){
		ll a, b, x, y;
		cin >> a >> b >> x >> y;
		swap(x, y);
		g[a].push_back({ b, {x, y} });
		g[b].push_back({ a, {y, x} });
	}
	dfs(1);
	ll answ = dp[1];
	for (ll i = 2; i <= n; i++) {
		answ = answ * pw(i, ms[i]) % mod;
	}
	cout << answ;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	for (ll i = 2; i < cst; i++) {
		if (er[i] == 0) {
			er[i] = i;
			primes.push_back(i);
			for (ll j = i * i; j < cst; j += i) {
				if (er[j] == 0) er[j] = i;
			}
		}
	}
	for (ll i = 1; i < cst; i++) rev[i] = pw(i, mod - 2);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	return 0;
}