#include<iostream>
#include<vector>
#include<stack>
#include<deque>
#include<iomanip>
#include<algorithm>
#include<set>
#include<map>
#include<string>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b)
{
	if (a == 0)
		return b;
	while (b != 0)
	{
		ll t = a % b;
		a = b;
		b = t;
	}
	return a;
}

ll mod = 998244353;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return (bin_pow(a, step - 1) * a)%mod;
	ll now = bin_pow(a, step / 2);
	return (now * now)%mod;
}


map<ll, ll>a, b;

void dfs(ll start, vector<vector<pair<ll, pair<ll, ll>>>> &go, vector<ll>&used)
{
	used[start] = 1;
	for (auto &i : go[start])
	{
		if (used[i.first] == 0)
		{
			set<ll>changed;
			auto p = i.second;
			ll l = 2;
			while (l * l <= i.second.first)
			{
				if (p.first % l == 0)
				{
					p.first /= l;
					changed.insert(l);
					a[l]++;
				}
				else
					l++;
			}
			if (p.first != 1)
			{
				a[p.first]++;
				changed.insert(p.first);
			}
			l = 2;
			while (l * l <= i.second.second)
			{
				if (p.second % l == 0)
				{
					p.second /= l;
					changed.insert(l);
					a[l]--;
				}
				else
					l++;
			}
			if (p.second != 1)
			{
				a[p.second]--;
				changed.insert(p.second);
			}
			for (auto i : changed)
				b[i] = max(b[i], a[i]);
			dfs(i.first, go, used);
			p = i.second;
			l = 2;
			while (l * l <= i.second.first)
			{
				if (p.first % l == 0)
				{
					p.first /= l;
					changed.insert(l);
					a[l]--;
				}
				else
					l++;
			}
			if (p.first != 1)
			{
				a[p.first]--;
				changed.insert(p.first);
			}
			l = 2;
			while (l * l <= i.second.second)
			{
				if (p.second % l == 0)
				{
					p.second /= l;
					changed.insert(l);
					a[l]++;
				}
				else
					l++;
			}
			if (p.second != 1)
			{
				a[p.second]++;
				changed.insert(p.second);
			}
		}
	}
}

ll ans = 0;

void dfs1(ll start, ll st, vector<vector<pair<ll, pair<ll, ll>>>>& go, vector<ll>& used)
{
	used[start] = 1;
	ans += st;
	ans %= mod;
	for (auto& i : go[start])
	{
		if (used[i.first] == 0)
		{
			ll st1 = st;
			st1 *= i.second.second;
			st1 %= mod;
			st1 *= bin_pow(i.second.first, mod - 2);
			st1 %= mod;
			dfs1(i.first, st1, go, used);
		}
	}
}

void solveD()
{
	ll t;
	cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector<vector<pair<ll, pair<ll, ll>>>>go(n);
		vector<ll>used(n);
		for (ll i = 0; i < n - 1; i++)
		{
			ll q, w, e, r;
			cin >> q >> w >> e >> r;
			q--;
			w--;
			go[q].push_back({ w, {e, r} });
			go[w].push_back({ q, {r, e} });
		}
		dfs(0, go, used);
		ll st = 1;
		for (auto& i : b)
		{
			st *= bin_pow(i.first, i.second);
			st %= mod;
		}
		vector<ll>used1(n);
		dfs1(0, st, go, used1);
		cout << ans << "\n";
		a.clear();
		b.clear();
		ans = 0;
	}
}
	

int main() {
	solveD();
}