#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int mod = 998244353, NMAX = 2e5 + 1;

//vx = uy

ll bin_pow(ll a, ll n){
    ll res = 1;
    for(; n; n >>= 1, a *= a, a %= mod) if(n & 1) res *= a, res %= mod;
    return res;
}

vector<ll>powers, cur, inv(NMAX, 1), ss(NMAX);
vector<pii>sieve[NMAX];

struct rel{
    int u, x, y;
};

ll tot = 1, sum = 0;

void dfs(int v, const vector<vector<rel>> &g, int p = -1, int x = 1, int y = 1){
    //cout << v << ' ' <<  x << ' ' << y << '\n';
    for(auto [q, cnt]: sieve[x]){
        cur[q] += cnt;
    }
    for(auto [q, cnt]: sieve[y]){
        if(v == 2){
           //cout << y << ' ' << q << ' ' << cnt << '\n';
        }
        if(cur[q] < cnt){
            powers[q] += cnt - cur[q];
        }
        cur[q] = max(0LL, cur[q] - cnt);
    }
    //cout << powers[2] << ' ' << powers[7] << '\n';
    for(auto [u, vx, uy]: g[v]){
        if(u != p){
            dfs(u, g, v, vx, uy);
        }
    }
    for(auto [q, cnt]: sieve[x]){
        cur[q] -= cnt;
    }
    for(auto [q, cnt]: sieve[y]){
        cur[q] += cnt;
    }
}

void trav(int v, const vector<vector<rel>> &g, int p = -1, int x = 1, int y = 1){
    tot *= x;
    tot %= mod;
    //cout << v << ' ' << tot << '\n';
    tot *= inv[y];
    tot %= mod;
    //cout << y << ' ' << tot << '\n';
    sum += tot;
    sum %= mod;
    for(auto [u, vx, uy]: g[v]){
        if(u != p){
            trav(u, g, v, vx, uy);
        }
    }
    tot *= y;
    tot %= mod;
    tot *= inv[x];
    tot %= mod;
}

void solve(){
    int n, pivot = 1;
    cin >> n;
    powers.assign(n + 1, 0);
    cur.assign(n + 1, 0);
    tot = 1;
    sum = 0;
    vector<vector<rel>>g(n + 1);
    for(int i = 1; i < n; i++){
        int v, u, x, y;
        cin >> v >> u >> x >> y;
        int gg = gcd(x, y);
        x /= gg;
        y /= gg;
        g[v].push_back({u, y, x});
        g[u].push_back({v, x, y});
    }
    //ll aaa = 1;
    dfs(pivot, g);
    for(int i = 2; i <= n; i++){
        tot *= bin_pow(i, powers[i]);
        tot %= mod;
        /*if(powers[i]){
            cout << i << ' ' << powers[i] << '\n';
        }*/
        /*for(int j = 0; j < powers[i]; j++){
            aaa *= j;
        }*/
        //cout << tot << '\n';
    }
    //cout << tot << ' ';
    trav(pivot, g);
    cout << sum << '\n';
}

int main(){
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for(int i = 2; i < NMAX; i++){
        inv[i] = bin_pow(i, mod - 2);
        if(ss[i] == 0){
            for(int j = i; j < NMAX; j += i){
                ss[j] = i;
            }
        }
        int cpy = i;
        while(cpy > 1){
            if(sieve[i].empty() || sieve[i].back().f != ss[cpy]){
                sieve[i].push_back({ss[cpy], 0});
            }
            sieve[i].back().s++;
            cpy /= ss[cpy];
        }
    }
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}