﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#include <random>
#include <cassert>

using namespace std;

#define int long long
#define double long double
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int N = 2e5 + 228;

const int al = 'z' - 'a' + 1;

int add(int x, int y) {
    x += y;
    if (x >= MOD) x -= MOD;
    return x;
}

int mult(int x, int y) {
    return (x * y) % MOD;
}

int binPow(int a, int p) {
    if (p == 0) return 1;
    if (p & 1) {
        return mult(binPow(a, p - 1), a);
    }
    else {
        return binPow(mult(a, a), p >> 1);
    }
}

int rev(int a) {
    return binPow(a, MOD - 2);
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int dp[N];
vi pr;

map<int, int> nok;
vector<vector<pair<int, pi>>> g;
pair<map<int, int>, map<int, int>> r;

void addUp(int d) {
    while (d > 1) {
        int d1 = dp[d];
        if (r.second.find(d1) != r.second.end()) {
            r.second[d1]--;
            if (r.second[d1] == 0) r.second.erase(d1);
        }
        else {
            r.first[d1]++;
        }
        d /= d1;
    }
}

void addDown(int d) {
    while (d > 1) {
        int d1 = dp[d];
        if (r.first.find(d1) != r.first.end()) {
            r.first[d1]--;
            if (r.first[d1] == 0) r.first.erase(d1);
        }
        else {
            r.second[d1]++;
            nok[d1] = max(nok[d1], r.second[d1]);
        }
        d /= d1;
    }
}

int s;

void dfs(int v, int p) {
    for (int i = 0; i < sz(g[v]); ++i) {
        int u = g[v][i].first;
        if (u == p) continue;
        int dv = g[v][i].second.first;
        int du = g[v][i].second.second;
        addUp(du);
        addDown(dv);
        dfs(u, v);
        addUp(dv);
        addDown(du);
    }
}

void dfs2(int v, int p, int cnow) {
    s = add(s, cnow);
    for (int i = 0; i < sz(g[v]); ++i) {
        int u = g[v][i].first;
        if (u == p) continue;
        int dv = g[v][i].second.first;
        int du = g[v][i].second.second;
        dfs2(u, v, mult(mult(cnow, du), rev(dv)));
    }
}

void solve() {
    g.clear();
    int n;
    cin >> n;
    g.resize(n);
    vector<pair<pi, pi>> req(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> req[i].first.first >> req[i].first.second >> req[i].second.first >> req[i].second.second;
        --req[i].first.first;
        --req[i].first.second;
        g[req[i].first.first].push_back(make_pair(req[i].first.second, req[i].second));
        g[req[i].first.second].push_back(make_pair(req[i].first.first, make_pair(req[i].second.second, req[i].second.first)));
    }
    r.first.clear();
    r.second.clear();
    nok.clear();
    dfs(0, 0);
    int cnow = 1;
    for (auto [k, cnt] : nok) {
        for (int i = 0; i < cnt; ++i) {
            cnow = mult(cnow, k);
        }
    }
    s = 0;
    dfs2(0, 0, cnow);
    cerr << "!!";
    cout << s << "\n";
}

signed  main(){
    for (int i = 2; i < N; ++i) {
        if (dp[i] == 0) {
            pr.push_back(i);
            dp[i] = i;
        }
        for (int j = 0; j < sz(pr) && i * pr[j] < N && pr[j] <= dp[i]; ++j) {
            dp[i * pr[j]] = pr[j];
        }
    }
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
