#include<algorithm>
#include<iostream>
#include<vector>
#include<string>
#include<unordered_map>

using namespace std;

constexpr int MOD = 998244353;

int powMOD(int a, int b) {
	if (b == 1) {
		return a;
	}
	else if (b % 2 == 0) {
		int t = powMOD(a, b / 2);
		return 1LL * t * t % MOD;
	}
	else {
		return 1LL * a * powMOD(a, b - 1) % MOD;
	}
}

void add(int a, unordered_map<int, int>& ans, unordered_map<int, int>& cur) {
	int val;
	for (int t = 2; 1LL * t *t <= a; ++t) {
		while (a % t == 0) {
			val = ++cur[t];
			auto it = ans.find(t);
			if (it != ans.end())
				it->second = max(it->second, val);
			else
				ans[t] = val;
			a /= t;
		}
	}
	if (a > 1) {
		val = ++cur[a];
		auto it = ans.find(a);
		if (it != ans.end())
			it->second = max(it->second, val);
		else
			ans[a] = val;
	}
}

void dec(int a, unordered_map<int, int>& cur) {
	for (int t = 2; 1LL * t *t <= a; ++t) {
		while (a % t == 0) {
			--cur[t];
			a /= t;
		}
	}
	if (a > 1) {
		--cur[a];
	}
}

void dfs(int curr, const vector<vector<pair<int, pair<int, int>>>>& gr, unordered_map<int, int>& ans, unordered_map<int, int>& cur, int par = -1) {
	for (const auto& nxt : gr[curr]) {
		if (nxt.first != par) {
			dec(nxt.second.first, cur);
			add(nxt.second.second, ans, cur);

			dfs(nxt.first, gr, ans, cur, curr);

			//add(nxt.second.first, ans, cur);
			dec(nxt.second.second, cur);
			add(nxt.second.first, ans, cur);
		}
	}
}

void cnt(int curr, const vector<vector<pair<int, pair<int, int>>>>& gr, int cur, int& sum, int par = -1) {
	sum += cur;
	if (sum > MOD) { sum -= MOD; }

	for (const auto nxt : gr[curr]) {
		if (nxt.first != par) {
			int nn = cur;
			nn = 1LL * nn * nxt.second.first % MOD;
			nn = 1LL * nn * powMOD(nxt.second.second, MOD - 2) % MOD;
			cnt(nxt.first, gr, nn, sum, curr);
		}
	}
}

void solve() {
	int n; cin >> n; 
	vector<vector<pair<int, pair<int, int>>>> gr(n);
	vector<int> in(n, 0);
	for (int i = 0; i < n - 1; ++i) {
		int i1, j1, x, y; cin >> i1 >> j1 >> x >> y; --i1; --j1;
		gr[j1].push_back({ i1,{ x, y } });
		gr[i1].push_back({ j1,{ y, x } });
	}

	//int root = find(in.begin(), in.end(), 0) - in.begin();

	unordered_map<int, int> ans;
	unordered_map<int, int> curr;
	dfs(0, gr, ans, curr);

	int res = 1;

	for (auto cur : ans) {
		if (cur.second >= 1) {
			res = 1LL * res * powMOD(cur.first, cur.second) % MOD;
		}
	}

	int sum = 0;
	cnt(0, gr, res, sum);

	cout << sum << "\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int ttt; cin >> ttt;
	while (ttt > 0) {
		solve(); --ttt;
	}
	return 0;
}