#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define dbl long double
#define db double
#define nl '\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define left v*2+1
#define right v*2+2

#define int long long

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, 
null_type, 
less<int>, 
rb_tree_tag, 
tree_order_statistics_node_update,
allocator<int>> 
ordered_set;

struct segtree{
	struct Node{
		int sum, max, min, added;
	};

	int size;
	vector<Node> tree;

	void init(vector<int> &a){
		size = a.size();
		tree.resize(4*size);
		build(0, 0, size, a);
	}

	void build(int v, int lx, int rx, vector<int> &a){
		if(rx - lx == 1){
			tree[v].sum = a[lx];
			tree[v].max = a[lx];
			tree[v].min = a[lx];
			return;
		}
		int m = (lx + rx) / 2;
		build(v * 2 + 1, lx, m, a);
		build(v * 2 + 2, m, rx, a);
		tree[v].sum = tree[left].sum + tree[right].sum;
		tree[v].max = max(tree[left].max, tree[right].max);
		tree[v].min = min(tree[left].min, tree[right].min);
	}

	int get_min(int v, int lx, int rx, int l, int r){
		if(rx <= r && lx >= l){
			return tree[v].min;
		}
		if(rx <= l || lx >= r) return 2000000000;
		int m = (lx + rx) / 2;
		return min(get_min(left, lx, m, l, r), get_min(right, m, rx, l, r));
	}

	int get_min(int l, int r){
		return get_min(0, 0, size, l, r);
	}

	int get_max(int v, int lx, int rx, int l, int r){
		if(rx <= r && lx >= l){
			return tree[v].min;
		}
		if(rx <= l || lx >= r) return -2000000000;
		int m = (lx + rx) / 2;
		return max(get_max(left, lx, m, l, r), get_max(right, m, rx, l, r));
	}

	int get_max(int l, int r){
		return get_max(0, 0, size, l, r);
	}

	int get_sum(int v, int lx, int rx, int l, int r){
		if(rx <= r && lx >= l){
			return tree[v].sum;
		}
		if(rx <= l || lx >= r) return 0;
		int m = (lx + rx) / 2;
		return (get_sum(left, lx, m, l, r) + get_sum(right, m, rx, l, r));
	}

	int get_sum(int l, int r){
		return get_sum(0, 0, size, l, r);
	}
};

int mod;

int fact[200000];
int min_divisor[2000000];

int bin_pow(int a, int b){
	if(b == 0) return 1;
	if(b % 2) return bin_pow(a * a % mod, b / 2) * a % mod;
	return bin_pow(a * a % mod, b / 2);
}

int C(int n, int k){
	return fact[n] * (bin_pow((fact[k] * fact[n-k])%mod, mod-2));
}

void erat(){
	for(int i = 2; i <= 2000000; ++i){
		if(min_divisor[i] == 0){
			min_divisor[i] = i;
			for(int j = i * i; j <= 2000000; j += i){
				if(min_divisor[j] == 0) min_divisor[j] = i;
			}
		}
	}
}



void solve(){
	int n;
	cin >> n;
	vector<int> a(n);
	for(int i = 0; i < n; ++i){
		cin >> a[i];
	}
	sort(all(a));
	cout << a[n-1] + a[n-2] << nl;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	/*erat();
	fact[0] = 1;
	for(int i = 1; i < 200000; ++i){
		fact[i] = (fact[i-1] * i) % mod;
	}*/
    int t = 1;
	cin >> t;
	while(t--){
		solve();
	}
}