#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define dbl long double
#define db double
#define nl '\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define left v*2+1
#define right v*2+2

//#define int long long

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, 
null_type, 
less<int>, 
rb_tree_tag, 
tree_order_statistics_node_update,
allocator<int>> 
ordered_set;

struct segtree{
	struct Node{
		int sum, max, min, added;
	};

	int size;
	vector<Node> tree;

	void init(vector<int> &a){
		size = a.size();
		tree.resize(4*size);
		build(0, 0, size, a);
	}

	void build(int v, int lx, int rx, vector<int> &a){
		if(rx - lx == 1){
			tree[v].sum = a[lx];
			tree[v].max = a[lx];
			tree[v].min = a[lx];
			return;
		}
		int m = (lx + rx) / 2;
		build(v * 2 + 1, lx, m, a);
		build(v * 2 + 2, m, rx, a);
		tree[v].sum = tree[left].sum + tree[right].sum;
		tree[v].max = max(tree[left].max, tree[right].max);
		tree[v].min = min(tree[left].min, tree[right].min);
	}

	int get_min(int v, int lx, int rx, int l, int r){
		if(rx <= r && lx >= l){
			return tree[v].min;
		}
		if(rx <= l || lx >= r) return 2000000000;
		int m = (lx + rx) / 2;
		return min(get_min(left, lx, m, l, r), get_min(right, m, rx, l, r));
	}

	int get_min(int l, int r){
		return get_min(0, 0, size, l, r);
	}

	int get_max(int v, int lx, int rx, int l, int r){
		if(rx <= r && lx >= l){
			return tree[v].min;
		}
		if(rx <= l || lx >= r) return -2000000000;
		int m = (lx + rx) / 2;
		return max(get_max(left, lx, m, l, r), get_max(right, m, rx, l, r));
	}

	int get_max(int l, int r){
		return get_max(0, 0, size, l, r);
	}

	int get_sum(int v, int lx, int rx, int l, int r){
		if(rx <= r && lx >= l){
			return tree[v].sum;
		}
		if(rx <= l || lx >= r) return 0;
		int m = (lx + rx) / 2;
		return (get_sum(left, lx, m, l, r) + get_sum(right, m, rx, l, r));
	}

	int get_sum(int l, int r){
		return get_sum(0, 0, size, l, r);
	}
};

ll mod = 998244353;

//int fact[200000];
int min_divisor[200000];

ll bin_pow(ll a, __int32 b){
	if(b == 0) return 1;
	if(b % 2) return bin_pow(a * a % mod, b / 2) * a % mod;
	return bin_pow(a * a % mod, b / 2);
}

int C(int n, int k){
	return 0;
	//return fact[n] * (bin_pow((fact[k] * fact[n-k])%mod, mod-2));
}

ll back_a(ll a){
	return bin_pow(a, mod-2);
}

void erat(){
	for(int i = 2; i <= 200000; ++i){
		if(min_divisor[i] == 0){
			min_divisor[i] = i;
			for(int j = i * i; j <= 200000; j += i){
				if(min_divisor[j] == 0) min_divisor[j] = i;
			}
		}
	}
}

vector<pair<__int32, pair<__int32, __int32>>> paths[200001];

int lca(int a, int b){
	return a / __gcd(a, b) * b;
}

gp_hash_table<int, int> re;
bool was[200001];

void dfs(int v, gp_hash_table<__int32, __int32> &now, gp_hash_table<__int32, __int32> &how_many){
	for(auto t : paths[v]){
		int j = t.first;
		int x = t.second.first;
		int y = t.second.second;
		gp_hash_table<int, int> f1, f2, f3;
		while(x != 1){
			f1[min_divisor[x]]++;
			x /= min_divisor[x];
		}
		while(y != 1){
			f2[min_divisor[y]]++;
			y /= min_divisor[y];
		}

		bool f = false;
		for(auto k : f1){
			for(int i = 0; i < k.second; ++i){
				if(now[k.first] == 0){
					how_many[k.first]++;
					f3[k.first]++;
					re[k.first] = max(re[k.first], how_many[k.first]);
				}
				else{
					now[k.first]--;
				}
			}
		}

		if(!was[j]){
			was[j] = true;
			for(auto k : f2){
				now[k.first] += k.second;
			}
			dfs(j, now, how_many);
			for(auto k : f2){
				now[k.first] -= k.second;
			}
		}
		for(auto k : f1){
			for(int i = 0; i < k.second; ++i){
				if(f3[k.first] > 0){
					f3[k.first]--;
					how_many[k.first]--;
				}
				else{
					now[k.first]++;
				}
			}
		}
	}
}

void dfs1(int v, ll now, ll &ans){
	for(auto t : paths[v]){
		int j = t.first;
		ll x = t.second.first, y = t.second.second;
		if(!was[j]){
			int k = now * y % mod * back_a(x) % mod;
			ans += k;
			ans %= mod;
			was[j] = true;
			dfs1(j, k, ans);
		}
	}
}

void solve(){
	int n;
	cin >> n;
	re.clear();
	for(int i = 1; i <= n; ++i){
		paths[i].clear();
		was[i] = false;
	}
	for(int i1 = 0; i1 < n - 1; ++i1){
		int i, j, x, y;
		cin >> i >> j >> x >> y;
		if(i > j){
			swap(i, j);
			swap(x, y);
		}
		int t = __gcd(x, y);
		x /= t;
		y /= t;

		paths[i].push_back({j, {x, y}});
		paths[j].push_back({i, {y, x}});
	}
	gp_hash_table<int, int> now, how_many;

	was[1] = true;
	dfs(1, now, how_many);

	ll ans = 0;

	ll now1 = 1;
	fill(was, was + n + 1, false);
	for(auto t : re){
		now1 *= bin_pow(t.first, t.second);
		now1 %= mod;
	}
	ans = now1;
	was[1] = true;
	dfs1(1, now1, ans);

	cout << ans << nl;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	erat();
	/*fact[0] = 1;
	for(int i = 1; i < 200000; ++i){
		fact[i] = (fact[i-1] * i) % mod;
	}*/
    int t = 1;
	cin >> t;
	while(t--){
		solve();
	}
}