#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define reverse_all(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


class FenwickTree {
	vector < int > sm;

public:
	FenwickTree(int sz) {
		sm.resize(sz + 1, 0);
	}

	void change(int x, int add) {
		for (int i = x + 1; i < sm.size(); i += i & -i)
			sm[i] += add;
	}

	int prefix_sum(int x) {
		int res = 0;
		for (int i = x + 1; i > 0; i -= i & -i)
			res += sm[i];
		return res;
	}

	int sum(int i, int j) {
		return prefix_sum(j) - prefix_sum(i - 1);
	}
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int t;
	cin >> t;

	for (; t; t--) {
		int n;
		cin >> n;

		vector < int > a(n);
		for (int& el : a)
			cin >> el;

		vector < int > pmx = a, smx = a;
		for (int i = 1; i < n; i++) {
			pmx[i] = max(pmx[i], pmx[i - 1]);
		}
		for (int i = n - 2; i >= 0; i--) {
			smx[i] = max(smx[i], smx[i + 1]);
		}

		int res = 0;
		for (int i = 0; i < n - 1; i++)
			res = max(res, max(a[i] + smx[i + 1], pmx[i] + a[i + 1]));

		cout << res << "\n";
	}

	return 0;
}