#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define reverse_all(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


class FenwickTree {
	vector < int > sm;

public:
	FenwickTree(int sz) {
		sm.resize(sz + 1, 0);
	}

	void change(int x, int add) {
		for (int i = x + 1; i < sm.size(); i += i & -i)
			sm[i] += add;
	}

	int prefix_sum(int x) {
		int res = 0;
		for (int i = x + 1; i > 0; i -= i & -i)
			res += sm[i];
		return res;
	}

	int sum(int i, int j) {
		return prefix_sum(j) - prefix_sum(i - 1);
	}
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int t;
	cin >> t;

	for (; t; t--) {
		string s;
		cin >> s;

		vector < int > cnt(26, 0);
		for (char c : s)
			cnt[c - 'a']++;

		string res = s;
		reverse(all(res));
		for (char c : s) {
			if (cnt[c - 'a'] > 1) {
				cnt[c - 'a']--;
				res.pop_back();
			}
			else
				break;
		}
		reverse(all(res));
		
		cout << res << "\n";
	}

	return 0;
}