#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define reverse_all(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


const int C = 317;


class FenwickTree {
	vector < int > sm;

public:
	FenwickTree(int sz) {
		sm.resize(sz + 1, 0);
	}

	void change(int x, int add) {
		for (int i = x + 1; i < sm.size(); i += i & -i)
			sm[i] += add;
	}

	int prefix_sum(int x) {
		int res = 0;
		for (int i = x + 1; i > 0; i -= i & -i)
			res += sm[i];
		return res;
	}

	int sum(int i, int j) {
		return prefix_sum(j) - prefix_sum(i - 1);
	}
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	vector < int > a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	int res = n;
	for (int d = -C; d <= C; d++) {
		if (d == 0)
			continue;

		vector < int > cur(n);
		for (int i = 0; i < n; i++)
			cur[i] = a[i] - i * d;
		sort(all(cur));

		int ln = 0;
		for (int i = 0; i < n; i++) {
			ln++;
			if (i == n - 1 || cur[i] != cur[i + 1]) {
				res = min(res, n - ln);
				ln = 0;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		vector < int > cur;
		for (int j = i + 1; j < min(i + C, n); j++) {
			if (abs(a[j] - a[i]) % (j - i) == 0)
				cur.push_back((a[j] - a[i]) / (j - i));
		}
		sort(all(cur));

		int ln = 0;
		for (int j = 0; j < cur.size(); j++) {
			ln++;
			if (j == cur.size() - 1 || cur[j] != cur[j + 1]) {
				res = min(res, n - ln - 1);
				ln = 0;
			}
		}
	}

	cout << res << "\n";

	return 0;
}