#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <sstream>
#include <assert.h>
#include <random>
#include <iomanip>
#include <algorithm>


using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);
#define show(a) do {cerr << #a << ": " << a << "\n";} while(0);

mt19937_64 rnd(1231);
const int MAXINT = 1e9 + 12;
const ll MAXLL = (ll)1e18 + 21;

namespace segtree {
	const int MAXN = 262144;
	struct v {
		int x;
	};

	int arr[MAXN];
	int t[2 * MAXN - 1];

	void recalc(int i) {

	}
	void push(int i) {

	}
	
	void build(int i = 0, int l = 0, int r = MAXN) {
		if (r - l == 1) {
			// init!
		}
		else {
			int m = (r + l) / 2;
			build(2 * i + 1, l, m);
			build(2 * i + 2, m, r);
			recalc(i);
		}
	}

	void massUpd(int L, int R, int X = 0, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (max(l, L) >= min(r, R))
			return;
		if (L <= l && r <= R) {

			push(i);
			return;
		}
		int m = (r + l) / 2;
		massUpd(L, R, X, 2 * i + 1, l, m);
		massUpd(L, R, X, 2 * i + 2, m, r);
		recalc(i);
	}

	int get(int L, int R, int X = 0, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (max(l, L) >= min(r, R)) {
			return 0; // neutral!
		}
		if (L <= l && r <= R) {
			return 1; // t[i]
		}
		int m = (r + l) / 2;
		int a1 = get(L, R, X, 2 * i + 1, l, m);
		int a2 = get(L, R, X, 2 * i + 2, m, r);
		return a1 + a2; // or smthg else
	}
}
namespace sparce {
	const int K = 30;
	const int MAXN = 1e5;

	int table[K][MAXN];
	int logs[MAXN];
	void init() {
		for (int i = 2; i < MAXN; i++) {
			logs[i] = logs[i / 2] + 1;
		}
	}
	void initSparce() {
		for (int j = 1; j < K; j++) {
			int p = (1<<(j - 1));
			for (int i = 0; i + p < MAXN; i++) {
				table[j][i] = max(table[j - 1][i], table[j - 1][i + p]);
			}
		}
	}

	int get(int l, int r) {
		int sz = r - l;
		int lg = logs[sz];
		return max(table[lg][l], table[lg][r - (1<<lg)]);
	}
}
namespace myHash {
	const int MAXN = 1e5;
	const ll M = 1e9 + 9;
	const ll P = 59;
	struct hasher {
		ll hashes[MAXN];
		ll pows[MAXN];
		hasher(string& s) {
			hashes[0] = s[0];
			for (int i = 1; i < s.length(); i++) {
				hashes[i] = (hashes[i - 1] * P + s[i]) % M;
			}
			pows[0] = 1;
			for (int i = 1; i < s.length(); i++) {
				pows[i] = (pows[i - 1] * P) % M;
			}
		}
		ll get(int l, int r) {
			if (l == 0)
				return hashes[r - 1];
			ll toRem = (hashes[l - 1] * pows[r - l]) % M;
			return (hashes[r - 1] + M - toRem) % M;
		}
	};
}

const ll MOD = 998244353;

ll fastPow(ll a, ll p) {
	if (p == 0)
		return 1;
	if (p == 1)
		return a;
	if (p == 2)
		return (a * a) % MOD;
	if ((p & 1) == 0)
		return fastPow(fastPow(a, p >> 1), 2);
	return (a * fastPow(a, p - 1)) % MOD;
}

const int MAXN = 2e5;
int isNotPrimes[MAXN + 1];
int primeId[MAXN + 1];
int obr[MAXN + 1];
int primes[18000];


struct edge {
	int other;
	ll x;
	ll y;
};
vector<vector<edge>> graph;

vector<int> toPrimes(int x) {
	vector<int> ans;
	int p = 2;
	while (p * p <= x) {
		if (x % p == 0) {
			ans.push_back(p);
			x /= p;
		}
		else
			p++;
	}
	if (x != 1)
		ans.push_back(x);
	return ans;
}

int maxPows[18000];
int powsNow[18000];
void dfs(int v, edge toMe, int p = -1) {
	vector<int> add;
	vector<int> rem;
	if (p != -1) {
		add = toPrimes(toMe.y);
		rem = toPrimes(toMe.x);
	}

	for (auto& e : add)
		powsNow[primeId[e]]++;
	for (auto& e : rem)
		powsNow[primeId[e]]--;

/*	cerr << v << ": ";
	for (int i = 0; i < 5; i++) {
		cerr << "{ " << primes[i] << " ^ " << powsNow[i] << " } ";
	}
	cerr << "\n";*/

	for (auto& e : add) {
		int i = primeId[e];
		maxPows[i] = max(maxPows[i], powsNow[i]);
	}
	for (auto& e : rem) {
		int i = primeId[e];
		maxPows[i] = max(maxPows[i], powsNow[i]);
	}

	for (auto& other : graph[v]) {
		if (other.other == p)
			continue;
		dfs(other.other, other, v);
	}

	for (auto& e : add)
		powsNow[primeId[e]]--;
	for (auto& e : rem)
		powsNow[primeId[e]]++;
}

void dfsAns(int v, int p, ll anow, ll& ans) {
	ans = (ans + anow) % MOD;
	for (auto& other : graph[v]) {
		if (other.other == p)
			continue;
		ll toOther = anow;
		toOther = (toOther * other.x) % MOD;
		toOther = (toOther * obr[other.y]) % MOD;
		dfsAns(other.other, v, toOther, ans);
	}
}

void solve() {
	int n;
	cin >> n;
	graph = vector<vector<edge>>(n);
	for (int i = 1; i < n; i++) {
		int a, b, x, y;
		cin >> a >> b >> x >> y;
		a--;
		b--;
		graph[a].push_back(edge({b, y, x}));
		graph[b].push_back(edge({a, x, y}));
	}
	for (int i = 0; i < 18000; i++) {
		maxPows[i] = 0;
		powsNow[i] = 0;
	}
	dfs(0, edge({0, 0, 0}));


	ll minA = 1;
	for (int i = 0; i < 18000; i++) {
		minA = (minA * fastPow(primes[i], maxPows[i])) % MOD;
	}

	ll ans = 0;
	dfsAns(0, -1, minA, ans);
	cout << ans << "\n";
}


int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	// total primes 18000
	for (int i = 2; i <= MAXN; i++) {
		if (isNotPrimes[i] == 0) {
			for (int j = 2 * i; j <= MAXN; j += i) {
				isNotPrimes[j] = 1;
			}
		}
	}
	
	int id = 0;
	for (int i = 2; i <= MAXN; i++) {
		if (isNotPrimes[i] == 0) {
			primes[id] = i;
			primeId[i] = id++;
		}
	}

	for (int i = 0; i <= MAXN; i++) {
		obr[i] = fastPow(i, MOD - 2);
	}

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}