#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <sstream>
#include <assert.h>
#include <random>
#include <iomanip>
#include <algorithm>
#include <unordered_map>
#include <ctime>


using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);
#define show(a) do {cerr << #a << ": " << a << "\n";} while(0);

mt19937_64 rnd(1231);
const int MAXINT = 1e9 + 12;
const ll MAXLL = (ll)1e18 + 21;

namespace segtree {
	const int MAXN = 131072;
	struct v {
		ll max;

		ll toPush = 0;
		bool hasPush = false;
	};

	ll arr[MAXN];
	v t[2 * MAXN - 1];

	void push(int i) {
		if (!t[i].hasPush)
			return;
		if (2 * i + 2 < 2 * MAXN - 2) {
			t[2 * i + 1].toPush += t[i].toPush;
			t[2 * i + 2].toPush += t[i].toPush;
			t[2 * i + 1].hasPush = 1;
			t[2 * i + 2].hasPush = 1;
		}
		t[i].max += t[i].toPush;
		t[i].hasPush = 0;
		t[i].toPush = 0;
	}

	void recalc(int i) {
		push(2 * i + 1);
		push(2 * i + 2);
		t[i].max = max(t[2 * i + 1].max, t[2 * i + 2].max);

	}
	
	void build(int i = 0, int l = 0, int r = MAXN) {
		if (r - l == 1) {
			t[i].max = arr[l];
		}
		else {
			int m = (r + l) / 2;
			build(2 * i + 1, l, m);
			build(2 * i + 2, m, r);
			recalc(i);
		}
	}

	void massUpd(int L, int R, int X, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (max(l, L) >= min(r, R))
			return;
		if (L <= l && r <= R) {
			t[i].toPush += X;
			t[i].hasPush = 1;
			push(i);
			return;
		}
		int m = (r + l) / 2;
		massUpd(L, R, X, 2 * i + 1, l, m);
		massUpd(L, R, X, 2 * i + 2, m, r);
		recalc(i);
	}

	void get(vector<int>& ans, int TO, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (t[i].max < 0) {
			return;
		}
		if (l >= TO)
			return;
		if (r - l == 1) {
			ans.push_back(l);
			return;
		}
		int m = (r + l) / 2;
		get(ans, TO, 2 * i + 1, l, m);
		get(ans, TO, 2 * i + 2, m, r);
	}
	int sologet(int I, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (r <= I || I < l)
			return 0;
		if (r - l == 1)
			return t[i].max;

		int m = (r + l) / 2;
		return sologet(I, 2 * i + 1, l, m) + sologet(I, 2 * i + 2, m, r);

	}
}
namespace sparce {
	const int K = 30;
	const int MAXN = 1e5;

	int table[K][MAXN];
	int logs[MAXN];
	void init() {
		for (int i = 2; i < MAXN; i++) {
			logs[i] = logs[i / 2] + 1;
		}
	}
	void initSparce() {
		for (int j = 1; j < K; j++) {
			int p = (1<<(j - 1));
			for (int i = 0; i + p < MAXN; i++) {
				table[j][i] = max(table[j - 1][i], table[j - 1][i + p]);
			}
		}
	}

	int get(int l, int r) {
		int sz = r - l;
		int lg = logs[sz];
		return max(table[lg][l], table[lg][r - (1<<lg)]);
	}
}
namespace myHash {
	const int MAXN = 1e5;
	const ll M = 1e9 + 9;
	const ll P = 59;
	struct hasher {
		ll hashes[MAXN];
		ll pows[MAXN];
		hasher(string& s) {
			hashes[0] = s[0];
			for (int i = 1; i < s.length(); i++) {
				hashes[i] = (hashes[i - 1] * P + s[i]) % M;
			}
			pows[0] = 1;
			for (int i = 1; i < s.length(); i++) {
				pows[i] = (pows[i - 1] * P) % M;
			}
		}
		ll get(int l, int r) {
			if (l == 0)
				return hashes[r - 1];
			ll toRem = (hashes[l - 1] * pows[r - l]) % M;
			return (hashes[r - 1] + M - toRem) % M;
		}
	};
}

const int K = 1000;

int smallD(vector<int>& arr) {
	int ans = 0;
	auto t1 = clock();
	for (int dnow = -400; dnow <= 400; dnow++) {
		unordered_map<int, int> cnt;
		for (int i = 0; i < arr.size(); i++) {
			cnt[arr[i] - dnow * i]++;
		}
		for (auto& [a, c] : cnt)
			ans = max(ans, c);
		auto t2 = clock();
		if ((t2 - t1) > 1 * CLOCKS_PER_SEC)
			break;
	}
	return ans;
}


int bigD(vector<int>& arr) {
	int ans = 0;
	vector<pair<int, int>> coolPairs;
	auto t1 = clock();
	for (int i = 0; i < arr.size(); i++) {
		segtree::arr[i] = arr[i] - K * i;
	}
	segtree::build();
	for (int i = 0; i < arr.size(); i++) {
		segtree::massUpd(0, arr.size(), -arr[i]);
		vector<int> cool;
		segtree::get(cool, arr.size());
		for (auto& e : cool) {
			int a = i;
			int b = e;
			if (a == b)
				continue;
			if (a > b)
				swap(a, b);
			coolPairs.push_back({a, b});
		}
		if (i + 1 == arr.size())
			break;
		segtree::massUpd(0, arr.size(), +arr[i]);
		segtree::massUpd(0, i + 1, -K);
		segtree::massUpd(i + 1, arr.size(), K);
		auto t2 = clock();
		if (t2 - t1 > (2 * CLOCKS_PER_SEC))
			break;
	}
	t1 = clock();
	for (auto& [a, b] : coolPairs) {
		int d = arr[b] - arr[a];
		if (abs(d) % (b - a) != 0)
			continue;
		d /= (b - a);
		int nowin = 1;
		for (int j = 1; j < arr.size(); j++) {
			if (a + j >= arr.size() && a - j < 0)
				break;
			if (a + j < arr.size() && arr[a + j] == arr[a] + j * d)
				nowin++;
			if (a - j >= 0 && arr[a - j] == arr[a] - j * d)
				nowin++;
		}
		ans = max(ans, nowin);
		auto t2 = clock();
		if (t2 - t1 > (2 * CLOCKS_PER_SEC))
			break;
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector<int> arr(n);
	input(arr);
	int ans = 1;
	ans = max(ans, smallD(arr));
	if (ans < 1e5 / K) {
		ans = max(ans, bigD(arr));
	}
	cout << n - ans << "\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}