#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MOD = 998244353;

int add(int a, int b) {
    if (a + b < MOD) return a + b;
    return a + b - MOD;
}

int sub(int a, int b) {
    if (a - b < 0) return a - b + MOD;
    return a - b;
}

int mul(int a, int b) {
    return ll(a) * b % MOD;
}

vector<vector<tuple<int, int, int>>> g;
vector<int> ca, cb;
vector<int> cm; // b

const int N = 2e5;
int minDel[N + 1];

int gcd(int a, int b) {
    if (a < b) swap(a, b);
    while (b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void add(int a) {
    while (a != 1) {
        int d = minDel[a];
        a /= d;
        if (cb[d] == 0) {
            ++ca[d];
        } else {
            --cb[d];
        }
    }
}

void del(int b) {
    while (b != 1) {
        int d = minDel[b];
        b /= d;
        if (ca[d] == 0) {
            ++cb[d];
            cm[d] = max(cm[d], cb[d]);
        } else {
            --ca[d];
        }
    }
}

void dfs(int v, int p) {
    for (auto &[u, x, y] : g[v]) {
        if (u != p) {
            add(x);
            del(y);
            dfs(u, v);
            add(y);
            del(x);
        }
    }
}

int modpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int res = modpow(a, n / 2);
        return mul(res, res);
    } else {
        return mul(a, modpow(a, n - 1));
    }
}

int inv(int a) {
    return modpow(a, MOD - 2);
}

int ans;

void dfs2(int v, int p, int c) {
    ans = add(ans, c);
    for (auto &[u, x, y] : g[v]) {
        if (u != p) {
            dfs2(u, v, mul(c, mul(x, inv(y))));
        }
    }
}

void solve() {
    int n;
    cin >> n;
    g.clear(), g.resize(n);
    ca.clear(), cb.clear(), cm.clear();
    ca.resize(n + 1, 0), cb.resize(n + 1, 0), cm.resize(n + 1, 0);
    for (int i = 1; i < n; ++i) {
        int a, b, x, y;
        cin >> a >> b >> x >> y;
        --a, --b;
        int gg = gcd(x, y);
        x /= gg, y /= gg;
        g[a].emplace_back(b, y, x);
        g[b].emplace_back(a, x, y);
    }

    dfs(0, 0);
    int one = 1;
    for (int i = 1; i <= n; ++i) {
        one = mul(one, modpow(i, cm[i]));
    }
    ans = 0;
    dfs2(0, 0, one);
    cout << ans << en;
}

int32_t main() {
    io();

    for (int i = 2; i <= N; ++i) {
        for (int j = i; j <= N; j += i) {
            if (minDel[j] == 0) minDel[j] = i;
        }
    }

#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}