#include<bits/stdc++.h>

using namespace std;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(const string& s) {
    return '"' + s + '"';
}

string to_string(const char& c) {
    string res = "'";
    res += c;
    return res + "'";
}

string to_string(bool b) {
    return (b ? "true" : "false");
}

template<typename A>
string to_string(A a) {
    string res = "{";
    int f = 0;
    for (const auto& x : a) {
        if (f) {
            res += ", ";
        }
        f = 1;
        res += to_string(x);
    }
    return res + "}";
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "{" + to_string(p.first) + ", " + to_string(p.second) + "}";
}

void debug_out() { cerr << endl; }

template<typename Head, typename... Tail>
void debug_out(Head h, Tail... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << ":] ", debug_out(__VA_ARGS__)
//#define int long long
#define pii pair<int, int>
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int) (x).size()
#define ld long double
#define pb push_back
#define forn(i, n) for (int i = 0; i < n; i++)

const int N = 2e5;
vector<int> g[N], st;
set<pii> tmp;
int a[N], n, dist[N], dp[N];
map<int, int> answer[N];

void dfs(int v, int k) {
    if (answer[v].find(k) != answer[v].end()) {
        return;
    }
    answer[v][k] = 0;
    for (auto u : g[v]) {
        if (dist[u] + 1 == dist[v]) {
            dfs(u, k + 1);
            answer[v][k] = max(answer[v][k], answer[u][k + 1] + 1);
        }
        if (dist[u] == dist[v] && k) {
            dfs(u, k - 1);
            answer[v][k] = max(answer[v][k], answer[u][k - 1] + 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    fill(dist, dist + n, n + 1);
    fill(dp, dp + n, n + 1);
    forn (i, n) {
        cin >> a[i];
        if (a[i]) {
            dist[i] = 0;
            st.pb(i);
        }
    }
    forn (i, n - 1) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    forn (i, sz(st)) {
        int v = st[i];
        for (auto u : g[v]) {
            if (dist[u] > dist[v]) {
                dist[u] = dist[v] + 1;
                st.pb(u);
            }
        }
    }
    if (n <= 200) {
        forn (i, n) dfs(i, 0);
        forn (i, n) cout << answer[i][0] << " ";
        return 0;
    }
    forn (v, n) {
        for (auto u : g[v]) {
            if (dist[u] == dist[v]) {
                dp[v] = dist[v];
            }
        }
        if (dp[v] != n + 1) {
            tmp.insert({dp[v], v});
        }
    }
    while (sz(tmp)) {
        auto el = *tmp.begin();
        tmp.erase(el);
        int v = el.se, c = el.fi;
        for (auto u : g[v]) {
            if (dist[u] == dist[v] + 1 && dp[u] > dp[v]) {
                tmp.erase({dp[u], u});
                dp[u] = dp[v];
                tmp.insert({dp[u], u});
            }
        }
    }
    forn (i, n) {
        int ans = dist[i];
        if (dp[i] <= ans) {
            int x = ans - dp[i];
            ans += x;
        }
        cout << ans << " ";
    }
}
