#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update> Set;
//
//const int RANDOM = std::chrono::system_clock::now().time_since_epoch().count();
//struct chash {
//    int operator()(int x) {
//        return x ^ RANDOM;
//    }
//};
//
//gp_hash_table<int, int, chash> table;

typedef long long ll;

const int MAXN = 3e5;
const int MOD = 998244353;
int sieve[MAXN];

struct edge {
    int to, x, y;

    edge() = default;
    edge(int to, int x, int y) : to(to), x(x), y(y) {}
};

std::vector<edge> g[MAXN];

std::map<int, int> ans0;

std::map<int, int> diff; // pow[x] - pow[y]
void dfs(int v, int p) {
//    std::cout << v << ": " << diff[2] << '\n';
    for (auto [to, x, y] : g[v]) {
        if (to == p) continue;
        int x1 = x, y1 = y;
        while (y > 1) {
            diff[sieve[y]]--;
            y /= sieve[y];
        }
        while (x > 1) {
            diff[sieve[x]]++;
            ans0[sieve[x]] = std::max(ans0[sieve[x]], diff[sieve[x]]);
            x /= sieve[x];
        }

        dfs(to, v);

        x = x1, y = y1;
        while (x > 1) {
            diff[sieve[x]]--;
            x /= sieve[x];
        }
        while (y > 1) {
            diff[sieve[y]]++;
            y /= sieve[y];
        }
    }
}

ll binpow(ll a, ll b) {
    if (b == 0) return 1;
    if (b % 2 == 0) return binpow(a * a % MOD, b / 2);
    else return binpow(a, b - 1) * a % MOD;
}

ll rev[MAXN];

ll ans = 0;
void calc(int v, int p, ll cur) {
    ans += cur;
    ans %= MOD;
    for (auto &[to, x, y] : g[v]) {
        if (to != p) {
            calc(to, v, cur * y % MOD * rev[x] % MOD);
        }
    }
}

void solve() {
    ans = 0;
    diff.clear();
    ans0.clear();

    int n;
    std::cin >> n;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; i++) {
        int a, b, x, y;
        std::cin >> a >> b >> x >> y;
        a--, b--;
        g[a].emplace_back(b, x, y);
        g[b].emplace_back(a, y, x);
    }
    dfs(0, 0);

    ll a0 = 1;
    for (auto &i : ans0) {
        if (i.second > 0) {
            a0 = a0 * binpow(i.first, i.second) % MOD;
        }
    }
    calc(0, 0, a0);
    std::cout << ans << '\n';
}

int main() {
    rev[1] = 1;
    for (int i = 2; i < MAXN; i++) {
        rev[i] = binpow(i, MOD - 2);
        if (sieve[i]) continue;
        sieve[i] = i;
        for (ll j = 1ll * i * i; j < MAXN; j += i) {
            if (sieve[j] == 0) {
                sieve[j] = i;
            }
        }
    }

    int t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
}
