#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <stack>

using namespace std;

#define khan ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define ll long long
#define pii pair < int, int >
#define pb push_back

const int N = 2e5 + 5, mod = 998244353 , INF = 1e9 + 7;

const ll BIG = 1e18;

const int block = 316;

const int base = 1000000000;
const int base_digits = 9;

const int tox[] = {0, 0, 1, -1}, toy[] = {1, -1, 0, 0};

const double eps = (double)1e-9;

int p[N], cur[N], ans[N], n, res;

vector < pair < int, pii > > g[N], g1[N];

void clear(){
    for(int i = 1; i <= n; i++){
        g[i].clear();
        g1[i].clear();
        ans[i] = 0;
        cur[i] = 0;
    }
    res = 0;
    n = 0;
}

void upd(int x, int val){
    while(x > 1){
        int pr = p[x];
        cur[pr] += val;
        ans[pr] = max(ans[pr], cur[pr]);
        x /= p[x];
    }
}

void create(int v, int p){
    for(auto e : g1[v]){
        int to = e.first;
        if(to == p)
            continue;
        g[v].pb(e);
        create(to, v);
    }
}

void print(){
    for(int i = 1; i <= 10; i++){
        cout << cur[i] << " ";
    }
    cout << endl;
}

void dfs(int v, int p){
//    cout << v << endl;
//    print();
    for(auto e : g[v]){
        int to = e.first;
        int w = e.second.second;
        if(to == p)
            continue;
        upd(w, 1);
        upd(e.second.first, -1);
        dfs(to, v);
        upd(w, -1);
        upd(e.second.first, 1);
    }
}

int mult(int a, int b){
    return (a * 1ll * b) % mod;
}

int bp(int a, int b){
    int res = 1;
    while(b){
        if(b & 1){
            res = mult(res, a);
        }
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

int add(int a, int b){
    int res = a + b - mod;
    if(res < 0)
        res += mod;
    return res;
}

int inv(int a){
    return bp(a, mod - 2);
}

void calc(int v, int p, int prod, int den){
    res = add(res, mult(prod, inv(den)));
    //cout << mult(prod, inv(den)) << ' ' << v << endl;
    for(auto e : g[v]){
        int to = e.first;
        int w = e.second.second;
        if(to == p)
            continue;
        calc(to, v, mult(prod, e.second.first), mult(den, w));
    }
}

int gcd(int x, int y){
    if(!y)
        return x;
    return gcd(y, x % y);
}

void solve(){
    cin >> n;
    for(int i = 1; i < n; i++){
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        int g = gcd(x, y);
        x /= g;
        y /= g;
        g1[u].pb({v, {y, x}});
        g1[v].pb({u, {x, y}});
    }
//    cout << "ok" << endl;
    int root = 1;
    for(int i = 1; i <= n; i++){
        if(g1[i].size() == 1)
            root = i;
    }
    create(root, 0);
//    cout << root << endl;
    dfs(root, 0);
    //for(int i = 1; i <= 10; i++){
    //    cout << ans[i] << " ";
    //}
    //cout << endl;
    int lcm = 1;
    for(int i = 1; i <= n; i++){
        lcm = mult(lcm, bp(i, ans[i]));
    }
//    cout << lcm << " lcm" << endl;
    calc(root, 0, lcm, 1);
    cout << res << endl;
}

int main(){
    khan
    int lim = 2e5;
    for(int i = 2; i <= lim; i++){
        if(!p[i]){
            p[i] = i;
            for(int j = i + i; j <= lim; j += i){
                p[j] = i;
            }
        }
    }
//    cout << "okok\n";
    int q;
    cin >> q;
    while(q--){
        solve();
        clear();
    }
}
//Eger osylai istesek:
//aldymen, tayelsiz komponentalardy tayyp, arqaisysyn a_i arqyly ornekteimiz
//sosyn, lcm arqyly qosyndysyn tabyga bolady
//boldy! endi lcm taby qiyn bop tur goi
//lcm-di tappai-aq, birden qosyndyny eseptesek?
//bul syzyqtyq jyldamdyqty beredi
//ar mushesin taby she?
//kerisin taba salmaisyn ba?
//jaa solai eken
//agash!! agash qurad eken
//sebebi somdary birdei degen
//dfs arqyly lcm-di tabyga bolady
