#include <bits/stdc++.h>

using namespace std;

#define int long long


const int maxn = 3e5 + 7, mod = 998244353;

int mult(int a, int b) {
	a *= b;
	a %= mod;
	return a;
}

void ADD(int &a, int b) {
	a += b;
	if (a >= mod) {
        a -= mod;
	}
}

int n;

struct edge {
    int to, x, y;
};

vector<edge>gr[maxn];
int prime[maxn];

vector<int> get(int x) {
	vector<int> xx;
	while (x != 1) {
        xx.push_back(prime[x]);
		x /= prime[x];
	}
    return xx;
}

int power(int a, int b){
	if (b == 0) {
        return 1;
	}
    int t = power(a, b / 2);
	t *= t;
	t %= mod;
	if (b & 1LL) {
		t *= a;
		t %= mod;
	}
	return t;
}


map<int, int> result;

map<int, int> up, down;

struct changes {
	int type;
	int x, cnt;
};

vector<changes>  add(int x, int y) {
	vector<changes> pt;
	vector<int> xx = get(x);
	vector<int> yy = get(y);
	for (auto a : xx) {
		pt.push_back({-1, a, up[a]});
		pt.push_back({1, a, down[a]});
	}
	for (auto a : yy) {
		pt.push_back({-1, a, up[a]});
		pt.push_back({1, a, down[a]});
	}

	for (auto a : xx) {
		if (down[a] >= 1) {
			down[a]--;
		} else {
			up[a]++;
		}
	}
	for (auto a : yy) {
		if (up[a] >= 1) {
			up[a]--;
		} else {
			down[a]++;
			result[a] = max(result[a], down[a]);

		}
	}
	return pt;
}

void dfs(int u, int pr) {
	for (auto v : gr[u]) {
        if (v.to != pr) {
			vector<changes> pt = add(v.x, v.y);
			dfs(v.to, u);
			for (auto a : pt) {
				if (a.type == -1) {
				    up[a.x] = a.cnt;
				} else {
					down[a.x] = a.cnt;
				}
        	}
		}
	}
}

int RES = 0;

void dfs1(int u, int pr, int res) {
	ADD(RES, res);
	for (auto v : gr[u]) {
		if (v.to == pr) continue;
		dfs1(v.to, u, mult(mult(res, v.x), power(v.y, mod - 2)));
	}
}

void solve() {
	cin >> n;
	RES = 0;
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
	}
	result.clear();
	up.clear();
    down.clear();

	for (int i = 0; i < n - 1; ++i) {
		int u, v, x, y;
		cin >> u >> v >> x >> y;
		--u, --v;
		int gcd = __gcd(x, y);
		x /= gcd;
		y /= gcd;
		gr[u].push_back({v, y, x});
        gr[v].push_back({u, x, y});
	}
	dfs(0, 0);

	int res = 1;
	for (auto x : result) {
		for (int j = 0; j < x.second; ++j) {
			res *= x.first;
			res %= mod;
		}
	}

	dfs1(0, 0, res);

	cout << RES << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
	cin.tie(0);
    cout.tie(0);

	for (int i = 2; i < maxn; ++i) {
		if (prime[i]) {
            continue;
		}
		for (int j = i; j < maxn; j += i) {
			prime[j] = i;
		}
	}
   	int t = 1; cin >> t;
   	for (int i = 0; i < t; ++i) {
   		solve();
   	}
}









