//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << i << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::::::::::::


const int MOD = 998244353;

inline int add(int a, int b) {
    a += b;
    if (a >= MOD) a -= MOD;
    if (a < 0) a += MOD;
    return a;
}

inline int mul(int a, int b) {
    return (1LL * a * b) % MOD;
}

int binpow(int a, ll n) {
    int res = 1;
    while (n) {
        if (n & 1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

inline int inv(int x) {
    return binpow(x, MOD - 2);
}


const int N = 2e5 + 5;

int siv[N];

map<int, int> now;
map<int, int> have;
void dfs(int v, int p, vector<vector<tuple<int, int, int>>>& graph, vector<int>& b, vector<int>& c, vector<int>& d) {
    int x = d[v];
    while (x > 1) {
        int d = siv[x];
        --now[d];
        x /= d;
    }
    x = c[v];
    while (x > 1) {
        int d = siv[x];
        ++now[d];
        strain(have[d], now[d]);
        x /= d;
    }
//    err(v + 1);
//    err(c[v]);
//    err(v + 1);
//    for (auto p : now) {
//        err(p.first);
//        err(p.second);
//    }
//    errf();
    for (auto [to, x, y] : graph[v]) {
        if (to == p) continue;
        c[to] = y;
        d[to] = x;
        b[to] = mul(b[v], mul(x, inv(y)));
        dfs(to, v, graph, b, c, d);
    }
    x = c[v];
    while (x > 1) {
        int d = siv[x];
        --now[d];
        x /= d;
    }
    x = d[v];
    while (x > 1) {
        int d = siv[x];
        ++now[d];
        x /= d;
    }
}

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

void solve() {
    int n;
    cin >> n;
    vector<vector<tuple<int, int, int>>> graph(n);
    for (int rep = 0; rep < n - 1; ++rep) {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        --i; --j;
        int g = gcd(x, y);
        x /= g;
        y /= g;
        graph[i].emplace_back(j, y, x);
        graph[j].emplace_back(i, x, y);
    }
    vector<int> b(n), c(n), d(n);
    b[0] = c[0] = d[0] = 1;
    have.clear();
    now.clear();
    dfs(0, 0, graph, b, c, d);

    int lc = 1;
    for (auto [p, c] : have) {
//        err(p);
//        err(c);
        lc = mul(lc, binpow(p, c));
    }
//    err(lc);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = add(ans, mul(b[i], lc));
//        err(mul(b[i], lc));
    }
//    err(ans);
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    for (int i = 2; i < N; ++i) {
        if (siv[i] == 0) {
            for (int j = i; j < N; j += i)
                if (siv[j] == 0)
                    siv[j] = i;
        }
    }

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}

