#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Tail>
    decltype(auto) operator()(Tail&&... tail) const {
        return fun(ref(*this), forward<Tail>(tail)...);
    }
};

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x : a) cin >> x;

    constexpr int B = 555, A = 1e5 + 228;
    vector<vector<ll>> values(2 * B + 1);
    for (int i = 0; i < n; i++) {
        for (int d = -B; d <= B; d++) {
            values[d + B].push_back(a[i] - 1ll * i * d);
        }
    }

    int ans = 1;
    for (auto &v : values) {
        sort(all(v));
        for (int i = 0, j = 0; i < len(v); i = j) {
            while (j < len(v) && v[i] == v[j]) j++;
            ans = max(ans, j - i);
        }
    }

    constexpr int MAX_LEN = A / B + 2;
    vector<pair<int, ll>> big;
    big.reserve(n * MAX_LEN / 6);
    vector<int> used(2 * A, -1);
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - MAX_LEN); j < min(n, i + MAX_LEN); j++) {
            if (i != j && (a[i] - a[j]) % (i - j) == 0) {
                int d = (a[i] - a[j]) / (i - j);
                if (used[d + A] == i) continue;
                used[d + A] = i;
                if (d > B || d < -B) big.emplace_back(d, a[i] - 1ll * i * d);
            }
        }
    }

    sort(all(big));
    for (int i = 0, j = 0; i < len(big); i = j) {
        while (j < len(big) && big[i] == big[j]) j++;
        ans = max(ans, j - i);
    }
    cout << n - ans << '\n';
}
