#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Tail>
    decltype(auto) operator()(Tail&&... tail) const {
        return fun(ref(*this), forward<Tail>(tail)...);
    }
};

constexpr int MOD[2]{int(1e9) + 7, int(1e9) + 9};
int base[2];
constexpr int N = 4e5;
int deg[2][N];

int mult(int a, int b, int i) {
    return 1ll * a * b % MOD[i];
}

int add(int a, int b, int i) {
    a += b;
    if (a >= MOD[i]) a -= MOD[i];
    return a;
}

struct my_hash {
    int length;
    int h[2];

    my_hash() {
        length = 0;
        h[0] = h[1] = 0;
    }

    my_hash(char c) {
        length = 1;
        h[0] = h[1] = c;
    }

    friend my_hash operator+(const my_hash &a, const my_hash &b) {
        my_hash res;
        res.length = a.length + b.length;
        for (int i : {0, 1}) {
            res.h[i] = add(mult(deg[i][b.length], a.h[i], i), b.h[i], i);
        }
        return res;
    }

    bool operator==(const my_hash &x) const {
        return h[0] == x.h[0] && h[1] == x.h[1];
    }
};

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    for (int i : {0, 1}) {
        base[i] = rng() % (MOD[i] - 6) + 6;
        if (base[i] % 2 == 0) base[i]++;
        deg[i][0] = 1;
        for (int j = 1; j < N; j++) deg[i][j] = mult(deg[i][j - 1], base[i], i);
    }

    int n;
    string s;
    cin >> n >> s;
    int m = 1 << n;

    vector<my_hash> tree(2 * m);
    vector<string> suck(2 * m);
    y_combinator([&](auto dfs, int v, int l, int r) -> void {
        if (r - l == 1) {
            suck[v] += s[l];
            tree[v] = my_hash(s[l]);
            return;
        }
        int m = (l + r) >> 1;
        dfs(v << 1, l, m);
        dfs(v << 1 | 1, m, r);
        tree[v] = tree[v << 1] + tree[v << 1 | 1];
        suck[v] = suck[v << 1] + suck[v << 1 | 1];
        sort(all(suck[v]));
        suck[v].resize(unique(all(suck[v])) - suck[v].begin());
    })(1, 0, m);

    auto compare = [&](int m1, int m2) {
        int v1 = 1, v2 = 1;
        int i = 0;
        for (int bit = 0; bit < n; bit++) {
            int left1 = (m1 >> bit & 1) ? (v1 << 1 | 1) : (v1 << 1);
            int left2 = (m2 >> bit & 1) ? (v2 << 1 | 1) : (v2 << 1);
            // if (len(suck[left1]) == 1 && len(suck[left2]) == 1 && suck[left1][0] == suck[left2][0]) {
            if (len(suck[v1]) == 1) {
                i ^= 1 << bit;
                // v1 = left1 ^ 1;
                // v2 = left2 ^ 1;
                v1 = v1 << 1 | 1;
                v2 = v2 << 1 | 1;
            } else {
                // v1 = left1;
                // v2 = left2;
                v1 = v1 << 1;
                v2 = v2 << 1;
            }
        }
        return s[i ^ m1] < s[i ^ m2];
    };

    int best = 0;
    for (int mask = 1; mask < m; mask++) {
        if (!compare(best, mask)) best = mask;
    }

    string ans(m, '?');
    for (int i = 0; i < m; i++) ans[i ^ best] = s[i];
    cout << ans << '\n';
}
