#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

#define all(x) x.begin(), x.end()
#define nl '\n'
#define deb(x) cout << #x << " = " << x << ' ';
#define debnl(x) cout << #x << " = " << x << nl;
#define rep(n) for (int i = 0; i < (n); i++)


typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef double D;
typedef long double LD;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<vvpll> vvvpll;

template<class T> void print(T a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << nl;
}

template<class T> void print2(T a) {
	for (auto x : a) {
		print(x);
	}
	cout << nl;
}

void fastio() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll mod = 998244353;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
	return (a * b) / gcd(a, b);
}

struct Frac {
	ll x, y;

	void norm() {
		ll g = gcd(x, y);
		x /= g;
		y /= g;
	}

	Frac() {
		x = 1;
		y = 1;
	}

	Frac(ll oth_x, ll oth_y) {
		x = oth_x;
		y = oth_y;
		norm();
	}

	Frac(ll oth_x) {
		x = oth_x;
		y = 1;
	}

	//Frac operator+(Frac oth) {
	//	/*ll g = gcd(y, oth.y);
	//	ll l = (y * oth.y) / g;
	//	return Frac(x * (l / y) + oth.x * (l / oth.y), l);*/
	//	Frac res = (x * oth.y + oth.x * y, y * oth.y);
	//	res.norm();
	//	return res;
	//}

	//Frac operator-(Frac oth) {
	//	/*ll g = gcd(y, oth.y);
	//	ll l = (y * oth.y) / g;
	//	return Frac(x * (l / y) - oth.x * (l / oth.y), l);*/
	//	Frac res = (x * oth.y + oth.x * y, y * oth.y);
	//	res.norm();
	//	return res;
	//}

	Frac operator*(Frac oth) {
		Frac res =  Frac(x * oth.x, y * oth.y);
		res.norm();
		return res;
	}

	/*Frac operator/(Frac oth) {
		Frac res = Frac(x * oth.y, y * oth.x);
		res.norm();
		return res;
	}*/

};

struct Edge {
	int v;
	Frac f;
};


vector<vector<Edge>> gr;
vector<Frac> val;
vi used;

void dfs(int u) {
	used[u] = 1;
	for (auto &tmp : gr[u]) {
		int v = tmp.v;
		if (!used[v]) {
			val[v] = val[u] * tmp.f;
			dfs(v);
		}
	}
}

void solve() {
	int n, root = 0, u, v;
	ll x, y;
	cin >> n;
	gr.clear();
	gr.resize(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> u >> v >> x >> y; u--; v--;
		gr[u].push_back({ v, Frac(y, x) });
		gr[v].push_back({ u, Frac(x, y) });
	}
	for (int i = 0; i < n; i++) {
		if (gr[i].size() == 1) root = i;
	}
	used = vi(n, 0);
	val.resize(n, Frac(1, 1));
	dfs(root);
	ll l = 1;
	for (int i = 0; i < n; i++) {
		l = lcm(l, val[i].y);
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		ll mas = ((l / val[i].y) * val[i].x) % mod;
		//deb(i); debnl(mas);
		ans += mas;
		ans %= mod;
	}
	cout << ans << nl;
}

signed main() {
	fastio();
	int t = 1;
	cin >> t;
	while (t) {
		solve();
		t--;
	}
}