#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int binpow(int a, int n, int mod) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) return 1ll * a * binpow(a, n - 1, mod) % mod;
    int t = binpow(a, n >> 1, mod);
    return 1ll * t * t % mod;
}

struct Edge {
    int to;
    map<int, int> xy;
};

constexpr int MAXN = 200005, MOD = 998244353;
int primes[MAXN];
int sieve[MAXN];
int primes_r = 0;

void calcsieve() {
    fill(sieve, sieve + MAXN, -1);
    for (int i = 2; i < MAXN; ++i) {
        if (sieve[i] == -1) {
            sieve[i] = primes_r;
            primes[primes_r++] = i;
        }
        for (int j = 0; j <= sieve[i] && primes[j] * i < MAXN; ++j) {
            sieve[i * primes[j]] = j;
        }
    }
}

map<int, int> cache[MAXN];

void print_map(map<int, int> a) {
    for (auto &now : a) {
        //cerr << now.first << ':' << now.second << ' ';
    }
    //cerr << '\n';
}

map<int, int> factorize(int v) {
    if (!cache[v].empty()) return cache[v];
    map<int, int> res;
    int iv = v;
    while (v != 1) {
        int n = primes[sieve[v]];
        v /= n;
        ++res[n];
    }
    return cache[iv] = res;
}

map<int, int> mapdiff(map<int, int> a, map<int, int> b) {
    map<int, int> res;
    for (auto &now : a) {
        res[now.first] = now.second - b[now.first];
    }
    for (auto &now : b) {
        res[now.first] = a[now.first] - now.second;
    }
    return res;
}

void inplace_mapdiff(map<int, int> &a, map<int, int> b, vector<int> &zapas) {
    for (auto &now : b) {
        a[now.first] -= now.second;
        // //cerr << now.first << ' ' << a[now.first] << '\n';
        zapas[now.first] = min(zapas[now.first], a[now.first]);
    }
}

void revert_inplace_mapdiff(map<int, int> &a, map<int, int> b) {
    for (auto &now : b) {
        a[now.first] += now.second;
        // zapas[now.first] = min(zapas[now.first], a[now.first]);
    }
}

void dfs(int v, int prev, vector<vector<Edge>> &graph, map<int, int> &cfs, vector<int> &zapas) {
    for (const Edge &ch : graph[v]) {
        if (ch.to == prev) continue;
        inplace_mapdiff(cfs, ch.xy, zapas);
        //cerr << v << '>' << ch.to << ' ';
        // print_map(cfs);
        dfs(ch.to, v, graph, cfs, zapas);
        revert_inplace_mapdiff(cfs, ch.xy);
    }
}

ll invert(ll num) {
    return binpow(num, MOD - 2, MOD);
}

ll dfs2(int v, int prev, vector<vector<Edge>> &graph, ll curvnum) {
    ll s = 0;
    for (const Edge &ch : graph[v]) {
        if (ch.to == prev) continue;
        ll newnum = curvnum;
        for (auto &now : ch.xy) {
            if (now.second <= 0) {
                newnum = newnum * binpow(now.first, -now.second, MOD) % MOD;
            }
            else {
                newnum = newnum * invert(binpow(now.first, now.second, MOD)) % MOD;
            }
        }
        s += dfs2(ch.to, v, graph, newnum);
        s %= MOD;
    }
    return (s + curvnum) % MOD;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    calcsieve();
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t --> 0) {
        int n;
        cin >> n;
        vector<vector<Edge>> graph(n);
        for (int i = 0; i < n - 1; ++i) {
            int u, v, x, y;
            cin >> u >> v >> x >> y;
            --u, --v;
            graph[u].push_back({v, mapdiff(factorize(x), factorize(y))});
            graph[v].push_back({u, mapdiff(factorize(y), factorize(x))});
        }
        map<int, int> cfs;
        vector<int> zapas(n + 1, 0);
        dfs(0, 0, graph, cfs, zapas);
        ll resx = 1;
        for (int i = 2; i <= n; ++i) {
            resx = resx * binpow(i, -zapas[i], MOD) % MOD;
        }
        //cerr << resx;
        cout << dfs2(0, 0, graph, resx) << '\n';
        //cerr << "==============";
    }
    return 0;
}