#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

const int MAXN = 2e5 + 123;

bool cut(ll x, multiset<ll>& st) {
    if (st.find(x) != st.end()) {
        st.erase(st.find(x));
        return true;
    }
    if (x < *st.begin())
        return false;
    if (!cut(x / 2, st) || !cut((x + 1) / 2, st))
        return false;
    return true;
}

void solve() {
    int n;
    cin >> n;
    multiset<ll> st;
    ll sm = 0;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        st.insert(x);
        sm += x;
    }
    if (cut(sm, st))
        cout << "YES\n";
    else
        cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
