#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
using namespace std;
using ll = long long;

const ll MAXN = 2e5 + 123;
const ll MOD = 998244353;
vector<pair<ll, pair<ll, ll>>> edg[MAXN];
ll a[MAXN];
ll lp[MAXN];

ll pw(ll a, ll m) {
    if (!m)
        return 1;
    a %= MOD;
    if (m % 2)
        return pw(a, m - 1) * a % MOD;
    return pw(a * a, m / 2);
}

ll dfs(ll v, ll rt, vector<ll>& pcur, vector<ll>& pmin) {
    ll ans = a[v];
    for (auto [u, rl] : edg[v]) {
        if (u == rt)
            continue;
        ll t = rl.second;
        while (t > 1) {
            ++pcur[lp[t]];
            t /= lp[t];
        }
        t = rl.first;
        while (t > 1) {
            --pcur[lp[t]];
            pmin[lp[t]] = min(pmin[lp[t]], pcur[lp[t]]);
            t /= lp[t];
        }
        a[u] = (a[v] * rl.second) % MOD * pw(rl.first, MOD - 2) % MOD;
        ans += dfs(u, v, pcur, pmin);
        ans %= MOD;
        t = rl.second;
        while (t > 1) {
            --pcur[lp[t]];
            t /= lp[t];
        }
        t = rl.first;
        while (t > 1) {
            ++pcur[lp[t]];
            t /= lp[t];
        }
    }
    return ans;
}

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i)
        edg[i].clear();
    for (int i = 2; i <= n; ++i)
        lp[i] = 0;
    for (ll i = 2; i <= n; ++i) {
        if (lp[i] == 0) {
            lp[i] = i;
            for (ll t = i * 2; t <= n; t += i)
                lp[t] = i;
        }
    }
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, x, y;
        cin >> u >> v >> x >> y;
        --u, --v;
        edg[u].push_back({v, {x, y}});
        edg[v].push_back({u, {y, x}});
    }
    a[0] = 1;
    vector<ll> pcur(n + 1, 0);
    vector<ll> pmin(n + 1, 0);
    ll ans = dfs(0, -1, pcur, pmin);
    ll mlt = 1;
    for (ll k = 2; k <= n; ++k) {
        mlt = (mlt * pw(k, -pmin[k])) % MOD;
    }
    //cout << ans << endl;
    cout << (ans * mlt) % MOD << '\n';
}

signed main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
