#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <iomanip>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <cstring>
#include <math.h>
#include <assert.h>

#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define BIL 1000000000ll
#define INF BIL * BIL * 4
#define fill(v, n) for (int qqq = 0; qqq < n; qqq++) cin >> v[qqq]
#define mod 998244353

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

vector<vector<int>> g;
vector<map<int, int>> d;
vector<int> ptr;
map<pii, pii> edges;

vector<pii> factorize(int x) {
	vector<pii> res;
	for (int i = 2; i * i <= x; i++) {
		int cnt = 0;
		while (x % i == 0) {
			cnt++;
			x /= i;
		}
		if (cnt)
			res.push_back({ i, cnt });
	}
	if (x > 1)
		res.push_back({ x, 1 });
	return res;
}

void dfs(int v, int p = 0, int divide = 1, int multiply = 1) {
	for (int to : g[v])
		if (to != p) {
			auto [a, b] = edges[{v, to}];
			dfs(to, v, a, b);
			if (ptr[v] == v)
				ptr[v] = ptr[to];
			else {
				int i1 = ptr[v], i2 = ptr[to];
				if (d[i1].size() > d[i2].size())
					for (auto [k, v] : d[i2])
						d[i1][k] = max(v, max(0, d[i1][k]));
				else {
					for (auto [k, v] : d[i1])
						d[i2][k] = max(v, max(0, d[i2][k]));
					ptr[v] = i2;
				}
			}
		}
	for (auto [p, cnt] : factorize(divide))
		d[ptr[v]][p] += cnt;
	for (auto [p, cnt] : factorize(multiply))
		d[ptr[v]][p] -= cnt;
	vector<int> k;
	for (auto [key, val] : d[ptr[v]])
		if (val < 0)
			k.push_back(key);
	for (int i : k)
		d[ptr[v]].erase(i);
}

int gcd(int a, int b) {
	if (b > a) return gcd(b, a);
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll binpow(ll x, ll p) {
	if (p == 0) return 1;
	if (p % 2)
		return (binpow(x, p - 1) * x) % mod;
	ll res = binpow(x, p / 2);
	return (res * res) % mod;
}

ll revmod(ll a) {
	return binpow(a, mod - 2);
}

int32_t main() {
	fast;
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		g.assign(n, {});
		d.assign(n, {});
		ptr.assign(n, 0);
		edges.clear();
		for (int i = 0; i < n; i++)
			ptr[i] = i;
		for (int i = 0; i < n - 1; i++) {
			int u, v, x, y;
			cin >> u >> v >> x >> y;
			int gg = gcd(x, y);
			if (gg > 1) {
				x /= gg;
				y /= gg;
			}
			u--;
			v--;
			g[u].push_back(v);
			g[v].push_back(u);
			edges[{u, v}] = { x, y };
			edges[{v, u}] = { y, x };
		}
		dfs(0);
		vector<ll> val(n, -1);
		queue<int> q;
		q.push(0);
		val[0] = 1;
		while (q.size()) {
			int cur = q.front();
			q.pop();
			for (int to : g[cur])
				if (val[to] == -1) {
					auto [f, s] = edges[{cur, to}];
					val[to] = (((val[cur] * s) % mod) * revmod(f)) % mod;
					q.push(to);
				}
		}
		ll mul = 1;
		for (auto [p, cnt] : d[ptr[0]])
			while (cnt--) {
				if (cnt < 0) break;
				mul *= p;
				mul %= mod;
			}
		ll ans = 0;
		for (ll t : val) {
			t *= mul;
			t %= mod;
			ans += t;
		}
		cout << ans % mod << "\n";
	}
}


/*

1
8
5 4 2 3
6 4 5 4
1 3 5 2
6 8 2 1
3 5 3 4
3 2 2 5
6 7 4 3

*/