#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <array>

using namespace std;

const int MOD = 998244353;

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int pwr(int a, int b) {
    int res = 1;
    while (b) {
        if (b % 2)
            res = 1ll * res * a % MOD;
        a = 1ll * a * a % MOD;
        b /= 2;
    }
    return res;
}

int dv(int a, int b) {
    return 1ll * a * pwr(b, MOD - 2) % MOD;
}

vector<vector<array<int, 3>>> gr;
map<int, int> d, h, ans;
vector<int> used;

void dfs(int u) {
    used[u] = 1;
    for (auto[v, f, s] : gr[u]) {
        if (used[v])
            continue;
        vector<array<int, 3>> ch;
        for (int i = 2; i * i <= f; ++i) {
            if (f % i == 0) {
                int cnt = 0;
                while (f % i == 0) {
                    cnt++;
                    f/=i;
                }
                ch.push_back({1, i, h[i]});
                h[i] += cnt;
            }
        }
        if (f > 1) {
            ch.push_back({1, f, h[f]});
            h[f]++;
        }
        for (int i = 2; i * i <= s; ++i) {
            if (s % i == 0) {
                int cnt = 0;
                while (s % i == 0) {
                    cnt++;
                    s /= i;
                }
                if (h[i] >= cnt) {
                    ch.push_back({1, i, h[i]});
                    h[i] -= cnt;
                }
                else {
                    ch.push_back({1, i, h[i]});
                    ch.push_back({0, i, d[i]});
                    cnt -= h[i];
                    h[i] = 0;
                    d[i] += cnt;
                }
            }
        }
        if (s > 1) {
            if (h[s] > 0) {
                ch.push_back({1, s, h[s]});
                h[s]--;
            }
            else {
                ch.push_back({0, s, d[s]});
                d[s]++;
            }
        }
        dfs(v);
        for (auto [x, y, z] : ch) {
            if (x)
                h[y] = z;
            else {
                ans[y] = max(ans[y], d[y]);
                d[y] = z;
            }
        }
    }
}

int dfs1(int u, int nw) {
    int res = nw;
    used[u] = 1;
    for (auto[v, x, y] : gr[u]) {
        if (used[v])
            continue;
        res = (res + dfs1(v, dv(1ll * nw * x % MOD, y))) % MOD;
    }
    return res;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        gr.assign(n, {});
        d.clear(), h.clear(), ans.clear();
        for (int i = 0; i < n - 1; ++i) {
            int f, s, x, y;
            cin >> f >> s >> x >> y;
            --f, --s;
            int g = gcd(x, y);
            x /= g, y /= g;
            gr[f].push_back({s, y, x});
            gr[s].push_back({f, x, y});
        }
        used.assign(n, 0);
        dfs(0);
        int nw = 1;
        for (auto [x, y] : ans)
            nw = 1ll * nw * pwr(x, y) % MOD;
        used.assign(n, 0);
        cout << dfs1(0, nw) << '\n';
    }
}