#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;
const int A = 26;
const ll MOD = 998244353;

ll bin_pow(ll a, ll deg)
{
    if (deg == 0)
        return 1;
    if (deg & 1)
        return a * bin_pow(a, deg - 1) % MOD;
    ll k = bin_pow(a, deg / 2);
    return k * k % MOD;
}

ll gcd(ll a, ll b)
{
    while (b)
    {
        a %= b;
        swap(a, b);
    }
    return a;
}

struct Node{
    vector <int> g;
    Node()
    {
        for (int i = 0; i < A; i++)
            g.push_back(-1);
    }
};

struct Point{
    ll x;
    ll y;
    Point() : x(0), y(0) {};
    Point(ll _x, ll _y) : x(_x), y(_y) {};

    Point operator- (const Point& a)
    {
        return {x - a.x, y - a.y};
    }
    Point operator+ (const Point& a)
    {
        return {x + a.x, y + a.y};
    }
    Point operator* (ld k)
    {
        return {x * k, y * k};
    }
    ll len()
    {
        return x * x + y * y;
    }
    ld len2()
    {
        return sqrt(len());
    }
};

ll vec(Point a, Point b)
{
    return a.x * b.y - a.y * b.x;
}
ll skal(Point a, Point b)
{
    return a.x * b.x + a.y * b.y;
}

vector <pair <ll, pair <ll, ll> > > g[MAXN];

int reshet[MAXN + 1];

vector <ll> cnt(MAXN + 1);
vector <ll> cnt1(MAXN, 0);
vector <ll> ans(MAXN + 1), let(MAXN + 1);
void dfs(int v, ll a, ll b, int p)
{
    ans[v] = a;
    let[v] = b;
    for (auto& [u, c] : g[v])
    {
        if (u == p)
            continue;
        ll c1 = c.first;
        ll c2 = c.second;
        while (c1 != 1)
        {
            cnt[reshet[c1]]++;
            c1 /= reshet[c1];
        }
        while (c2 != 1)
        {
            cnt[reshet[c2]]--;
            if (cnt[reshet[c2]] < 0)
                cnt1[reshet[c2]] = max(-cnt[reshet[c2]], cnt1[reshet[c2]]);
            c2 /= reshet[c2];
        }
        dfs(u, (a * c.first) % MOD, (b * c.second) % MOD, v);
        c1 = c.first;
        c2 = c.second;
        while (c1 != 1)
        {
            cnt[reshet[c1]]--;
            c1 /= reshet[c1];
        }
        while (c2 != 1)
        {
            cnt[reshet[c2]]++;
            c2 /= reshet[c2];
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    for (int i = 0; i <= MAXN; i++)
    {
        reshet[i] = -1;
    }
    reshet[1] = 1;
    for (int i = 2; i <= MAXN; i++)
    {
        if (reshet[i] == -1)
        {
            reshet[i] = i;
            for (ll j = i * i; j <= MAXN; j += i)
            {
                if (reshet[j] == -1)
                    reshet[j] = i;
            }
        }
    }

    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        ll q, w, e, r;
        for (int i = 0; i < n; i++)
        {
            g[i].clear();
            cnt[i] = 0;
            cnt1[i] = 0;
        }
        cnt[n] = 0;
        cnt1[n] = 0;
        for (int i = 1; i < n; i++)
        {
            cin >> q >> w >> e >> r;
            q--;
            w--;
            g[q].push_back({w, {r, e}});
            g[w].push_back({q, {e, r}});
        }
        dfs(0, 1, 1, -1);
        ll cd = 1;
        for (ll i = 1; i <= n; i++)
        {
            for (int j = 0; j < cnt1[i]; j++)
            {
               cd = cd * i % MOD;
            }
        }
        ll sum = 0;
        for (int i = 0; i < n; i++)
        {
            sum = sum + ans[i] * cd % MOD * bin_pow(let[i], MOD - 2) % MOD;
            if (sum >= MOD)
                sum -= MOD;
        }
        cout << sum << "\n";
    }
}
/*
1
17
8 7 4 16
9 17 4 5
5 14 13 12
11 1 17 14
6 13 8 9
2 11 3 11
4 17 7 2
17 16 8 6
15 5 1 14
16 7 1 10
12 17 13 10
11 16 7 2
10 11 6 4
13 17 14 6
3 11 15 8
15 6 12 8
*/
