#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;
const int A = 26;
const ll MOD = 998244353;

ll bin_pow(ll a, ll deg)
{
    if (deg == 0)
        return 1;
    if (deg & 1)
        return a * bin_pow(a, deg - 1) % MOD;
    ll k = bin_pow(a, deg / 2);
    return k * k % MOD;
}

ll gcd(ll a, ll b)
{
    while (b)
    {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    if (n < 3)
    {
        cout << 0;
        return 0;
    }
    vector <ll> a(n), pref(n), suf(n), sum(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        if (i > 0)
            sum[i] = sum[i - 1] + a[i] - a[i - 1];
        else
            sum[i] = 0;
    }

    pref[0] = 0;
    for (int i = 1; i < n; i++)
    {
        if (a[i] - a[i - 1] == a[i - 1] - a[i - 2])
            pref[i] = pref[i - 1] + 1;
        else
            pref[i] = 0;
    }
    suf[n - 1] = 0;
    suf[n - 2] = 1;
    for (int i = n - 3; i >= 0; i--)
    {
        if (a[i + 1] - a[i] == a[i + 2] - a[i + 1])
            suf[i] = suf[i + 1] + 1;
        else
            suf[i] = 1;
    }

    ll ans = n - 2;
    for (int i = 0; i < n; i++)
    {
        ll s = i - pref[i];
        ll f = i + suf[i];
        ll cnt = s + n - f - 1;
        ans = min(ans, cnt);
    }
    cout << ans;

}
/*
1
17
8 7 4 16
9 17 4 5
5 14 13 12
11 1 17 14
6 13 8 9
2 11 3 11
4 17 7 2
17 16 8 6
15 5 1 14
16 7 1 10
12 17 13 10
11 16 7 2
10 11 6 4
13 17 14 6
3 11 15 8
15 6 12 8
*/
