/*
#pragma comment(linker, "stack:200000000")
#pragma GCC optimize("0fast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune-native")
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <fstream>
#include <unordered_set>
#include <cmath>
#include <cstring>
#include <chrono>
#include <queue>
#include <deque>
#include <stack>

// ext/pb_ds/assoc_container.hpp>
// __gnu_pbds

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const int mod = 998244353;
const ld eps = 1e-7;
const ld pi = acos(-1);

#define ff first
#define y1 y11
#define ss second
#define endl '\n'
#define ins insert
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define fl() cout.flush()


/*
struct segtree {
    vector <int> tree;
    int sz;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1);
    }

    void update (int i, int v, int x, int lx, int rx) {

    }

    int get (int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {

        }
        if (lx >= l && rx <= r) {

        }
        int m = (lx + rx) / 2;
    }
};
*/


bool cmp (ll a, ll b) {
    return a > b;
}

ll gcd (ll a, ll b) {
    if (!b) {
        return a;
    }
    return gcd(b, a % b);
}


vector<vector<vector<ll>>> g;
vector <ll> ans;

ll binpow (ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
            res %= mod;
        }
        n >>= 1;
        a *= a;
        a %= mod;
    }
    return res;
}

const int N = 2e5 + 3;
ll lp[N];


vector <ll> x, y, A, NOD;


void dfs1 (int k, int p) {
    // cout << k << endl;
    for (auto i : g[k]) {
        if (i[0] != p) {
            ll x1 = i[1], y1 = i[2];
            while (x1 > 1) {
                ++x[lp[x1]];
                NOD[lp[x1]] = min(x[lp[x1]], y[lp[x1]]);
                A[lp[x1]] = max(A[lp[x1]], x[lp[x1]] - NOD[lp[x1]]);
                x1 /= lp[x1];
            }
            while (y1 > 1) {
                ++y[lp[y1]];
                NOD[lp[y1]] = min(x[lp[y1]], y[lp[y1]]);
                A[lp[y1]] = max(A[lp[y1]], x[lp[y1]] - NOD[lp[y1]]);
                y1 /= lp[y1];
            }
            dfs1(i[0], k);
            x1 = i[1];
            y1 = i[2];
            while (x1 > 1) {
                --x[lp[x1]];
                NOD[lp[x1]] = min(x[lp[x1]], y[lp[x1]]);
                A[lp[x1]] = max(A[lp[x1]], x[lp[x1]] - NOD[lp[x1]]);
                x1 /= lp[x1];
            }
            while (y1 > 1) {
                --y[lp[y1]];
                NOD[lp[y1]] = min(x[lp[y1]], y[lp[y1]]);
                A[lp[y1]] = max(A[lp[y1]], x[lp[y1]] - NOD[lp[y1]]);
                y1 /= lp[y1];
            }
        }
    }
}


void dfs (int k, int p) {
    for (auto i : g[k]) {
        if (i[0] != p) {
            ans[i[0]] = ans[k] * i[2] % mod * binpow(i[1], mod - 2) % mod;
            dfs(i[0], k);
        }
    }
}


void solve() {
    int n;
    cin >> n;
    x.clear();
    y.clear();
    A.clear();
    NOD.clear();
    x.resize(n + 1);
    y.resize(n + 1);
    A.resize(n + 1);
    NOD.resize(n + 1);
    g.clear();
    ans.clear();
    ans.resize(n);
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        ll i1, i2, x, y;
        cin >> i1 >> i2 >> x >> y;
        --i1; --i2;
        ll gc = gcd(x, y);
        x /= gc; y /= gc;
        g[i1].pb({i2, x, y});
        g[i2].pb({i1, y, x});
    }
    dfs1(0, -1);
    // ans[0]
    ans[0] = 1;
    for (int i = 2; i < n + 1; ++i) {
        // cout << A[i] << ' ';
        ans[0] *= binpow(i, A[i]);
        ans[0] %= mod;
    }
    dfs(0, -1);
    ll s = 0;
    for (auto i: ans) {
        s += i;
        s %= mod;
    }
    cout << s << endl;
}


signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    lp[1] = -1;
    for (int i = 2; i < N; ++i) {
        lp[i] = i;
        for (int j = 2; j * j <= i; ++j) {
            if (i % j == 0) {
                lp[i] = j;
                break;
            }
        }
    }
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}