#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll

const int MOD = 998244353;
const int MAXN = 2e5 + 100;
vector<vector<int> > sp[MAXN];
int r[MAXN];
int tot = 0;

void prec() {
	r[1] = 1;
	for (int x = 2; x < MAXN; ++x) {
		if (r[x] == 0) {
			r[x] = x;
			for (int y = x * x; y < MAXN; y += x) {
				if (r[y] == 0) {
					r[y] = x;
				}
			}
		}
	}
}

int gcd(int x, int y) {
	if (y == 0) {
		return x;
	}
	return gcd(y, x % y);
}

int fast_pow(int x, int y) {
	if (y == 0) {
		return 1;
	}
	if (y % 2 == 0) {
		return fast_pow(x * x % MOD, y / 2);
	}
	else {
		return x * fast_pow(x, y - 1) % MOD;
	}
}

void devide(map<int, int> &mp, int x) {
	while(x != 1) {
		mp[r[x]]--;
		x /= r[x];
	}
}

void power(map<int, int> &mp, int x) {
	while(x != 1) {
		mp[r[x]]++;
		x /= r[x];
	}
}

int get_gcd(map<int, int> &mp, int x) {
	int ans = 1;
	for (auto [val, cnt] : mp) {
		while(cnt != 0 && x % val == 0) {
			x /= val;
			ans *= val;
			--cnt;	
		}
	}
	return ans;
}

int dfs(int u, int p, int now, map<int, int> &d) {
	int v, x, y;
	tot = (tot + now) % MOD;
	int pw = 1;
	for (auto vec : sp[u]) {
		v = vec[0];
		x = vec[1];
		y = vec[2];
		if (v == p) {
			continue;
		}
		int g = get_gcd(d, x);
		pw = (pw * x / g) % MOD;
		now = (now * x / g) % MOD;
		tot = (tot * x / g) % MOD;
		power(d, x);
		devide(d, g);
		power(d, y);
		devide(d, x);
		int tmp = dfs(v, u, (now * fast_pow(x, MOD - 2) % MOD) * y % MOD, d);
		pw = (pw * tmp) % MOD;
		now = (now * tmp) % MOD;
		devide(d, y);
		power(d, x);
	}
	return pw;
}

/*
1
4
3 2 3 4
1 2 4 3
1 4 2 4



1
6
1 2 1 1
2 3 3 1
2 4 2 1
3 6 3 2
3 5 5 1
*/

void solve() {
	prec();
	int n;
	cin >> n;
	int u, v, x, y;
	for (int i = 0; i < n - 1; ++i) {
		cin >> u >> v >> x >> y;
		--u;
		--v;
		int g = gcd(x, y);
		sp[u].push_back({v, x / g, y / g});
		sp[v].push_back({u, y / g, x / g});
	}
	int st = 0;
	for (int i = 0; i < n; ++i) {
		if (sp[i].size() == 1) {
			st = i;
			break;
		}
	}
	map<int, int> mp;
	dfs(st, -1, 1, mp);
	cout << tot << endl;
	for (int i = 0; i < n; ++i) {
		sp[i].clear();
		tot = 0;
	}
	return;
}

int32_t main() {
	// freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	cin >> tests;
	while(tests--) {
		solve();
	}
}