#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x)  (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

const ll mod = 998244353;
ll bp(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) res = res * a % mod;
        a = a * a % mod;
        n >>= 1;
    }
    return res;
}

ll inv(ll a) {
    return bp(a, mod - 2);
}

const int maxn  = 200005;
int cnt_max[maxn], cnt[maxn];
vector<int> dv[maxn];
vector<array<int, 3>> g[maxn];

ll ans = 0;

void dfs(int v, int p = -1) {
    for (auto &[u, x, y]: g[v]) {
        if (u == p) continue;
        for (int d: dv[x]) {
            cnt[d]--;
        }
        for (int d: dv[y]) {
            cnt[d]++;
            cnt_max[d] = max(cnt_max[d], cnt[d]);
        }
        dfs(u, v);
        for (int d: dv[x]) {
            cnt[d]++;
        }
        for (int d: dv[y]) {
            cnt[d]--;
        }
    }
}

void dfs2(int v, ll cv = 0, int p = -1) {
    ans = (ans + cv) % mod;
    for (auto &[u, x, y]: g[v]) {
        if (u == p) continue;
        dfs2(u, cv *x % mod * inv(y) % mod, v);
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i <= n; i++) {
        g[i].clear();
        cnt_max[i] = cnt[i] = 0;
    }

    for (int i = 0; i < n - 1; i++) {
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        u--; v--;
        g[v].push_back({u, x, y});
        g[u].push_back({v, y, x});
    }

    dfs(0);

    ll cv = 1;
    for (int i = 0; i <= n; i++) {
        while (cnt_max[i]--) cv = cv * i % mod;
    }

    ans = 0;
    dfs2(0, cv);
    cout << ans % mod << nl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    for (int i = 1; i < maxn; i++) {
        int j = 2;
        int ti = i;
        while (j * j <= ti) {
            while (ti % j == 0) {
                dv[i].push_back(j);
                ti /= j;
            }
            j++;
        }
        if (ti > 1) dv[i].push_back(ti);
    }

    int T;
    cin >> T;
    while (T--) solve();
}
