#include <bits/stdc++.h>
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define point pair<ll, ll>
#define x first
#define y second

using ll = long long;
using ld = long double;

const ll mod = 998244353;

struct edge {
    int u;
    int x;
    int y;
    edge(int u1, int x1, int y1) : u(u1), x(x1), y(y1) {}
    ///val[u] / val[v] = y / x
};

vector<vector<edge> > g;

const int N = (int)2e5 + 1234;

int mp[N]; ///mp[p] = a; p^a
int mx[N];
int mind[N];
int dpow[N];
int pre[N];
ll inv[N];
ll val[N];

ll bin_pow(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0) {
        ll t = (a * a) % mod;
        return bin_pow(t, n >> 1);
    }
    return (a * bin_pow(a, n - 1)) % mod;
}

void dfs(int v, int par) {
    //cout << v << ": ";
    ///cout << 2 << ' ' <<
    for (edge &e : g[v]) {
        if (e.u == par)
            continue;
        ///* y / x
        int y = e.y, x = e.x;
        while (y != 1) {
            int p = mind[y];
            int pw = dpow[y];
            mp[p] += pw;
            y = pre[y];
            ///cout << y << endl;
        }
        while (x != 1) {
            int p = mind[x];
            int pw = dpow[x];
            mp[p] -= pw;
            mx[p] = max(mx[p], -mp[p]);
            x = pre[x];
            ///cout << x << endl;
        }
        dfs(e.u, v);
        y = e.y;
        x = e.x;
        while (y != 1) {
            int p = mind[y];
            int pw = dpow[y];
            mp[p] -= pw;
            y = pre[y];
        }
        while (x != 1) {
            int p = mind[x];
            int pw = dpow[x];
            mp[p] += pw;
            x = pre[x];
        }
    }
}

void dfs2(int v, int par) {
    for (edge &e : g[v]) {
        if (e.u == par)
            continue;
        val[e.u] = ((val[v] * e.y) % mod) * inv[e.x] % mod;
        dfs2(e.u, v);
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    fill(mind, mind + N, -1);
    mind[1] = 1;
    for (int i = 2; i < N; ++i) {
        if (mind[i] == -1) {
            mind[i] = i;
        } else {
            continue;
        }
        for (int j = i + i; j < N; j += i) {
            if (mind[j] == -1) {
                mind[j] = i;
            }
        }
    }
    for (int i = 1; i < N; ++i) {
        inv[i] = bin_pow(i, mod - 2);
    }
    for (int i = 1; i < N; ++i) {
        if (mind[i] == i) {
            dpow[i] = 1;
            pre[i] = 1;
            continue;
        }
        int w = i / mind[i];
        if (mind[w] == mind[i]) {
            dpow[i] = dpow[w] + 1;
            pre[i] = pre[w];
        } else {
            dpow[i] = 1;
            pre[i] = w;
        }
    }
    /**for (int i = 1; i < 20; ++i) {
        cout << i << ": " << mind[i] << ' ' << dpow[i] << ' ' << pre[i] << endl;
    }**/
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        g = vector<vector<edge> >(n);
        for (int i = 0; i < n - 1; ++i) {
            int v, u;
            cin >> v >> u;
            --v;
            --u;
            int x, y;
            cin >> x >> y;
            //swap(x, y);
            g[v].emplace_back(edge(u, x, y));
            g[u].emplace_back(edge(v, y, x));
            ///val(v) / val(u) = x / y
        }
        fill(mp, mp + n + 1, 0);
        fill(mx, mx + n + 1, 0);
        dfs(0, -1);
        val[0] = 1;
        for (int i = 1; i <= n; ++i) {
            val[0] = (val[0] * bin_pow(i, mx[i])) % mod;
        }
        dfs2(0, -1);
        ll ans = 0;
        for (int v = 0; v < n; ++v) {
            ans = (ans + val[v]) % mod;
        }
        cout << ans << '\n';
    }
    return 0;
}

