#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <algorithm>
#include <map>
#include <string>
#include <numeric>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <queue>
#include <cassert>

using namespace std;

using ll = int;
using ld = long double;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;
template <typename... T>
using tup = tuple<T...>;

constexpr ll MOD = 998244353;

template <typename A, typename B>
inline istream& operator>> (istream& in, pa<A, B>& p);

template <typename T>
inline istream& operator>> (istream& in, v<T>& a) {
	for (T& t : a) {
		in >> t;
	}
	return in;
}

template <typename A, typename B>
inline istream& operator>> (istream& in, pa<A, B>& p) {
	return in >> p.first >> p.second;
}

ll SQRT_C = 317;

inline void solve() {
	ll n;
	cin >> n;
	v<ll> a(n);
	cin >> a;
	ll mares = 0;
	v<ll> cnts((ll)2e8 + 3);
	for (ll i = 0; i < n; ++i) {
		v<ll> deltas;
		deltas.reserve(2 * SQRT_C);
		for (ll j = i + 1; j < min(n, i + 2 * SQRT_C); ++j) {
			ll cad = a[j] - a[i];
			if (cad > 0 && cad % (j - i) == 0) {
				ll cd = cad / (j - i);
				++cnts[cd];
				deltas.push_back(cd);
			}
		}
		for (ll d : deltas) {
			mares = max(mares, cnts[d] + 1);
			cnts[d] = 0;
		}
	}
	for (ll delta = 0; delta <= 2 * SQRT_C; ++delta) {
		for (ll i = 0; i < n; ++i) {
			ll cx = a[i] - i * delta;
			mares = max(mares, ++cnts[cx + (ll)1e8]);
		}
		for (ll i = 0; i < n; ++i) {
			ll cx = a[i] - i * delta;
			cnts[cx + (ll)1e8] = 0;
		}
	}
	reverse(a.begin(), a.end());
	for (ll i = 0; i < n; ++i) {
		v<ll> deltas;
		deltas.reserve(2 * SQRT_C);
		for (ll j = i + 1; j < min(n, i + 2 * SQRT_C); ++j) {
			ll cad = a[j] - a[i];
			if (cad > 0 && cad % (j - i) == 0) {
				ll cd = cad / (j - i);
				++cnts[cd];
				deltas.push_back(cd);
			}
		}
		for (ll d : deltas) {
			mares = max(mares, cnts[d] + 1);
			cnts[d] = 0;
		}
	}
	for (ll delta = 0; delta <= 2 * SQRT_C; ++delta) {
		for (ll i = 0; i < n; ++i) {
			ll cx = a[i] - i * delta;
			mares = max(mares, ++cnts[cx + (ll)1e8]);
		}
		for (ll i = 0; i < n; ++i) {
			ll cx = a[i] - i * delta;
			cnts[cx + (ll)1e8] = 0;
		}
	}
	cout << (n - mares) << '\n';
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	//cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}