#include <iostream>
#include <vector>
using namespace std;
struct info
{
    int to, num, dnum;
};
int euclid(int a, int b)
{
    if (!b)
    {
        return a;
    }
    return euclid(b, a % b);
}
void dfs(int u, pair<int, int> edge, vector<int>& cur, vector<int>& maxs, vector<int>& lowest_prime, vector<vector<info>>& graph, int prev = -1)
{
    vector<int> m, p;
    if (edge.first)
    {
        while (edge.first > 1)
        {
            cur[lowest_prime[edge.first]]--;
            m.push_back(lowest_prime[edge.first]);
            edge.first /= lowest_prime[edge.first];
        }
        while (edge.second > 1)
        {
            cur[lowest_prime[edge.second]]++;
            maxs[lowest_prime[edge.second]] = max(maxs[lowest_prime[edge.second]], cur[lowest_prime[edge.second]]);
            p.push_back(lowest_prime[edge.second]);
            edge.second /= lowest_prime[edge.second];
        }
    }
    for (auto el : graph[u])
    {
        if (el.to != prev)
        {
            dfs(el.to, {el.num, el.dnum}, cur, maxs, lowest_prime, graph, u);
        }
    }
    for (int i = 0; i < m.size(); i++)
    {
        cur[m[i]]++;
    }
    for (int i = 0; i < p.size(); i++)
    {
        cur[p[i]]--;
    }
}
int add(int a, int b, int mod)
{
    a += b;
    return (a >= mod ? a - mod : a);
}
int mul(long long a, long long b, long long mod)
{
    a *= b;
    return (a >= mod ? a % mod : a);
}
int binpow(int base, int indicator, int mod)
{
    int res = 1;
    while (indicator)
    {
        if (indicator & 1)
        {
            res = mul(res, base, mod);
        }
        base = mul(base, base, mod);
        indicator >>= 1;
    }
    return res;
}
void get_ans(int u, int mod, int lcm, int& ans, pair<int, int> edge, vector<vector<info>>& graph, int prev = -1)
{
    ans = add(ans, mul(lcm, mul(edge.first, binpow(edge.second, mod - 2, mod), mod), mod), mod);
    for (auto el : graph[u])
    {
        if (el.to != prev)
        {
            get_ans(el.to, mod, lcm, ans, {mul(el.num, edge.first, mod), mul(el.dnum, edge.second, mod)}, graph, u);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    const int mod = 998244353;
    int t;
    vector<int> lowest_prime(200001, 1e9);
    for (int i = 2; i <= 200000; i++)
    {
        for (int j = i; j <= 200000; j += i)
        {
            lowest_prime[j] = min(lowest_prime[j], i);
        }
    }
    cin >> t;
    while (t--)
    {
        int n, lcm = 1, ans = 0;
        cin >> n;
        vector<int> cur(n + 1), maxs(n + 1);
        vector<vector<info>> graph(n);
        for (int k = 0; k < n - 1; k++)
        {
            int i, j, x, y, gcd;
            cin >> i >> j >> x >> y;
            i--, j--;
            gcd = euclid(x, y);
            x /= gcd, y /= gcd;
            graph[i].push_back({j, y, x});
            graph[j].push_back({i, x, y});
        }
        dfs(0, {0, 0}, cur, maxs, lowest_prime, graph);
        for (int i = 2; i <= n; i++)
        {
            if (maxs[i])
            {
                lcm = mul(lcm, binpow(i, maxs[i], mod), mod);
            }
        }
        get_ans(0, mod, lcm, ans, {1, 1}, graph);
        cout << ans << '\n';
    }
}
