﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <string>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <random>
#include <algorithm>
#include <time.h>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair<ll, ll> pii;

mt19937 rng(time(0));

#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define pb push_back
#define eb emplace_back
#define Sum(x) accumulate(All(x), 0ll)
#define X first
#define Y second

const ll INF = 1e9 + 5;
const ll mod = 998244353;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

ll add(ll a, ll b) {
    return (a + b) % mod;
}

ll binpow(ll a, ll k) {
    if (k == 0) return 1;
    if (k & 1) return mul(a, binpow(a, k - 1));
    ll p = binpow(a, k >> 1);
    return mul(p, p);
}

ll rev(ll x) {
    return binpow(x, mod - 2);
}

#define triple tuple<ll, ll, ll>

vector<vector<triple>> gr;
vector<ll> p, q, ans, f, g;
ll p_pr = 1, q_pr = 1;

const ll MAXN = 2e5 + 5;

ll pr[MAXN];

void multiply(ll v) {
    while (v > 1) {
        ll cur = pr[v];
        p[cur]++;
        p_pr = mul(p_pr, cur);
        if (q[cur] > 0) {
            ll r = rev(cur);
            p_pr = mul(p_pr, r);
            q_pr = mul(q_pr, r);
            p[cur]--;
            q[cur]--;
        }
        v /= cur;
    }
}

void divide(ll v) {
    while (v > 1) {
        ll cur = pr[v];
        q[cur]++;
        q_pr = mul(q_pr, cur);
        if (p[cur] > 0) {
            ll r = rev(cur);
            p_pr = mul(p_pr, r);
            q_pr = mul(q_pr, r);
            p[cur]--;
            q[cur]--;
        }
        ans[cur] = max(ans[cur], q[cur]);
        v /= cur;
    }
}

void dfs(ll v, ll parent = -1) {
    ll u, x, y;
    f[v] = p_pr;
    g[v] = q_pr;
    for (auto &e : gr[v]) {
        tie(u, x, y) = e;
        if (u == parent) continue;
        multiply(y);
        divide(x);
        dfs(u, v);
        multiply(x);
        divide(y);
    }
}

void solve() {
    ll overall = 0, divisor = 1;
    int n, v, u, x, y;
    cin >> n;
    gr.resize(n);
    f.resize(n);
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> v >> u >> x >> y;
        v--, u--;
        gr[v].push_back({ u, x, y });
        gr[u].push_back({ v,y,x });
    }
    p.resize(n + 1);
    q.resize(n + 1);
    ans.assign(n + 1, 0);
    dfs(0);
    for (int i = 2; i <= n; i++) {
        if (ans[i] == 0) continue;
        divisor = mul(divisor, binpow(i, ans[i]));
    }
    for (int v = 0; v < n; v++) {
        overall = add(overall, mul(f[v], mul(divisor, rev(g[v]))));
    }
    cout << overall << '\n';
}

void precalc() {
    memset(pr, -1, sizeof pr);
    pr[1] = 1;
    for (ll i = 2; i < MAXN; i++) {
        if (pr[i] != -1) continue;
        pr[i] = i;
        for(ll j = 1ll * i * i; j < MAXN; j+=i){
            pr[j] = (pr[j] == -1 ? i : pr[j]);
        }
    }
}

void reset() {
    gr.clear();
    p.clear();
    q.clear();
    ans.clear();
    f.clear();
    g.clear();
    p_pr = 1, q_pr = 1;
}

signed main()
{
    precalc();

    ll t = 1;
    cin >> t;
    while (t--) {
        reset();
        solve();
    }
}
