#include <bits/stdc++.h>
#define int long long

using namespace std;

struct edge{
    int u, x, y;
};

const int maxn = 2e5;

vector < vector <edge> > g(maxn, vector <edge> ());
vector <int> d[maxn + 1];
int res[maxn + 1], cnt[maxn + 1];

const int mod = 998244353;

void dfs(int v, int p) {
    for (auto [u, x, y] : g[v]) {
        if (u != p) {
            for (auto c : d[y]) {
                cnt[c]--;
            }
            for (auto c : d[x]) {
                cnt[c]++;
                res[c] = max(cnt[c], res[c]);
            }
            dfs(u, v);
            for (auto c : d[x]) {
                cnt[c]--;
            }
            for (auto c : d[y]) {
                cnt[c]++;
            }
        }
    }
}

int binpow(int a, int p) {
    if (p == 0) return 1;
    if (p & 1) {
        return binpow(a * a % mod, p / 2) * a % mod;
    }
    return binpow(a * a % mod, p / 2);
}

int an = 0;

void calc(int v, int p, int val) {
    an += val;
    if (an >= mod) an -= mod;
    for (auto [u, x, y] : g[v]) {
        if (u != p) {
            val *= y; val %= mod;
            val *= binpow(x, mod - 2); val %= mod;
            calc(u, v, val);
            val *= x; val %= mod;
            val *= binpow(y, mod - 2); val %= mod;
        }
    }
}

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; ++i) {
        int v, u, x, y; cin >> v >> u >> x >> y;
        v--; u--;
        g[v].push_back({u, x, y});
        g[u].push_back({v, y, x});
    }
    dfs(0, -1);
    int mi = 1;
    for (int i = 1; i <= n; ++i) {
        while (res[i] > 0) {
            mi *= i;
            mi %= mod;
            res[i]--;
        }
    }
    an = 0;
    calc(0, -1, mi);
    cout << an << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    for (int i = 2; i <= maxn; ++i) {
        if (d[i].size() == 0) {
            for (int j = i; j <= maxn; j += i) {
                int cj = j;
                while (cj % i == 0) {
                    d[j].push_back(i);
                    cj /= i;
                }
            }
        }
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
