#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <string>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 3e5;
const int mod = 998244353;

int pr[N];

struct E
{
	int to;
	int x, y;
};

vector<E> e[N];

int maxp[N];
int nowp[N];

void np(int x, int ch)
{
	while (x != 1)
	{
		nowp[pr[x]] += ch;
		maxp[pr[x]] = max(maxp[pr[x]], -nowp[pr[x]]);
		x /= pr[x];
	}
}

void dfsz(int i, int p = -1)
{
	for (E j : e[i])
	{
		if (j.to != p)
		{
			np(j.x, 1);
			np(j.y, -1);
			dfsz(j.to, i);
			np(j.y, 1);
			np(j.x, -1);
		}
	}
}

struct mint
{
	int x;
	mint() {}
	mint(int a) :x(a) {}
	friend mint operator+= (mint & a, mint b)
	{
		a.x += b.x;
		if (a.x >= mod)
		{
			a.x -= mod;
		}
		return a;
	}
	friend mint operator+(mint a, mint b)
	{
		return a += b;
	}
	friend mint operator*=(mint& a, mint b)
	{
		a.x *= b.x;
		a.x %= mod;
		return a;
	}
	friend mint operator*(mint a, mint b)
	{
		return a *= b;
	}
	friend mint operator%(mint a, int b)
	{
		mint ans = 1;
		mint now = a;
		while (b)
		{
			if (b & 1)
				ans *= now;
			now *= now;
			b >>= 1;
		}
		return ans;
	}
};

mint ans;
mint mul;

mint o[N];

void f(int x, bool fl)
{
	while (x != 1)
	{
		if (fl)
		{
			mul *= pr[x];
		}
		else
		{
			mul *= o[pr[x]];
		}
		x /= pr[x];
	}
}

void dfsans(int i, int p = -1)
{
	ans += mul;
	for (E j : e[i])
	{
		if (j.to != p)
		{
			f(j.x, 1);
			f(j.y, 0);
			dfsans(j.to, i);
			f(j.y, 1);
			f(j.x, 0);
		}
	}
}

signed main()
{
#ifdef _CONSOLE
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	for (int i = 2; i < N; i++)
	{
		if (!pr[i])
		{
			for (int j = i * i; j < N; j += i)
			{
				pr[j] = i;
			}
			pr[i] = i;
		}
	}
	for (int i = 2; i < N; i++)
	{
		if (pr[i] == i)
		{
			o[i] = (mint(i) % (mod - 2));
		}
	}
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		fill(maxp, maxp + n + 5, 0);
		fill(nowp, nowp + n + 5, 0);
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
		}
		for (int i = 0; i < n - 1; i++)
		{
			int a, b, x, y;
			cin >> a >> b >> x >> y;
			a--;
			b--;
			e[a].push_back({ b,y,x });
			e[b].push_back({ a,x,y });
		}
		dfsz(0);
		ans = 0;
		mul = 1;
		for (int i = 1; i <= n; i++)
		{
			mul *= (mint(i) % maxp[i]);
		}
		dfsans(0);
		cout << ans.x << endl;
	}
}