#include "bits/stdc++.h"
using namespace std;

#define ar array
#define int long long

const int N = 2e5 + 5;
const int mod = (119 << 23) + 1;
vector<ar<int, 3>> edges[N];

int bp(int a, int b){
	int r=1;
	while(b){
		if(b&1) r = r * 1ll * a % mod;
		a = a * 1ll * a % mod, b >>= 1;
	} return r;
}

void solve(){
	int n; cin>>n;
	
	vector<int> inv(n + 1), a(n + 1);
	for(int i=1;i<=n;i++){
		inv[i] = bp(i, mod - 2);
	}
	vector<vector<int>> p(n + 1), c(n + 1);
	for(int i=2;i<=n;i++){
		if(!p[i].empty()) continue;
		for(int j=i;j<=n;j+=i){
			p[j].push_back(i);
		}
	}
	
	for(int i=2;i<=n;i++){
		int x = i;
		for(auto v : p[i]){
			c[i].push_back(0);
			while(x % v == 0) c[i].back()++, x /= v;
		}
	}
	
	for(int i=1;i<n;i++){
		int a, b; cin>>a>>b;
		int x, y; cin>>x>>y;
		int g = __gcd(x, y); x /= g, y /= g;
		edges[a].push_back({b, x, y});
		edges[b].push_back({a, y, x});
	}
	
	vector<int> used(n + 1), tot(n + 1), cur(n + 1), tmp;
	set<int> tt;
	function<void(int)> dfs = [&](int u){
		tmp.push_back(u), used[u] = 1;
		for(auto x : edges[u]){
			if(used[x[0]]) continue;
			for(int j=0;j<(int)p[x[2]].size();j++){
				cur[p[x[2]][j]] -= c[x[2]][j];
			} for(int j=0;j<(int)p[x[1]].size();j++){
				tt.insert(p[x[1]][j]);
				cur[p[x[1]][j]] += c[x[1]][j];
				tot[p[x[1]][j]] = max(tot[p[x[1]][j]], cur[p[x[1]][j]]);
			}
 			
			dfs(x[0]);
			for(int j=0;j<(int)p[x[1]].size();j++){
				cur[p[x[1]][j]] -= c[x[1]][j];
			} for(int j=0;j<(int)p[x[2]].size();j++){
				cur[p[x[2]][j]] += c[x[2]][j];
			}
		}
	};
	
	function<void(int)> rdfs = [&](int u){
		used[u] = 1;
		for(auto x : edges[u]){
			if(used[x[0]]) continue;
			a[x[0]] = a[u] * 1ll * x[2] % mod * inv[x[1]] % mod;
			rdfs(x[0]);
		}
	};
	// cout<<"here"<<endl;
	for(int i=1;i<=n;i++){
		if(used[i]) continue;
		tmp.clear(), tt.clear();
		dfs(i);
		int v = 1;
		for(auto x : tt){
			//~ cout<<x<<" "<<tot[x]<<"\n";
			v = v * 1ll * bp(x, tot[x]) % mod;
			tot[x] = 0;
		}
		for(auto x : tmp) used[x] = 0;
		a[i] = v;
		rdfs(i);
	}
	
	int res = 0;
	for(int i=1;i<=n;i++) res = (res + a[i]) % mod, edges[i].clear();
	cout<<res<<"\n";
}

signed main(){
	ios::sync_with_stdio(0); cin.tie(0);
	
	int t; cin>>t;
	while(t--){
		solve();
	}
	
	return 0;
}
