// ConsoleApplication1.cpp : Defines the entry point for the console application.
//
#define _CRT_SECURE_NO_WARNINGS
//#include "stdafx.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cassert>
#include <bitset>
#include <algorithm>

#define int long long
using namespace std;

using vi = vector<int>;
using db = double;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define rep(n) for (int i = 0; i < n; i++)
#define print(a) for (int i = 0; i < a.size(); i++) cout << a[i] << " ";
#define mp make_pair;

const int MOD = 1e9 + 7;
const int INF = 1e18 + 2;

int gcd(int a, int b) {
	while (a && b) {
		if (a > b) a %= b;
		else b %= a;
	}
	return max(a, b);
}

int binpow(int a, int p, int mod) {
	if (!p) return 1;
	if (p & 1) return a * binpow(a, p - 1, mod) % mod;
	int x = binpow(a, p >> 1, mod);
	return x * x % mod;
}

void solve() {
	int n; cin >> n;
	map<int, int> cnt;
	int w = 0;
	rep(n) {
		int x; cin >> x;
		cnt[x]++;
		w += x;
	}
	vi a(1, w);
	int steps = 0;
	while (steps < n - 1) {
		if (cnt[a.back()] > 0) {
			cnt[a.back()]--;
			a.pop_back();
		}
		else {
			int w1 = a.back() / 2;
			int w2 = (a.back() + 1) / 2;
			a.pop_back();
			a.push_back(w1);
			a.push_back(w2);
			steps++;
		}
	}
	for (auto& x : a) {
		if (cnt[x] == 0) {
			cout << "NO\n";
			return;
		}
		cnt[x]--;
	}
	for (auto& p : cnt) {
		if (p.second > 0) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t; cin >> t;
	while (t--)
		solve();

    return 0;
}

