// ConsoleApplication1.cpp : Defines the entry point for the console application.
//
#define _CRT_SECURE_NO_WARNINGS
//#include "stdafx.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cassert>
#include <bitset>
#include <algorithm>

#define int long long
using namespace std;

using vi = vector<int>;
using db = double;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define rep(n) for (int i = 0; i < n; i++)
#define print(a) for (int i = 0; i < a.size(); i++) cout << a[i] << " ";
#define mp make_pair;

const int MOD = 998244353; //1e9 + 7;
const int INF = 1e18 + 2;

int gcd(int a, int b) {
	while (a && b) {
		if (a > b) a %= b;
		else b %= a;
	}
	return max(a, b);
}

int binpow(int a, int p, int mod) {
	if (!p) return 1;
	if (p & 1) return a * binpow(a, p - 1, mod) % mod;
	int x = binpow(a, p >> 1, mod);
	return x * x % mod;
}

const int N = 2e5 + 2;

struct To {
	int a, x, y;
	bool dir;
	
	To() : a(0), x(0), y(0) {}
	To(int A, int X, int Y, bool DIR) : a(A), x(X), y(Y), dir(DIR) {}
};
vector<To> graph[N];
int a1[N], xx[N], yy[N];
vi factor[N];
bool is_prime[N];
int res = 0;

void precalc() {
	for (int i = 0; i < N; i++) is_prime[i] = true;
	for (int i = 2; i < N; i++) {
		if (is_prime[i]) {
			for (int j =  i * i; j < N; j += i) {
				is_prime[j] = false;
			}
			for (int j = i; j < N; j += i) {
				int val = j;
				while (val % i == 0) {
					factor[j].push_back(i);
					val /= i;
				}
			}
		}
	}
}

void dfs1(int v, int p = -1) {
	for (auto& toto : graph[v]) {
		int to = toto.a;
		if (to == p) continue;
		int x = toto.x, y = toto.y;
		if (toto.dir) swap(x, y);
		for (auto& px : factor[x]) xx[px]++;
		for (auto& py : factor[y]) yy[py]++;
		for (auto& px : factor[x]) {
			int need = max(0ll, yy[px] - xx[px] - a1[px]);
			a1[px] += need;
		}
		for (auto& py : factor[y]) {
			int need = max(0ll, yy[py] - xx[py] - a1[py]);
			a1[py] += need;
		}
		dfs1(to, v);
		for (auto& px : factor[x]) xx[px]--;
		for (auto& py : factor[y]) yy[py]--;
	}
}

void dfs2(int v, int p, int val) {
	res = (res + val) % MOD;
	for (auto& toto : graph[v]) {
		int to = toto.a;
		if (to == p) continue;
		int x = toto.x, y = toto.y;
		if (toto.dir) swap(x, y);
		int nxt = val;
		nxt = (nxt * x) % MOD;
		nxt = (nxt * binpow(y, MOD - 2, MOD)) % MOD;
		dfs2(to, v, nxt);
	}
}

void solve() {
	int n; cin >> n;
	rep(n  -1) {
		int a, b, x, y; cin >> a >> b >> x >> y;
		graph[a].push_back(To(b, x, y, true));
		graph[b].push_back(To(a, x, y, false));
	}
	dfs1(1);
	int first = 1;
	rep(n + 1) {
		first = (first * binpow(i, a1[i], MOD)) % MOD;
	}
	dfs2(1, -1, first);
	cout << res << "\n";
	res = 0;
	rep(n + 1) {
		a1[i] = xx[i] = yy[i] = 0;
		graph[i].clear();
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	precalc();

	int t; cin >> t;
	while (t--)
		solve();

    return 0;
}

