#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 3, mod = 998244353;

vector <pair <int, pair <int, int> > > g[maxn];
int dv[maxn];

void build() {
    for (int i = 2; i * i < maxn; i++) {
        if (!dv[i]) {
            for (int j = i * i; j < maxn; j += i) {
                if (!dv[j]) {
                    dv[j] = i;
                }
            }
        }
    }
}

void fact(int x, vector <pair <int, int> >& f) {
    while (dv[x]) {
        int curr = dv[x], k = 0;
        while (dv[x] == curr) {
            k++;
            x /= dv[x];
        }
        f.push_back({curr, k});
    }
    if (x > 1) {
        f.push_back({x, 1});
    }
}

int bp(int x, int y) {
    if (y == 0) {
        return 1;
    }
    if (y % 2 == 0) {
        int curr = bp(x, y >> 1);
        return curr * 1ll * curr % mod;
    } else {
        return bp(x, y - 1) * 1ll * x % mod;
    }
}

int inv(int x) {
    return bp(x, mod - 2);
}

int dop_mul[maxn], root[maxn];

void dfs(int v, int p = -1) {
    for (auto i : g[v]) {
        int to = i.first, x = i.second.first, y = i.second.second;
        if (to == p) {
            continue;
        }
        vector <pair <int, int> > f_x, f_y;
        fact(x, f_x);
        fact(y, f_y);
        for (pair <int, int> v : f_x) {
            dop_mul[v.first] += v.second;
        }
        for (pair <int, int> v : f_y) {
            dop_mul[v.first] -= v.second;
            if (root[v.first] + dop_mul[v.first] < 0) {
                root[v.first] += -(root[v.first] + dop_mul[v.first]);
            }
        }
        dfs(to, v);
        for (pair <int, int> v : f_x) {
            dop_mul[v.first] -= v.second;
        }
         for (pair <int, int> v : f_y) {
            dop_mul[v.first] += v.second;
         }
    }
}

int calc(int v, int curr, int p = -1) {
    int ans = curr;
    for (auto i : g[v]) {
        int to = i.first, x = i.second.first, y = i.second.second;
        if (to == p) {
            continue;
        }
        ans += calc(to, curr * 1ll * x % mod * inv(y) % mod, v);
        ans %= mod;
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    build();

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int i = 0; i <= n; i++) {
            g[i].resize(0);
            dop_mul[i] = 0;
            root[i] = 0;
        }
        for (int it = 0; it < n - 1; it++) {
            int i, j, x, y;
            cin >> i >> j >> y >> x;
            if (i > j) {
                swap(i, j);
                swap(x, y);
            }
            g[i].push_back({j, {x, y}});
            g[j].push_back({i, {y, x}});
        }
        dfs(1);
        int root_val = 1;
        for (int i = 2; i <= n; i++) {
            for (int j = 0; j < root[i]; j++) {
                root_val = root_val * 1ll * i % mod;
            }
        }
        cout << calc(1, root_val) << "\n";
    }
    return 0;
}
