#include <bits/stdc++.h>
using namespace std;

const int mod = 998244353;

int gcd(int a, int b) {
    if (a < b) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a % b);
}

long long fast_pow(int a, int n) {
    if (n < 0) {
        cout << "CRINGE";
        return 0;
    }
    if (n == 0) return 1;
    if (n % 2) return ((long long)fast_pow(a, n - 1) * a) % mod;
    long long half = fast_pow(a, n / 2);
    return (half * half) % mod;
}

struct edge {
    int x, y, to;
    edge(int x, int y, int to) : x(x), y(y), to(to) {}
};

vector<vector<edge>> graph;

vector<int> already_div;
vector<int> max_div;

vector<int> sieve;
int n;


vector<int> curr_gcd;
vector<long long> ans;

void dfs_ans(int v, int p = -1, int x = -1, int y = -1) {
    vector<int> new_x_divs;
    vector<int> new_y_divs;
    if (p != -1) {
        int tmp_x = x;
        int tmp_y = y;
        while (tmp_x > 1) {
            new_x_divs.push_back(sieve[tmp_x]);
            tmp_x /= sieve[tmp_x];
        }
        while (tmp_y > 1) {
            new_y_divs.push_back(sieve[tmp_y]);
            tmp_y /= sieve[tmp_y];
        }
        long long div = 1;
        long long mul = 1;
        for (int i : new_y_divs) {
            mul *= i;
            mul %= mod;
            already_div[i]++;
        }
        for (int i : new_x_divs) {
            div *= i;
            div %= mod;
            already_div[i]--;
            if (curr_gcd[i] > already_div[i]) curr_gcd[i] = already_div[i];
        }
        mul *= fast_pow(div, mod - 2);
        mul %= mod;
        ans[v] = (ans[p] * mul) % mod;
    }
    for (auto e : graph[v]) {
        if (e.to == p) continue; 
        dfs_ans(e.to, v, e.x, e.y);
    }
    if (p != -1) {
        for (int i : new_x_divs) {
            already_div[i]++;
        }
        for (int i : new_y_divs) {
            already_div[i]--;
        }
    }
}


// void dfs_ans

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int useless = 0; useless < t; useless++) {
        cin >> n;
        sieve.assign(n + 1, -1);
        vector<int> p;
        already_div.assign(n + 1, 0);
        for (int i = 2; i <= n; i++) {
            if (sieve[i] == -1) {
                sieve[i] = i;
                p.push_back(i);
            }
            for (int pr : p) {
                // cout << pr << " " << i << "\n";
                if (pr > sieve[i]) break; 
                if ((long long)pr * i > n) break; 
                sieve[pr * i] = pr;
            }
        }
        // for (int i : sieve) cout << i << " ";
        // cout << "\n";
        graph.assign(n, vector<edge>());
        for (int i = 0; i < n - 1; i++) {
            int a, b, x, y;
            cin >> a >> b >> x >> y;
            int g = gcd(x, y);
            x /= g;
            y /= g;
            graph[a - 1].push_back(edge(x, y, b - 1));
            graph[b - 1].push_back(edge(y, x, a - 1));
            while (x > 1) {
                already_div[sieve[x]]++;
                x /= sieve[x];
            }
            while (y > 1) {
                already_div[sieve[y]]++;
                y /= sieve[y];
            }
        }
        curr_gcd = already_div;
        // dfs_ans(0);
        ans.assign(n, 1);
        for (int i = 1; i <= n; i++) {
            ans[0] *= fast_pow(i, already_div[i]);
            ans[0] %= mod;
        }
        dfs_ans(0);
        long long fin = 0;
        for (int i : ans) {
            fin += i;
            fin %= mod;
        }
        long long div = 1;
        for (int i = 1; i <= n; i++) {
            div *= fast_pow(i, curr_gcd[i]);
            div %= mod;
        }
        div = fast_pow(div, mod - 2);
        fin *= div;
        fin %= mod;
        cout << fin << "\n";
    }
}