#include <bits/stdc++.h>

using namespace std;

//#define int long long
typedef long long ll;
const ll MOD = 998244353;

struct Edge {
  int u, x, y;
};

vector<vector<Edge>> graph;
vector<char> used;
int sm = 0;

int binpow(ll x, int p) {
  ll res = 1;
  while (p > 0) {
    if (p & 1)
      res = res * x % MOD;
    x = x * x % MOD;
    p >>= 1;
  }
  return res;
}

int inv(int x) {
  return binpow(x, MOD - 2);
}

void dfs(int v, int xx, int yy, map<int, int> &nok, map<int, int> &yxrazl) {
  used[v] = 1;
  int mul = xx * 1ll * inv(yy) % MOD;
  sm += mul;
  if (sm >= MOD)
    sm -= MOD;
  for (auto &e : graph[v]) {
    int u = e.u;
    if (used[u])
      continue;
    int nxx = xx * 1ll * e.y % MOD;
    int nyy = yy * 1ll * e.x % MOD;

    vector<pair<int, int>> old;
    {
      int val = e.y;
      for (int d = 2; d * d <= val; ++d) {
        if (val % d != 0)
          continue;
        int cnt = 0;
        while (val % d == 0) {
          val /= d;
          cnt++;
        }
        if (yxrazl.count(d) == 0) {
          old.emplace_back(d, 0);
          yxrazl[d] = -cnt;
        } else {
          old.emplace_back(d, yxrazl[d]);
          yxrazl[d] += -cnt;
        }
        if (nok.count(d) == 0) {
          if (yxrazl[d] > 0)
            nok[d] = yxrazl[d];
        } else
          nok[d] = max(nok[d], yxrazl[d]);
      }
      if (val > 1) {
        int d = val;
        int cnt = 1;
        if (yxrazl.count(d) == 0) {
          old.emplace_back(d, 0);
          yxrazl[d] = -cnt;
        } else {
          old.emplace_back(d, yxrazl[d]);
          yxrazl[d] += -cnt;
        }
        if (nok.count(d) == 0) {
          if (yxrazl[d] > 0)
            nok[d] = yxrazl[d];
        } else
          nok[d] = max(nok[d], yxrazl[d]);
      }
    }
    {
      int val = e.x;
      for (int d = 2; d * d <= val; ++d) {
        if (val % d != 0)
          continue;
        int cnt = 0;
        while (val % d == 0) {
          val /= d;
          cnt++;
        }
        if (yxrazl.count(d) == 0) {
          old.emplace_back(d, 0);
          yxrazl[d] = cnt;
        } else {
          old.emplace_back(d, yxrazl[d]);
          yxrazl[d] += cnt;
        }
        if (nok.count(d) == 0)
          nok[d] = yxrazl[d];
        else
          nok[d] = max(nok[d], yxrazl[d]);
      }
      if (val > 1) {
        int d = val;
        int cnt = 1;
        if (yxrazl.count(d) == 0) {
          old.emplace_back(d, 0);
          yxrazl[d] = cnt;
        } else {
          old.emplace_back(d, yxrazl[d]);
          yxrazl[d] += cnt;
        }
        if (nok.count(d) == 0)
          nok[d] = yxrazl[d];
        else
          nok[d] = max(nok[d], yxrazl[d]);
      }
    }

    dfs(u, nxx, nyy, nok, yxrazl);

    reverse(old.begin(), old.end());
    for (auto[a, b] : old) {
      if (b == 0)
        yxrazl.erase(a);
      else
        yxrazl[a] = b;
    }
  }
}

void solve() {
  int n;
  cin >> n;
  graph.clear();
  graph.resize(n);
  for (int i = 0; i < n - 1; ++i) {
    int v, u, x, y;
    cin >> v >> u >> x >> y;
    v--, u--;
    graph[v].push_back({u, x, y});
    graph[u].push_back({v, y, x});
  }
  used.assign(n, 0);
  sm = 0;
  map<int, int> nok;
  map<int, int> yxrazl;
  dfs(0, 1, 1, nok, yxrazl);
  for (auto[d, cnt] : nok) {
    sm = sm * 1ll * binpow(d, cnt) % MOD;
  }
  cout << sm;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t = 1;
  cin >> t;
  while (t--) {
    solve();
    cout << '\n';
  }
}