//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,popcnt,lzcnt")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <climits>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

template<class A>
void print(A x) {
  cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
  cerr << '(' << x.first << ' ' << x.second << ')';
}
template<class A>
void print(set<A> x) {
  for (A el : x) {
    print(el);
    cerr << ' ';
  }
  cerr << '\n';
}
template<class A>
void print(multiset<A> x) {
  for (A el : x) {
    print(el);
    cerr << ' ';
  }
  cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
  for (A el : x) {
    print(el);
    cerr << ' ';
  }
  cerr << '\n';
}
template<class A>
void print(vector<A> x) {
  for (A el : x) {
    print(el);
    cerr << ' ';
  }
  cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
  for (pair<A, B> el : x) {
    print(el);
    cerr << ' ';
  }
  cerr << '\n';
}

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

mt19937 rnd(time(0));
const int INF = int(1e9) + 7;

#ifdef DESPAIR_101
int __lg(ll x) {
  int i = 0;
  while (i <= 62 && (1ll << i) <= x) ++i;
  return i - 1;
}
#endif

ll binPow(ll a, ll n, ll m) {
  if (n == 0) return 1;
  if (n & 1) return a * binPow(a, n - 1, m) % m;
  return binPow(a * a % m, n / 2, m) % m;
}

void solve() {
  int n;
  cin >> n;

  vector<ll> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }

  sort(a.begin(), a.end());
  cout << a[n - 2] + a[n - 1] << '\n';
}

signed main() {
  cin.tie(nullptr)->ios::sync_with_stdio(false);
  cout << fixed << setprecision(20);

  int te = 1;
  cin >> te;
  for (int t = 1; t <= te; ++t) {
    cerr << "_____ TEST #" << t << " _____\n";
    solve();
  }
}