#include <bits/stdc++.h>

std::vector<int> lp, pr;
const int N = 2e5+5;
void precalc() {
    lp.assign(N, 0);
    pr = {};
    for (int i = 2; i < N; ++i) {
        if (lp[i] == 0) {
            lp[i] = i;
            pr.emplace_back(i);
        }
        for (int j = 0; j < pr.size() && pr[j] <= lp[i] && i * pr[j] < N; ++j)
            lp[i * pr[j]] = pr[j];
    }
}

const int64_t P = 998244353;
int64_t add(int64_t a, int64_t b) {
    return a + b >= P ? a + b - P : a + b;
}
int64_t mul(int64_t a, int64_t b) {
    return a * b % P;
}
int64_t bpow(int64_t a, int64_t n) {
    int64_t res = 1;
    while (n) {
        if (n & 1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}
int64_t inv(int64_t x) {
    return bpow(x, P - 2);
}

struct raz {
    std::map<int, int> m;
    int64_t soot = 1;
    raz() {}
    raz(int x) {
        soot = x;
        while (x != 1) {
            ++m[lp[x]];
            x /= lp[x];
        }
    }
    int64_t get() {
        int64_t res = 1;
        for (auto &[val, ord] : m)
            res = mul(res, bpow(val, ord));
        return soot = res;
    }
    raz& operator*=(int x) {
        soot = mul(soot, x);
        while (x != 1) {
            ++m[lp[x]];
            x /= lp[x];
        }
        return *this;
    }
    raz& operator/=(int x) {
        soot = mul(soot, inv(x));
        while (x != 1) {
            --m[lp[x]];
            x /= lp[x];
        }
        return *this;
    }
};
raz gcd(raz &a, raz &b) {
    if (a.m.size() < b.m.size()) {
        raz res = a;
        for (auto &[val, ord] : res.m) {
            if (b.m[val] < ord) {
                res.soot = mul(res.soot, inv(bpow(val, ord)));
                ord = b.m[val];
                res.soot = mul(res.soot, bpow(val, ord));
            }
        }
        return res;
    } else {
        raz res = b;
        for (auto &[val, ord] : res.m) {
            if (a.m[val] < ord) {
                res.soot = mul(res.soot, inv(bpow(val, ord)));
                ord = a.m[val];
                res.soot = mul(res.soot, bpow(val, ord));
            }
        }
        return res;
    }
}

std::vector<std::vector<std::tuple<int64_t, int64_t, int64_t>>> graph;
std::vector<raz> volume;

int64_t dfs(int v, int p = -1) {
    int res = 1;
    for (auto &[to, ours, others] : graph[v]) {
        if (to == p)
            continue;

        int64_t cur = dfs(to, v);
        volume[v] *= others;
        volume[to] *= ours;
        auto g = gcd(volume[v], volume[to]);

        //int64_t c = std::lcm(volume[v] * others, volume[to] * ours);
        //int64_t l = c / (volume[v] * others), k = c / (volume[to] * ours);
        //volume[v] *= l;
        res = mul(res, mul(volume[to].soot, inv(g.soot)));
        cur = mul(cur, mul(volume[v].soot, inv(g.soot)));
        res = add(res, cur);
        volume[v] /= others;

        if (volume[v].m.size() < volume[to].m.size()) {
            std::swap(volume[v].soot, volume[to].soot);
            volume[v].m.swap(volume[to].m);
        }
        for (auto &[val, ord] : volume[to].m) {
                /*
            if (volume[v].m[val] > ord) {
                int64_t &hsoot = volume[v].soot;
                hsoot = mul(hsoot, inv(bpow(val, volume[v].m[val])));
                hsoot = mul(hsoot, bpow(val, ord));
                volume[v].m[val] = ord;
            }
            */
            volume[v].m[val] += ord;
        }
        volume[v].soot = mul(volume[v].soot, volume[to].soot);
        for (auto &[val, ord] : g.m) {
            volume[v].m[val] -= ord;
        }
        volume[v].soot = mul(volume[v].soot, inv(g.soot));
    }
    return res;
}

void solve() {
    int n;
    std::cin >> n;
    graph.assign(n, std::vector<std::tuple<int64_t, int64_t, int64_t>>(0));
    volume.assign(n, raz());
    for (int ind_e = 0; ind_e < n - 1; ++ind_e) {
        int u, v, x, y;
        std::cin >> u >> v >> x >> y, --u, --v;
        graph[u].emplace_back(v, x, y);
        graph[v].emplace_back(u, y, x);
    }
    std::cout << dfs(0) << "\n";
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0), std::cout.tie(0);
    precalc();
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
