// #define __GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#define int long long
#define real long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define elif else if
#define pi M_PI
#define f first
#define s second
typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;


const int INF = 1e18, MOD = 998244353, RANDOM = chrono::steady_clock::now().time_since_epoch().count();
const real EPS = 1e-12;
mt19937 rng(RANDOM);


int mod(int x){
	if (x >= MOD) return x - MOD;
	if (x < 0) return x + MOD;
	return x;
}


int fastdeg(int x, int d){
	int ans = 1, cur = x;
	while (d){
		if (d & 1) ans = (ans * cur) % MOD;
		d >>= 1;
		cur = (cur * cur) % MOD;
	}
	return ans;
}


vector<pair<int, int>> factorize(int x){
	int m = x, d = 2;
	vector<pair<int, int>> divs;
	while (d * d <= m){
		if (!(m % d)){
			if (divs.empty() or divs.back().f != d) divs.push_back({d, 1});
			else ++divs.back().s;
			m /= d;
		}
		else ++d;
	}
	if (m > 1){
		if (divs.empty() or divs.back().f != m) divs.push_back({m, 1});
		else ++divs.back().s;
	}
	return divs;
}


const int maxn = 2e5 + 100;
int n;
vector<vector<int>> graph[maxn];
int inv[maxn];
int answer[maxn];
int degy[maxn], degx[maxn], lcmm[maxn];


void build(){
	for (int i=1; i<maxn; ++i) inv[i] = fastdeg(i, MOD - 2);
}


void rebuild(vector<pair<int, int>> &divs, vector<pair<int, int>> &divs2){
	for (auto i: divs){
		degy[i.f] += i.s;
	}
	for (auto i: divs2){
		degx[i.f] += i.s;
	}
	for (auto i: divs){
		int d = max(degy[i.f], degx[i.f]);
		d -= degy[i.f];
		lcmm[i.f] = max(lcmm[i.f], d);
	}
	for (auto i: divs2){
		int d = max(degy[i.f], degx[i.f]);
		d -= degy[i.f];
		lcmm[i.f] = max(lcmm[i.f], d);
	}
}


void del(vector<pair<int, int>> &divs, vector<pair<int, int>> &divs2){
	for (auto i: divs){
		degy[i.f] -= i.s;
	}
	for (auto i: divs2){
		degx[i.f] -= i.s;
	}
}


void search(int id, int p, int x, int y){
	answer[id] = ((answer[p] * y) % MOD * inv[x]) % MOD;
}


void dfs(int v, int p){
	for (auto u: graph[v]){
		if (u[0] == p) continue;
		vector<pair<int, int>> divs = factorize(u[2]), divs2 = factorize(u[1]);
		rebuild(divs, divs2);
		dfs(u[0], v);
		del(divs, divs2);
	}
}


void dfs2(int v, int p){
	for (auto u: graph[v]){
		if (u[0] == p) continue;
		search(u[0], v, u[1], u[2]);
		dfs2(u[0], v);
	}
}


void calc(){
	int ans = 1;
	for (int i=2; i<=n; ++i){
		ans = (ans * fastdeg(i, lcmm[i])) % MOD;
	}
	answer[0] = ans;
}


void init(){
	fill(graph, graph + n, vector<vector<int>>());
	fill(degy, degy + n + 1, 0);
	fill(degx, degx + n + 1, 0);
	fill(lcmm, lcmm + n + 1, 0);
}


void debug(){
	cerr << "\n";
	for (int i=0; i<n; ++i) cerr << answer[i] << " ";
	cerr << "\n";
}


signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	int t; cin >> t;
	build();
	while (t--){
		cin >> n;
		init();
		for (int i=0; i<n - 1; ++i){
			int v, u, x, y; cin >> v >> u >> x >> y;
			--v; --u;
			graph[v].push_back({u, x, y});
			graph[u].push_back({v, y, x});
		}
		dfs(0, -1);
		// for (int i=1; i<=n; ++i) cerr << lcmm[i] << " ";
		calc();
		dfs2(0, -1);
		// debug();
		int sum = 0;
		for (int i=0; i<n; ++i) sum = mod(sum + answer[i]);
		cout << sum << "\n";
	}
}