#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double
#define ld long double

typedef tree <
    pair <int, int>,
    null_type,
    less < pair <int, int> >,
    rb_tree_tag,
    tree_order_statistics_node_update
> ordered_set;

struct seg_tree{
    vector <int> t, p;

    void push(int v) {
        t[v * 2] += p[v];
        t[v * 2 + 1] += p[v];
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return -1e18;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

void solve(){
    int n;
    cin >> n;

    vector <int> a(n), suf(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }

    for(int i = n - 2; i >= 0; --i){
        suf[i] = max(suf[i + 1], a[i] + a[i + 1]);
    }

    int otv = 0;
    for(int i = 0; i + 1 < n; ++i){
        otv = max(otv, a[i] + a[i + 1]);
    }

    int mx = 0;
    for(int i = 0; i < n; ++i){
        int mx1 = mx;
        for(int j = i; j + 1 < n; ++j){
            mx1 = max(mx1, a[j] + a[j + 1]);
            int mx2 = 0;
            if(j + 2 < n) {
                mx2 = max(mx1, suf[j + 2]);
            }else{
                mx2 = mx1;
            }

            int mx3 = 0;
            if(i > 0){
                mx3 = max(mx3, a[j + 1] + a[i - 1]);
            }
            if(j + 2 < n){
                mx3 = max(mx3, a[i] + a[j + 2]);
            }

            mx2 = max(mx2, mx3);
            otv = max(otv, mx2);
        }

        if(i > 0) {
            mx = max(mx, a[i] + a[i - 1]);
        }
    }

    cout << otv << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //solve();

    int tests;
    cin >> tests;
    while(tests--){
        solve();
    }
}
