#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double
#define ld long double

typedef tree <
    pair <int, int>,
    null_type,
    less < pair <int, int> >,
    rb_tree_tag,
    tree_order_statistics_node_update
> ordered_set;

struct seg_tree{
    vector <int> t, p;

    void push(int v) {
        t[v * 2] += p[v];
        t[v * 2 + 1] += p[v];
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return -1e18;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

void solve(){
    string s;
    cin >> s;

    vector <int> used(26);
    int n = s.length();
    int pos = 1e18;

    for(int i = n - 1; i >= 0; --i){
        if(!used[s[i] - 'a']){
            used[s[i] - 'a'] = 1;
            pos = i;
        }
    }

    for(int i = pos; i < n; ++i){
        cout << s[i];
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //solve();

    int tests;
    cin >> tests;
    while(tests--){
        solve();
    }
}
