#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double
#define ld long double

typedef tree <
    pair <int, int>,
    null_type,
    less < pair <int, int> >,
    rb_tree_tag,
    tree_order_statistics_node_update
> ordered_set;

const int mod = 998244353;

struct seg_tree{
    vector <int> t, p;

    void push(int v) {
        t[v * 2] += p[v];
        t[v * 2 + 1] += p[v];
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return -1e18;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

struct edge{
    int to, x, y;
};

int binpow(int x, int k){
    if(k == 0){
        return 1;
    }

    int y = binpow(x, k / 2);
    if(k % 2 == 0){
        return (y * y) % mod;
    }else{
        return (((y * y) % mod) * x) % mod;
    }
}

vector < vector <edge> > a;
vector <int> cntx, cnt;
vector < vector < pair <int, int> > > p;
int otv = 0;

void dfs1(int v, int pr){
    for(auto to : a[v]){
        if(to.to != pr){
            for(auto x : p[to.x]){
                cntx[x.first] += x.second;
                cnt[x.first] = max(cnt[x.first], cntx[x.first]);
            }
            for(auto x : p[to.y]){
                cntx[x.first] -= x.second;
            }
            dfs1(to.to, v);
            for(auto x : p[to.x]){
                cntx[x.first] -= x.second;
            }
            for(auto x : p[to.y]){
                cntx[x.first] += x.second;
            }
        }
    }
}

void dfs2(int v, int pr, int kol){
    otv += kol;
    otv %= mod;

    for(auto to : a[v]){
        if(to.to != pr){
            int koln = (((kol * to.y) % mod) * binpow(to.x, mod - 2)) % mod;
            dfs2(to.to, v, koln);
        }
    }
}

void solve(){
    int n;
    cin >> n;

    a.clear();
    cnt.clear();
    cntx.clear();
    otv = 0;

    a.resize(n);
    cnt.resize(n + 1);
    cntx.resize(n + 1);

    for(int i = 0; i < n - 1; ++i){
        int v, u, x, y;
        cin >> v >> u >> x >> y;
        --v; --u;

        int d = gcd(x, y);
        x /= d;
        y /= d;
        a[v].push_back({u, x, y});
        a[u].push_back({v, y, x});
    }

    dfs1(0, -1);

    int nok = 1;
    for(int i = 0; i <= n; ++i){
        nok = (nok * binpow(i, cnt[i])) % mod;
    }

    //cout << nok << " dd" << '\n';

    dfs2(0, -1, nok);

    cout << otv << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //solve();
    int gg = 200020;
    p.resize(gg);
    vector <int> used(gg);
    for(int i = 2; i < gg; ++i){
        if(!used[i]){
            p[i].push_back({i, 1});
            for(int j = 2 * i; j < gg; j += i){
                used[j] = 1;

                int x = j;
                int kol = 0;
                while(x % i == 0){
                    x /= i;
                    kol++;
                }

                p[j].push_back({i, kol});
            }
        }
    }

    int tests;
    cin >> tests;
    while(tests--){
        solve();
    }
}
