#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <unordered_map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1000000007;
const ll MOD2 = 998244353;
#define all(x) x.begin(), x.end()
#define break_(x) {x; return;}

struct num
{
    unordered_map<int, int> a;

    num(int c)
    {
        int i = 2;
        while (i * i <= c)
        {
            if (c % i == 0)
            {
                while (c % i == 0)
                {
                    c /= i;
                    ++a[i];
                }
            }
            ++i;
        }
        if (c != 1) a[c] += 1;
    }

    num(num& A, int c)
    {
        a = A.a;
        int i = 2;
        while (i * i <= c)
        {
            if (c % i == 0)
            {
                while (c % i == 0)
                {
                    c /= i;
                    ++a[i];
                }
            }
            ++i;
        }
        if (c > 1) ++a[c];
    }
};

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

vector<vector<int>> edge;
vector<int> a, b, x, y;

int dl(num& nm, num X)
{
    int ns = 1;
    for (auto p : X.a)
    {
        int A = p.first;
        int B = p.second;
        if (nm.a[A] >= B)
        {
            nm.a[A] -= B;
        }
        else
        {
            B -= nm.a[A];
            nm.a[A] = 0;
            for (int j = 0; j < B; ++j)
                ns *= A;
        }
        if (nm.a[A] == 0) nm.a.erase(A);
    }
    return ns;
}

ll back_to_num(num& a)
{
    ll ans = 1;
    for (auto p : a.a)
        for (int j = 0; j < p.second; ++j)
            ans = (ans * p.first) % MOD2;
    return ans;
}

void nok(num& a, num& b)
{
    for (auto p : b.a)
        a.a[p.first] = max(a.a[p.first], p.second);
}

pair<num, ll> dfs(int u, int p)
{
    vector<pair<num, int>> anss;
    vector<int> X, Y;
    for (int c : edge[u])
    {
        if (c != p)
        {
            int v = a[c];
            if (v != u)
            {
                X.push_back(y[c]);
                Y.push_back(x[c]);
            }
            else
            {
                X.push_back(x[c]);
                Y.push_back(y[c]);
                v = b[c];
            }
            anss.push_back(dfs(v, c));
        }
    }
    if (anss.size() == 0) return { num(1), 1 };
    vector<num> nums;
    for (int i = 0; i < anss.size(); ++i)
    {
        ll ost = dl(anss[i].first, num(Y[i]));
        anss[i].second = (anss[i].second * ost) % MOD2;
        nums.push_back(num(anss[i].first, X[i]));
    }
    num ns = nums[0];
    for (int i = 1; i < anss.size(); ++i)
    {
        nok(ns, nums[i]);
    }
    ll ans = back_to_num(ns);
    for (int i = 0; i < anss.size(); ++i)
    {
        num cp = ns;
        dl(cp, nums[i]);
        ll nm = back_to_num(cp);
        ans = (ans + nm * anss[i].second) % MOD2;
    }
    return { ns, ans };
}

void solve(int test_case)
{
    edge.clear();
    a.clear(); b.clear();
    x.clear(); y.clear();
    int n; cin >> n;
    edge.resize(n);
    a.resize(n - 1); b.resize(n - 1);
    x.resize(n - 1); y.resize(n - 1);
    for (int i = 0; i < n - 1; ++i)
    {
        cin >> a[i] >> b[i] >> x[i] >> y[i];
        --a[i]; --b[i];
        edge[a[i]].push_back(i);
        edge[b[i]].push_back(i);
        int gc = gcd(x[i], y[i]);
        x[i] /= gc;
        y[i] /= gc;
    }
    auto p = dfs(0, -1);
    cout << p.second << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    srand(time(NULL));
    int t = 1; cin >> t;
    for (int i = 0; i < t; ++i) solve(i);
}