#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <unordered_map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

//const ll MOD = 1000000007;
const ll MOD2 = 998244353;
#define all(x) x.begin(), x.end()
#define break_(x) {x; return;}

ll fast_pow(ll a, ll b)
{
    if (b == 0) return 1;
    ll ans = fast_pow(a, b / 2);
    ans = (ans * ans) % MOD2;
    if (b % 2) ans = (ans * a) % MOD2;
    return ans;
}

int resh[200001];

struct num
{
    unordered_map<int, int> a;
    ll nmm;

    num(int c)
    {
        nmm = c;
        while (c > 1)
        {
            ++a[resh[c]];
            c /= resh[c];
        }
    }

    void umn(ll c)
    {
        nmm = (nmm * c) % MOD2;
        while (c > 1)
        {
            ++a[resh[c]];
            c /= resh[c];
        }
    }
};

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

vector<vector<int>> edge;
vector<int> a, b, x, y, sz;

int dl(num* nm, num X)
{
    int ns = 1;
    for (auto p : X.a)
    {
        int A = p.first;
        ll obr = fast_pow(A, MOD2 - 2);
        int B = p.second; int hm = nm->a[A];
        for (int j = 0; j < min(hm, B); ++j)
            nm->nmm = (nm->nmm * obr) % MOD2;
        if (nm->a[A] >= B)
        {
            nm->a[A] -= B;
        }
        else
        {
            B -= nm->a[A];
            nm->a[A] = 0;
            for (int j = 0; j < B; ++j)
                ns *= A;
        }
        if (nm->a[A] == 0) nm->a.erase(A);
    }
    return ns;
}

void nok(num* a, num* b)
{
    for (auto p : b->a)
    {
        int hm = a->a[p.first];
        a->a[p.first] = max(a->a[p.first], p.second);
        for (int i = hm; i < p.second; ++i)
            a->nmm = (a->nmm * (ll)p.first) % MOD2;
    }
}

pair<num*, ll> dfs(int u, int p)
{
    vector<pair<num*, int>> anss;
    vector<int> X, Y;
    vector<pair<int, int>> bsz;
    int cnt = 0;
    for (int c : edge[u])
    {
        if (c != p)
        {
            int v = a[c];
            if (v != u)
            {
                X.push_back(y[c]);
                Y.push_back(x[c]);
            }
            else
            {
                X.push_back(x[c]);
                Y.push_back(y[c]);
                v = b[c];
            }
            anss.push_back(dfs(v, c));
            bsz.push_back({ -sz[v], cnt });
            ++cnt; sz[u] += sz[v];
        }
    }
    if (anss.size() == 0) return { new num(1), 1 };
    sort(all(bsz));
    for (int i = 0; i < anss.size(); ++i)
    {
        ll ost = dl(anss[bsz[i].second].first, num(Y[bsz[i].second]));
        anss[bsz[i].second].second = (anss[bsz[i].second].second * ost) % MOD2;
        anss[bsz[i].second].first->umn(X[bsz[i].second]);
    }
    num* ns = anss[bsz[0].second].first;
    ll nmmwas = ns->nmm;
    for (int i = 1; i < anss.size(); ++i)
    {
        nok(ns, anss[bsz[i].second].first);
    }
    ll ans = ns->nmm;
    ll nm = (ns->nmm * fast_pow(nmmwas, MOD2 - 2)) % MOD2;
    ans = (ans + nm * anss[bsz[0].second].second) % MOD2;
    for (int i = 1; i < anss.size(); ++i)
    {
        ll nm = (ns->nmm * fast_pow(anss[bsz[i].second].first->nmm, MOD2 - 2)) % MOD2;
        ans = (ans + nm * anss[bsz[i].second].second) % MOD2;
    }
    return { ns, ans };
}

void solve(int test_case)
{
    edge.clear();
    a.clear(); b.clear();
    x.clear(); y.clear();
    sz.clear();
    int n; cin >> n;
    edge.resize(n);
    a.resize(n - 1); b.resize(n - 1);
    x.resize(n - 1); y.resize(n - 1);
    sz.resize(n, 1);
    for (int i = 0; i < n - 1; ++i)
    {
        cin >> a[i] >> b[i] >> x[i] >> y[i];
        --a[i]; --b[i];
        edge[a[i]].push_back(i);
        edge[b[i]].push_back(i);
        int gc = gcd(x[i], y[i]);
        x[i] /= gc;
        y[i] /= gc;
    }
    auto p = dfs(0, -1);
    cout << p.second << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    srand(time(NULL));
    for (int i = 2; i <= 200000; ++i)
    {
        if (resh[i] == 0)
        {
            resh[i] = i;
            for (ll j = (ll)i * (ll)i; j <= 200000; j += (ll)i)
                if (resh[j] == 0)
                    resh[j] = i;
        }
    }
    int t = 1; cin >> t;
    for (int i = 0; i < t; ++i) solve(i);
}