#include <iostream>
#include <iomanip>
#include <functional>
#include <numeric>
#include <cmath>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <tuple>
#include <utility>
#include <random>
#include <chrono>
#include <algorithm>
#define all(o) (o).begin(), (o).end()
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const T &e : v) o << e << " ";
    return o;
}
template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (T &e : v) o >> e;
    return o;
}
template<typename T1, typename T2>
ostream &operator<<(ostream &o, const pair<T1, T2> &v) {
    o << v.first << " " << v.second;
    return o;
}
template<typename T1, typename T2>
istream &operator>>(istream &o, pair<T1, T2> &v) {
    o >> v.first >> v.second;
    return o;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> ar(n);
    cin >> ar;
    dbg(ar);
    multiset<ll> a(all(ar));
    multiset<ll> b{accumulate(all(a), 0ll)};
    while (!b.empty()) {
        ll x = *b.begin();
        b.erase(b.begin());
        if (a.find(x) != a.end()) {
            a.erase(a.lower_bound(x));
            continue;
        }
        b.insert(x / 2);
        b.insert((x + 1) / 2);
        if (*b.begin() < *a.begin()) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

int main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        solve();
        cout << "#############################\n";
    }
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
    int q = 1;
    cin >> q;
    while (q--) solve();
#endif
    return 0;
}
