#pragma GCC optimize("O3")

#include <iostream>
#include <iomanip>
#include <functional>
#include <numeric>
#include <cmath>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <tuple>
#include <utility>
#include <random>
#include <chrono>
#include <algorithm>

#define all(o) (o).begin(), (o).end()
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const T &e : v) o << e << " ";
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (T &e : v) o >> e;
    return o;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &o, const pair<T1, T2> &v) {
    o << v.first << " " << v.second;
    return o;
}

template<typename T1, typename T2>
istream &operator>>(istream &o, pair<T1, T2> &v) {
    o >> v.first >> v.second;
    return o;
}

const int MX = 150, MN = 1e5 + 600;
const int MK = MN / MX;
const int ASZ = MK * MN;

void solve() {
    int n;
    cin >> n;

    static array<int, MN> a{};
    static array<short, ASZ * 2> a0_cnt{};
    fill(all(a0_cnt), 0);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }

    int best = 0;

    static array<int, MN * 16> cnt_2{};
    for (int d = -4; d <= 4; ++d) {
        fill(all(cnt_2), 0);
        for (int i = 0; i < n; ++i) {
            cnt_2[a[i] - d * i + MN * 8]++;
        }
        best = max(best, *max_element(all(cnt_2)));
    }
    dbg(best);
    if (best > INT16_MAX) {
        cout << n - best << "\n";
        dbg("ok");
        return;
    }


    for (int i = 0; i < n; ++i) {
        dbg(i);
        int l = max(0, i - MX), r = min(n, i + MX);

        for (int j = l; j < r; ++j) {
            if (i == j) continue;
            // if ((a[i] - a[j]) % (j - i) != 0) continue;
            int d = (a[i] - a[j]) / (j - i);
            // if (abs(d) < MX * MX) continue;
            int cnt = 0;
            int f = d * (l - i);
            for (int k = l; k < r; ++k) {
                cnt += (a[k] + f == a[i]);
                f += d;
            }
            best = max(cnt, best);
        }
    }

    for (int d = -MK; d <= MK; ++d) {
        dbg(d);
        int f = 0;
        for (int i = 0; i < n; ++i) {
            int x = a[i] - f + ASZ;
            a0_cnt[x]++;
            best = max(int(a0_cnt[x]), best);
            f += d;
        }
        f = 0;
        for (int i = 0; i < n; ++i) {
            int x = a[i] - f + ASZ;
            a0_cnt[x] = 0;
            f += d;
        }
    }
    cout << n - best << "\n";
}

int main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        solve();
        cout << "#############################\n";
    }
    cout << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
    int q = 1;
    // cin >> q;
    while (q--) solve();
#endif
    return 0;
}
