#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
typedef long long ll;
//#define int long long

int t;
int n;

int gcd(int x, int y)
{
	while (y)
	{
		x %= y;
		swap(x, y);
	}
	return x;
}

struct ed
{
	int u, v, x, y;

	ed() {}

	ed(int u, int v, int x, int y) : u(u), v(v), x(x), y(y)
	{
		int d = gcd(x, y);
		x /= d;
		y /= d;
	}
};

vector <ed> g[200010];
int cnt[200010];
int mi[200010];

vector <int> pr[200010];

void dfs(int u, int p)
{
	for (auto e : g[u]) if (e.v != p)
	{
		auto v = e.v;
		auto x = e.x;
		auto y = e.y;

		vector <int> diff;
		for (auto i : pr[y])
		{
			cnt[i]++;
			diff.push_back(i);
		}

		for (auto i : pr[x])
		{
			cnt[i]--;
			diff.push_back(i);
		}

		for (auto i : diff)
		{
			mi[i] = min(mi[i], cnt[i]);
		}

		dfs(v, u);
		for (auto i : pr[y])
		{
			cnt[i]--;
		}

		for (auto i : pr[x])
		{
			cnt[i]++;
		}
	}
}

const int MOD = 998244353;

int bp(int a, int b)
{
	int ans = 1;
	while (b)
	{
		if (b & 1) ans = (ll)ans * a % MOD;

		a = (ll)a * a % MOD;
		b >>= 1;
	}
	return ans;
}

int ans;

void dfsans(int u, int v, int p = -1)
{
	ans += v;
	ans %= MOD;

	for (auto e : g[u]) if (e.v != p)
	{
		dfsans(e.v, (ll)v * e.y % MOD * bp(e.x, MOD - 2) % MOD, u);
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	for (int i = 2; i < 200010; ++i)
	{
		int c = i;
		for (int d = 2; d * d <= c; ++d)
		{
			while (c % d == 0)
			{
				c /= d;
				pr[i].push_back(d);
			}
		}

		if (c > 1) pr[i].push_back(c);
	}

	cin >> t;

	while (t--)
	{
		cin >> n;

		for (int i = 1; i <= n; ++i) g[i].clear();
		for (int i = 1; i <= n - 1; ++i)
		{
			int u, v, x, y;
			cin >> u >> v >> x >> y;
			g[u].push_back(ed(u, v, x, y));
			g[v].push_back(ed(v, u, y, x));
		}

		for (int i = 1; i <= n; ++i)
		{
			mi[i] = cnt[i] = 0;
		}

		dfs(1, 1);

		int v = 1;

		for (int i = 1; i <= n; ++i)
		{
			for (int j = 0; j < -mi[i]; ++j)
			{
				v = (ll)v * i % MOD;
			}
		}

		ans = 0;

		dfsans(1, v);
		cout << ans << '\n';
	}

	return 0;
}