//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include<iostream>
#include<vector>
#include<cmath>
#include<random>
#include<set>
#include<map>
using namespace std;

#define debug(x) cout << (#x) << ": " << x;
#define int long long

struct ST {
	int sz;
	vector<int> data;
	ST() {
		;
	}

	ST(vector<int> inp) {
		for (sz = 1; sz < inp.size(); sz *= 2);
		data.assign(sz * 2, 0);
		for (int i = 0; i < inp.size(); i++) data[i + sz] = inp[i];
		for (int i = sz - 1; i > 0; i--) data[i] = data[i * 2] + data[i * 2 + 1];
	}

	long long get(int l, int r) {
		l += sz;
		r += sz;
		long long ans = 0;

		while (r > l) {
			if (l % 2) ans += data[l++];
			if (!(r % 2)) ans += data[r--];
			l /= 2; r /= 2;
		}

		if (r == l) ans += data[l];

		return ans;
	}

	void upd(int ind, int ch) {
		ind += sz;
		data[ind] = ch;
		ind /= 2;
		while (ind != 0) {
			data[ind] = data[ind * 2] + data[ind * 2 + 1];
			ind /= 2;
		}
	}
};

struct elem {
	int to, x, y;
};

int gcd(int a, int b) {
	if (a == 0) {
		return b;
	}
	return gcd(b % a, a);
}

vector<pair<int, int>> razb(int k) {
	if (k == 1) {
		return {};
	}

	int k1 = k;

	vector<pair<int, int>> ans;
	for (int i = 2; i * i <= k1; i++) {
		int deg = 0;
		while (!(k % i)) {
			k /= i;
			deg++;
		}

		if (deg) {
			ans.push_back({deg, i});
		}
	}

	if (k != 1) {
		ans.push_back({1, k});
	}

	return ans;
}

vector<vector<int>> mass;
vector<vector<elem>> g;
vector<int> smth(2e5 + 10);
vector<int> maxi;
void dfs(int i, int p) {
	for (auto j : g[i]) {
		if (j.to != p) {
			//smth[j.x] += 1;

			auto tmp = razb(j.x);
			auto tmp2 = razb(j.y);

			for (auto pr : tmp2) {
				smth[pr.second] -= pr.first;
			}

			for (auto pr : tmp) {
				smth[pr.second] += pr.first;
				maxi[pr.second] = max(maxi[pr.second], smth[pr.second]);
			}

			dfs(j.to, i);

			for (auto pr : tmp2) {
				smth[pr.second] += pr.first;
			}

			for (auto pr : tmp) {
				smth[pr.second] -= pr.first;
			}
		}
	}
}

constexpr int mod = 998244353;
int bindeg(int a, int k) {
	if (k == 0) {
		return 1;
	}

	if (k % 2) return (1ll * a * bindeg(a, k - 1)) % mod;
	int tmp = bindeg(a, k / 2);
	return (1ll * tmp * tmp) % mod;
}

int ans = 0;
void calc(int i, int p, int k) {
	ans = (ans + k) % mod;
	for (auto j : g[i]) {
		if (j.to != p) {
			calc(j.to, i, 1ll * (k * j.y) % mod * bindeg(j.x, mod - 2) % mod);
		}
	}
}

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;

	for (int z = 0; z < t; z++) {
		int n;
		cin >> n;

		smth.assign(n + 1, 0);
		maxi.assign(n + 1, 0);
		g.assign(n, {});
		ans = 0;
		for (int i = 0; i < n - 1; i++) {
			int a, b;
			cin >> a >> b; a--; b--;
			int x, y;
			cin >> x >> y;

			int tmp = gcd(x, y);
			x /= tmp;
			y /= tmp;

			g[a].push_back(elem{b, x, y});
			g[b].push_back(elem{a, y, x});
		}

		dfs(0, 0);
		int tmp = 1;
		for (int i = 0; i < n + 1; i++) {
			if (maxi[i] > 0)
			tmp = (1ll * tmp * bindeg(i, maxi[i])) % mod;
		}

		calc(0, 0, tmp);

		cout << ans << "\n";
		//cout << 0;
	}
}