#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define all(x) (x).begin(), (x).end()
#define pb push_back

template <typename T>
inline int len(T& x) {
    return x.size();
}



ll binpow(ll b, ll e, ll p) {
    ll r = 1;
    while(e > 0) {
        if(e & 1) r = r * b % p;
        b = b * b % p;
        e >>= 1;
    }
    return r;
}

const ll MOD = 998244353;
const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const int maxN = 2e5 + 9;
struct pq {
    ll p, q;
    pq operator*(const pq& sec) const {
        return pq{p * sec.p % MOD, q * sec.q % MOD};
    }
};
vector<pair<int, pq>> g[maxN];
pq res[maxN];


int mind[maxN];
void init() {
    for(ll i = 2; i < maxN; ++i) {
        if(mind[i] == 0) {
            for(ll j = i; j < maxN; j += i) {
                if(mind[j] == 0) {
                    mind[j] = i;
                }
            }
        }
    }
}

int cur[maxN], mins[maxN];

void add(pq z, ll r) {
    ll p = z.p, q = z.q;
    while(p > 1) {
        ll d = mind[p];
        cur[d] += r;
        mins[d] = min(mins[d], cur[d]);
        p /= d;
    }
    while(q > 1) {
        ll d = mind[q];
        cur[d] -= r;
        mins[d] = min(mins[d], cur[d]);
        q /= d;
    }
}



void dfs(int v, int p = -1) {
    for(auto &i: g[v]) {
        if(i.first == p) continue;
        res[i.first] = res[v] * i.second;
        add(i.second, 1);
        dfs(i.first, v);
        add(i.second, -1);
    }
}


void clear(int n) {
    for(int i = 0; i <= n; ++i) {
        res[i] = {0, 0};
        g[i].clear();
        cur[i] = mins[i] = 0;
        //        vis[i] = 0;
    }
}

void solve() {
    int n; cin >> n;
    clear(n);

    for(int i = 1; i < n; ++i) {
        ll u, v, x, y; cin >> u >> v >> x >> y;
        g[u].pb({v, pq{y, x}});
        g[v].pb({u, pq{x, y}});
    }
    res[1] = {1, 1};
    dfs(1);

    for(int i = 1; i <= n; ++i) {
        assert(res[i].p != 0 && res[i].q != 0);
    }

    ll x = 1;
    for(int i = 1; i <= n; ++i) {
        if(mins[i] < 0) {
            x = x * binpow(i, -mins[i], MOD) % MOD;
        }
    }
    ll ans = 0;
    for(int i = 1; i <= n; ++i) {
        ans = (ans + (x * res[i].p % MOD) * binpow(res[i].q, MOD - 2, MOD) % MOD) % MOD;
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    init();
    int tc; cin >> tc;
    while(tc--) solve();
}
/*
i / j = x / y
i = x / y * j
j / i = y / x
j = i * y / x

x * p = 0 (mod q)

1
5
1 2 1 2
2 3 1 2
3 4 1 2
4 5 1 2


 */