#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;

#define all(arr) (arr).begin(), (arr).end()
#define sz(x) int((x).size())
#define fi first
#define se second
#define ll long long
#define ld long double
#define pb push_back
#define endl '\n'

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct FenwickTree{
  vector<ll> bit;
  int n;
  FenwickTree(int n_){
    n = n_;
    bit.resize(n);
  };

  ll rsq(int r){
    ll res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1){
      res += bit[r];
    }
    return res;
  }

  ll rsq(int l, int r){
    return rsq(r) - rsq(l - 1);
  }

  void add(int idx, ll val){
    for (; idx < n; idx |= idx + 1){
      bit[idx] += val;
    }
  }
};

const int DSU_N = 2e5 + 20;
struct DSU{
  int par[DSU_N], sz[DSU_N];

  void makeset(int v){
    par[v] = v, sz[v] = 1;
  }

  int getset(int v){
    return par[v] == v? v : par[v] = getset(par[v]);
  }

  bool same(int u, int v){
    return getset(u) == getset(v);
  }

  void unite(int u, int v){
    u = getset(u), v = getset(v);
    if (u == v) return;
    if (sz[u] < sz[v]) swap(u, v);
    par[v] = u, sz[u] += sz[v];
  }
};

const int ST_N = 2e5 + 20;
struct SegTree{
  int n;
  int t[4 * ST_N];
  int default_return = INT_MAX;

  SegTree(int n_){
    n = n_;
    for (int i = 0; i < 4 * n; i++) t[i] = default_return;
  }

  void modify(int v, int tl, int tr, int pos, int val){
    if (tl == tr){
      t[v] = val;
      return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) modify(2 * v + 1, tl, tm, pos, val);
    else modify(2 * v + 2, tm + 1, tr, pos, val);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
  }

  int query(int v, int tl, int tr, int l, int r){
    if (r > l) return default_return;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) / 2;
    return min(query(2 * v + 1, tl, tm, l, min(r, tm)),
    query(2 * v + 2, tm + 1, tr, max(l, tm + 1), r));
  }

  void modify(int pos, int val){
    modify(0, 0, n - 1, pos, val);
  }

  int query(int l, int r){
    return query(0, 0, n - 1, l, r);
  }

  void clear(int n_){
    n = n_;
    for (int i = 0; i < 4 * n; i++) t[i] = default_return;
  }
};

void solve(){
  string s;
  cin >> s;
  vector<int> last(26, INT_MAX);
  for (int i = 0; i < sz(s); i++) last[s[i] - 'a'] = i;
  cout << s.substr(*min_element(all(last))) << endl;
}

signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  // cout.precision(20);
  int test_cases = 1;
  cin >> test_cases;
  while(test_cases--){
    solve();
  }
}