#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;

#define all(arr) (arr).begin(), (arr).end()
#define sz(x) int((x).size())
#define fi first
#define se second
#define ll long long
#define ld long double
#define pb push_back
#define endl '\n'

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct FenwickTree{
  vector<ll> bit;
  int n;
  FenwickTree(int n_){
    n = n_;
    bit.resize(n);
  };

  ll rsq(int r){
    ll res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1){
      res += bit[r];
    }
    return res;
  }

  ll rsq(int l, int r){
    return rsq(r) - rsq(l - 1);
  }

  void add(int idx, ll val){
    for (; idx < n; idx |= idx + 1){
      bit[idx] += val;
    }
  }
};

const int DSU_N = 2e5 + 20;
struct DSU{
  int par[DSU_N], sz[DSU_N];

  void makeset(int v){
    par[v] = v, sz[v] = 1;
  }

  int getset(int v){
    return par[v] == v? v : par[v] = getset(par[v]);
  }

  bool same(int u, int v){
    return getset(u) == getset(v);
  }

  void unite(int u, int v){
    u = getset(u), v = getset(v);
    if (u == v) return;
    if (sz[u] < sz[v]) swap(u, v);
    par[v] = u, sz[u] += sz[v];
  }
};

const int ST_N = 2e5 + 20;
struct SegTree{
  int n;
  int t[4 * ST_N];
  int default_return = INT_MAX;

  SegTree(int n_){
    n = n_;
    for (int i = 0; i < 4 * n; i++) t[i] = default_return;
  }

  void modify(int v, int tl, int tr, int pos, int val){
    if (tl == tr){
      t[v] = val;
      return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) modify(2 * v + 1, tl, tm, pos, val);
    else modify(2 * v + 2, tm + 1, tr, pos, val);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
  }

  int query(int v, int tl, int tr, int l, int r){
    if (r > l) return default_return;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) / 2;
    return min(query(2 * v + 1, tl, tm, l, min(r, tm)),
    query(2 * v + 2, tm + 1, tr, max(l, tm + 1), r));
  }

  void modify(int pos, int val){
    modify(0, 0, n - 1, pos, val);
  }

  int query(int l, int r){
    return query(0, 0, n - 1, l, r);
  }

  void clear(int n_){
    n = n_;
    for (int i = 0; i < 4 * n; i++) t[i] = default_return;
  }
};

const int N = 2e5 + 20;
const int MOD = 998244353;

vector<pair<int, int>> primes[N];

vector<pair<int, pair<int, int>>> g[N];
int cntup[N], cntdown[N], anscnt[N];

void dfs1(int v, int par){
  for (auto [u, frac] : g[v]){
    if (u == par) continue;
    for (auto [p, c] : primes[frac.fi]){
      cntup[p] += max(0, c - cntdown[p]);
      cntdown[p] = max(0, cntdown[p] - c);
    }
    for (auto [p, c] : primes[frac.se]){
      cntdown[p] += max(0, c - cntup[p]);
      cntup[p] = max(0, cntup[p] - c);
    }
    for (auto [p, c] : primes[frac.fi]){
      anscnt[p] = max(anscnt[p], cntdown[p]);
    }
    for (auto [p, c] : primes[frac.se]){
      anscnt[p] = max(anscnt[p], cntdown[p]);
    }
    dfs1(u, v);
    swap(frac.fi, frac.se);
    for (auto [p, c] : primes[frac.fi]){
      cntup[p] += max(0, c - cntdown[p]);
      cntdown[p] = max(0, cntdown[p] - c);
    }
    for (auto [p, c] : primes[frac.se]){
      cntdown[p] += max(0, c - cntup[p]);
      cntup[p] = max(0, cntup[p] - c);
    }
  }
}

int binpow(int a, int b){
  int res = 1;
  for (; b; a = a * 1ll * a % MOD, b >>= 1){
    if (b & 1) res = res * 1ll * a % MOD;
  }
  return res;
}

int ans = 0;
int val[N];

void dfs2(int v, int p){
  ans = (ans + val[v]) % MOD;
  for (auto [u, frac] : g[v]){
    if (u != p){
      val[u] = val[v] * 1ll * frac.fi % MOD * 1ll * binpow(frac.se, MOD - 2) % MOD;
      dfs2(u, v);
    }
  }
}

void solve(){
  int n;
  cin >> n;
  for (int i = 0; i <= n; i++){
    g[i].clear();
    val[i] = 0;
    ans = 0;
    cntup[i] = cntdown[i] = anscnt[i] = 0;
  }
  for (int i = 1; i < n; i++){
    int a, b, c, d;
    cin >> a >> b >> c >> d;
    g[a].pb(pair{b, pair{d, c}});
    g[b].pb(pair{a, pair{c, d}});
  }
  dfs1(1, 0);
  val[1] = 1;
  for (int i = 1; i <= n; i++){
    val[1] = val[1] * 1ll * binpow(i, anscnt[i]) % MOD;
  }
  dfs2(1, 0);
  cout << ans << endl;
}

signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  // cout.precision(20);
  for (int i = 2; i < N; i++){
    int i1 = i;
    for (int j = 2; j * j <= i; j++){
      int c = 0;
      while (i1 % j == 0) i1 /= j, c++;
      if (c) primes[i].pb({j, c});
    }
    if (i1 > 1) primes[i].pb({i1, 1});
  }
  int test_cases = 1;
  cin >> test_cases;
  while(test_cases--){
    solve();
  }
}