#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<array>
#include<random>
#include<stack>
#include<queue> 

using namespace std;
using ll = long long;
using ld = long double;

mt19937 gen(0);
const int IINF = 2e9;
const ll LINF = 4e18;
const ld EPS = 1e-12;
const ll mod = 998244353;

#define all(x) x.begin(), x.end()
#define print(x) cout << #x << ": " << x << endl;
#define print_arr(x) cout << #x << ": "; for(auto y: x) cout << y << ' '; cout << endl;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

vector<vector<array<ll, 3>>> g;
vector<int> used;
unordered_map<ll, ll> max_pow;
unordered_map<ll, ll> cur_pow_up, cur_pow_down;


void mult_hah(unordered_map<ll, ll>& x, unordered_map<ll, ll>& y) {
	for (auto [prime, pow] : x) {
		if (cur_pow_down[prime] <= pow) {
			cur_pow_up[prime] += pow - cur_pow_down[prime];
			cur_pow_down[prime] = 0;
		}
		else {
			cur_pow_down[prime] -= pow;
		}
	}
	for (auto [prime, pow] : y) {
		if (cur_pow_up[prime] <= pow) {
			cur_pow_down[prime] += pow - cur_pow_up[prime];
			max_pow[prime] = max(max_pow[prime], cur_pow_down[prime]);
			cur_pow_up[prime] = 0;
		}
		else {
			cur_pow_up[prime] -= pow;
		}
	}
}

void dfs(int v) {
	used[v] = 1;
	for (auto [u, x, y] : g[v]) {
		if (!used[u]) {
			unordered_map<ll, ll> x_pow, y_pow;
			ll xx = x, yy = y;
			for (int i = 2; i * i <= xx; ++i) {
				while (xx % i == 0) {
					x_pow[i]++;
					xx /= i;
				}
			}
			x_pow[xx]++;
			for (int i = 2; i * i <= yy; ++i) {
				while (yy % i == 0) {
					y_pow[i]++;
					yy /= i;
				}
			}
			y_pow[yy]++;
			mult_hah(x_pow, y_pow);
			dfs(u);
			swap(x_pow, y_pow);
			mult_hah(x_pow, y_pow);
		}
	}
}

ll mult(ll a, ll b) {
	return (a * b) % mod;
}

ll bin_pow(ll a, ll pow) {
	if (pow == 0) return 1;
	if (pow % 2 == 0) {
		ll res = bin_pow(a, pow / 2);
		return mult(res, res);
	}
	return mult(a, bin_pow(a, pow - 1));
}

ll rev(ll a) {
	return bin_pow(a, mod - 2);
}

ll add(ll a, ll b) {
	return (a + b) % mod;
}

ll cur = 1;
ll ans = 0;
void calc_ans(int v) {
	used[v] = 1;
	for (auto [u, x, y] : g[v]) {
		if (!used[u]) {
			cur = mult(cur, x);
			cur = mult(cur, rev(y));
			ans = add(ans, cur);
			calc_ans(u);
			cur = mult(cur, rev(x));
			cur = mult(cur, y);
		}
	}
}

void clear_all() {
	g.clear();
	max_pow.clear();
	ans = 0;
	cur = 1;
	cur_pow_down.clear();
	cur_pow_up.clear();
}

void solve(int abba = 0) {
	int n;
	cin >> n;
	clear_all();
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		ll v, u, x, y;
		cin >> v >> u >> x >> y;
		--v; --u;
		ll d = gcd(x, y);
		x /= d; y /= d;
		g[v].push_back({ u, y, x });
		g[u].push_back({ v, x, y });
	}
	used.assign(n, 0);
	dfs(0);
	for (auto [prime, pow] : max_pow) {
		cur = mult(cur, bin_pow(prime, pow));
	}
	ans = add(ans, cur);
	used.assign(n, 0);
	calc_ans(0);
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int abba = 1;
	cin >> abba;
	while (abba--) {
		solve(abba);
	}
}