#include <bits/stdc++.h>
using namespace std;
#define forn(i, x, y) for(int i = (x); i < (y); i++)
#define forr(i, x, y) for(int i = (x); i >= (y); i--)
#define all(x) (x).begin(), (x).end()

#define int long long

//#pragma GCC optimize ("O3", "unroll-loops")

const int mod = 998244353;

struct mint {
    int x;
    mint() {x = 0;}
    mint(int y) {x = y;}
    mint operator +(const mint& other) const {
        int res = x + other.x;
        if(res >= mod) {
            res -= mod;
        }
        return res;
    }
    mint operator -(const mint& other) const {
        int res = x - other.x;
        if(res < 0) {
            res += mod;
        }
        return res;
    }
    mint operator *(const mint& other) const {
        int res = (x * other.x) % mod;
        return res;
    }
    friend mint binpow(mint b, int p) {
        if(p == 0) {
            return 1;
        }
        mint res = binpow(b, p/2);
        res = res * res;
        if(p & 1) {
            res = res * b;
        }
        return res;
    }
    friend mint modrev(mint num) {
        return binpow(num, mod-2);
    }
    mint operator /(const mint& num) const {
        return (*this * modrev(num));
    }
    friend void print(mint num) {
        cout << num.x << "\n";
    }
};

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    const int maxn = 2e5 + 5;
    vector<vector<pair<int,int>>> sieve(maxn);
    int cur_prime = 0;
    vector<int> prime_vals;
    forn(i, 2, maxn) {
        if(sieve[i].empty()) {
            for(int j = i; j < maxn; j += i) {
                int prv = j / i;
                if(prv % i == 0) {
                    sieve[j].push_back(sieve[prv].back());
                    sieve[j].back().second++;
                }
                else {
                    sieve[j].emplace_back(cur_prime, 1);
                }
            }
            prime_vals.push_back(i);
            cur_prime++;
        }
    }
    vector<vector<mint>> revs(cur_prime), pows(cur_prime);
    forn(i, 0, cur_prime) {
        int cur = prime_vals[i];
        revs[i].push_back(1);
        pows[i].push_back(1);
        while(cur < maxn) {
            revs[i].push_back(modrev((mint)cur));
            pows[i].push_back(cur % mod);
            cur *= prime_vals[i];
        }
    }
//    forn(i, 0, 5) {
//        cout << prime_vals[i] << ": ";
//        for(auto it : revs[i]) {
//            print(it);
//            cout << " ";
//        }
//        cout << "\n";
//    }

//    forn(i, 0, 100) {
//        cout << i << ":\n";
//        for(auto [p, cnt] : sieve[i]) {
//            cout << "\t" << p << " " << cnt << "\n";
//        }
//        cout << "\n";
//    }

    int t;
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        vector<vector<tuple<int,int,int>>> g(n);
        forn(i, 0, n-1) {
            int u, v, x, y;
            cin >> u >> v >> x >> y;
            u--, v--;
            g[u].push_back({v, y, x});
            g[v].push_back({u, x, y});
        }
        vector<int> razb(cur_prime), min_pow(cur_prime);
        function<void(int,int)> dfs = [&](int v, int p) {
            for(auto [to, x, y] : g[v]) {
                if(to != p) {
                    for(auto [a, b] : sieve[x]) {
                        razb[a] += b;
                    }
                    for(auto [a, b] : sieve[y]) {
                        razb[a] -= b;
                        min_pow[a] = min(min_pow[a], razb[a]);
                    }
                    dfs(to, v);
                    for(auto [a, b] : sieve[x]) {
                        razb[a] -= b;
                    }
                    for(auto [a, b] : sieve[y]) {
                        razb[a] += b;
                    }
                }
            }
        };
        dfs(0, -1);

//        forn(i, 0, 10) {
//            cout << min_pow[i] << " ";
//        }
//        cout << "\n";

        mint cur = 1;
        forn(i, 0, cur_prime) {
            cur = cur * binpow((mint)prime_vals[i], min_pow[i]);
        }

        mint ans = 0;
        function<void(int,int)> dfs2 = [&](int v, int p) {
            ans = ans + cur;
            for(auto [to, x, y] : g[v]) {
                if(to != p) {
                    mint was = cur;
                    for(auto [a, b] : sieve[x]) {
                        cur = cur * pows[a][b];
                    }
                    for(auto [a, b] : sieve[y]) {
                        cur = cur * revs[a][b];
                    }
                    dfs2(to, v);
                    cur = was;
                }
            }
        };
        dfs2(0, -1);

        print(ans);
    }
    return 0;
}
