#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
//#define LONG

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf9 = 1000000009;
const ll inf18 = 1000000000000000018;

#ifdef LONG
#define int long long
#define inf inf18
#else
#define inf inf9
#endif

const int M = 998244353;

template <typename T1, typename T2> istream& operator>>(istream& is, pair <T1, T2>& a){is >> a.ff >> a.ss;return is;}
template <typename T1, typename T2> ostream& operator<<(ostream& os, pair <T1, T2> a){os << "(" << a.ff << ", " << a.ss << ")";return os;}
template <typename T> istream& operator>>(istream& is, vector <T>& a){for (auto &x : a){is >> x;}return is;}
template <typename T> ostream& operator<<(ostream& os, vector <T> a){for (auto x : a){os << x << " ";}os << endl;return os;}
template <typename T> void print(T a){for (auto x : a){cout << x << " ";}cout << endl;}

struct edge{
    int u, x, y;
};

const int N = 200010, LOG = 7;
vector <edge> g[N];
int ans[N], len[N];
pair <ll, int> f[N][LOG];
unordered_map <ll, int> a;

ll binpow(ll x, int y){
    ll c = 1;
    while (y){
        if (y & 1){
            c = (ll)c * x % M;
        }
        y >>= 1;
        x = (ll)x * x % M;
    }
    return c;
}

ll inverse(ll x){
    return binpow(x, M - 2);
}

int gcd(int a, int b){
    while (a > 0 && b > 0){
        if (a < b){
            swap(a, b);
        }
        a %= b;
    }
    return a + b;
}

void dfs(int v, int r){
    for (auto const &[u, x, y] : g[v]){
        if (u != r){
            for (int i = 0; i < len[x]; i++){
                int d = f[x][i].ff, val = f[x][i].ss;
                a[d] -= val;
                a[d] = max(a[d], 0);
            }
            for (int i = 0; i < len[y]; i++){
                int d = f[y][i].ff, val = f[y][i].ss;
                a[d] += val;
            }
            dfs(u, v);
            for (int i = 0; i < len[x]; i++){
                int d = f[x][i].ff, val = f[x][i].ss;
                a[d] += val;
            }
            for (int i = 0; i < len[y]; i++){
                int d = f[y][i].ff, val = f[y][i].ss;
                a[d] -= val;
            }
        }
    }
}

void walk(int v, int r, ll x1){
    ans[v] = x1;
    ll x2 = x1;
    for (auto [u, x, y] : g[v]){
        if (u != r){
            for (int i = 0; i < len[x]; i++){
                x1 = x1 * inverse(binpow(f[x][i].ff, f[x][i].ss)) % M;
            }
            for (int i = 0; i < len[y]; i++){
                x1 = x1 * binpow(f[y][i].ff, f[y][i].ss) % M;
            }
            walk(u, v, x1);
            x1 = x2;
        }
    }
}

void solve(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        g[i].clear();
        ans[i] = 1;
    }
    for (int k = 0; k < n - 1; k++){
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        i--; j--;
        int gd = gcd(x, y);
        x /= gd;
        y /= gd;
        g[i].pb({j, x, y});
        g[j].pb({i, y, x});
    }
    a.clear();
    dfs(0, -1);
    ll x1 = 1;
    for (auto [d, val] : a){
        x1 = x1 * binpow(d, val) % M;
    }
    walk(0, -1, x1);
    int sum = 0;
    for (int i = 0; i < n; i++){
        sum = (sum + ans[i]) % M;
    }
    cout << sum << endl;
}

int32_t main(){
#ifndef LOCAL
ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#endif
    for (int i = 2; i < N; i++){
        int x = i;
        for (int j = 2; j * j <= x; j++){
            if (x % j == 0){
                int cnt = 0;
                while (x % j == 0){
                    x /= j;
                    cnt++;
                }
                f[i][len[i]] = {j, cnt};
                len[i]++;
            }
        }
        if (x > 1){
            f[i][len[i]] = {x, 1};
            len[i]++;
        }
    }
    int ttt = 1;
    cin >> ttt;
    while (ttt--){
        solve();
    }
}
/*
1
4
3 2 3 4
1 2 4 3
1 4 2 4
 */