#include <iostream>
#include <map>
#include <vector>
 
using namespace std;
 
const int maxn = int(2e5 + 25);
vector<int> prime(maxn);
 
void precalc() {
    vector<int> is_prime(maxn, 1);
    is_prime[0] = 0;
    is_prime[1] = 0;
    prime[0] = 1;
    prime[1] = 1;
    for (int x = 2; x < maxn; ++x) {
        if (is_prime[x]) {
            prime[x] = x;
            if (x * 1LL * x < maxn) {
                for (int to = x * x; to < maxn; to += x) {
                    is_prime[to] = 0;
                    prime[to] = x;
                }
            }
        }
    }
}
 
/////
 
using LL = long long;
 
const LL mod = 998244353;
const int root = 0;
 
void add(LL& a, LL b) {
    a = (a + b) % mod;
}
 
LL mul(LL a, LL b) {
    return (a * b) % mod;
}
 
LL sqr(LL x) {
    return mul(x, x);
}
 
LL deg(LL x, LL n) {
    if (n == 0) {
        return 1LL;
    }
    if (n % 2) {
        return mul(deg(x, n - 1), x);
    } else {
        return sqr(deg(x, n / 2));
    }
}
 
LL rev(LL x) {
    return deg(x, mod - 2);
}
 
struct edge {
    int to, x, y;
 
    edge(int a, int b, int c):
        to(a),
        x(b),
        y(c) {}
};
 
int n;
vector<vector<edge>> g;
map<int, int> count_den, count_num, max_count;
 
void read() {
    count_num.clear();
    count_den.clear();
    max_count.clear();
    g.clear();
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        --u; --v;
        g[u].push_back(edge(v, x, y));
        g[v].push_back(edge(u, y, x));
    }
}
 
void dfs(int v, LL& sum, LL cur, int p) {
    add(sum, cur);
 
    for (auto e: g[v]) {
        int u = e.to;
        int x = e.x;
        int y = e.y;
 
        if (u == p) {
            continue;
        }
 
        vector<int> was;
 
        int cp_y = y;
        while (cp_y > 1) {
            was.push_back(prime[cp_y]);
 
            ++count_num[prime[cp_y]];
            cp_y /= prime[cp_y];
        }
 
        int cp_x = x;
        while (cp_x > 1) {
            was.push_back(prime[cp_x]);
 
            ++count_den[prime[cp_x]];
            cp_x /= prime[cp_x];
        }
 
        for (auto pr: was) {
            max_count[pr] = max(max_count[pr], count_den[pr] - count_num[pr]);
        }
 
        LL new_cur = cur;
        new_cur = mul(new_cur, y);
        new_cur = mul(new_cur, rev(x));
        dfs(u, sum, new_cur, v);
 
        cp_y = y;
        while (cp_y > 1) {
            --count_num[prime[cp_y]];
            cp_y /= prime[cp_y];
        }
 
        cp_x = x;
        while (cp_x > 1) {
            --count_den[prime[cp_x]];
            cp_x /= prime[cp_x];
        }
    }
}
 
void solve() {
    read();
 
    LL sum = 0LL;
    dfs(root, sum, 1LL, -1);
 
    LL value = 1LL;
    for (auto p: max_count) {
        value = mul(value, deg(p.first, p.second));
    }
 
    cout << mul(value, sum) << "\n";
}
 
int main() {
    precalc();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
