#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <utility>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <string>
#include <sstream>
#include <random>
#include <cstdio>
#include <cstdlib>

using namespace std;

const int MOD = 998244353;

int add(int a, int b) {
	if (a + b >= MOD) {
		return a + b - MOD;
	}
	return a + b;
}

int sub(int a, int b) {
	if (a - b < 0) {
		return a - b + MOD;
	}
	return a - b;
}

int mult(int a, int b) {
	return 1ll * a * b % MOD;
}

int binpow(int a, int q) {
	if (q == 0) {
		return 1;
	}
	if (q & 1) {
		return mult(a, binpow(a, q - 1));
	}
	int b = binpow(a, q >> 1);
	return mult(b, b);
}

vector<vector<pair<int, pair<int, int>>>> g;
long long ans = 0;

void dfs(int v, int pr, map<int, int> &up, map<int, int> &down, map<int, int> &maxdown) {
	for (int i = 0; i < (int)g[v].size(); ++i) {
		int u = g[v][i].first;
		if (u == pr) {
			continue;
		}
		int x = g[v][i].second.first;
		int y = g[v][i].second.second;
		for (int i = 2; i * i <= max(x, y); ++i) {
			int cntx = 0, cnty = 0;
			while (x % i == 0) {
				++cntx;
				x /= i;
			}
			while (y % i == 0) {
				++cnty;
				y /= i;
			}
			if (cnty > cntx) {
				int val = cnty - cntx;
				if (up.find(i) != up.end()) {
					if (val >= up[i]) {
						val -= up[i];
						up.erase(i);
						if (val) {
							down[i] += val;
							maxdown[i] = max(maxdown[i], down[i]);
						}
					}
					else {
						up[i] -= val;
					}
				}
				else {
					down[i] += val;
					maxdown[i] = max(maxdown[i], down[i]);
				}
			} 
			else if (cntx > cnty) {
				int val = cntx - cnty;
				if (down.find(i) != down.end()) {
					if (val >= down[i]) {
						val -= down[i];
						down.erase(i);
						if (val) {
							up[i] += val;
						}
					}
					else {
						down[i] -= val;
					}
				}
				else {
					up[i] += val;
				}
			}
		}
		if (x != y) {
			if (x != 1) {
				if (down.find(x) != down.end()) {
					if (down[x] == 1) {
						down.erase(x);
					}
					else {
						--down[x];
					}
				}
				else {
					up[x]++;
				}
			}
			if (y != 1) {
				if (up.find(y) != up.end()) {
					if (up[y] == 1) {
						up.erase(y);
					}
					else {
						--up[y];
					}
				}
				else {
					maxdown[y] = max(maxdown[y], ++down[y]);
				}
			}
		}
		dfs(u, v, up, down, maxdown);
		x = g[v][i].second.first;
		y = g[v][i].second.second;
		for (int i = 2; i * i <= max(x, y); ++i) {
			int cntx = 0, cnty = 0;
			while (x % i == 0) {
				++cntx;
				x /= i;
			}
			while (y % i == 0) {
				++cnty;
				y /= i;
			}
			if (cnty > cntx) {
				int val = cnty - cntx;
				if (down.find(i) != down.end()) {
					if (val >= down[i]) {
						val -= down[i];
						down.erase(i);
						if (val) {
							up[i] += val;
						}
					}
					else {
						down[i] -= val;
					}
				}
				else {
					up[i] += val;
				}
			}
			else if (cntx > cnty) {
				int val = cntx - cnty;
				if (up.find(i) != up.end()) {
					if (val >= up[i]) {
						val -= up[i];
						up.erase(i);
						if (val) {
							down[i] += val;
						}
					}
					else {
						up[i] -= val;
					}
				}
				else {
					down[i] += val;
				}
			}
		}
		if (x != y) {
			if (x != 1) {
				if (up.find(x) != up.end()) {
					if (up[x] == 1) {
						up.erase(x);
					}
					else {
						--up[x];
					}
				}
				else {
					++down[x];
				}
			}
			if (y != 1) {
				if (down.find(y) != down.end()) {
					if (down[y] == 1) {
						down.erase(y);
					}
					else {
						--down[y];
					}
				}
				else {
					up[y]++;
				}
			}
		}
	}
}

void ansdfs(int v, int pr, long long val) {
	ans = add(ans, val);
	for (int i = 0; i < (int)g[v].size(); ++i) {
		int u = g[v][i].first;
		if (u == pr) {
			continue;
		}
		int x = g[v][i].second.first;
		int y = g[v][i].second.second;
		ansdfs(u, v, mult(mult(val, x), binpow(y, MOD - 2)));
	}
}

void solve() {

	int n;
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int v, u, x, y;
		cin >> v >> u >> x >> y;
		--v;
		--u;
		g[v].emplace_back(u, make_pair(y, x));
		g[u].emplace_back(v, make_pair(x, y));
	}
	map<int, int> up, down, maxdown;
	dfs(0, 0, up, down, maxdown);
	long long x = 1;
	for (auto elem : maxdown) {
		x = mult(x, binpow(elem.first, elem.second));
	}
	ansdfs(0, 0, 1);
	cout << mult(ans, x) << "\n";
	g.clear();
	ans = 0;

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}