#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <queue>
#include <deque>
#include <numeric>
#include <bitset>
#include <random>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int maxn = 2e5; //  don't forget to change this if needed
const int mod = 1e9 + 7;
const int inf = 1e18;
mt19937_64 rnd;

struct dsu {
    int p[maxn];
    int sz[maxn];
    
    void init(int n) {
        fill(sz, sz + n, 1);
        iota(p, p + n, 0);
    }
    
    int color(int v) {
        return (v == p[v] ? v : p[v] = color(p[v]));
    }
    
    void unite(int u, int v) {
        u = color(u);
        v = color(v);
        if (u == v) return;
        if (sz[u] < sz[v]) swap(u, v);
        sz[u] += sz[v];
        p[v] = u;
    }
};

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

pair<int, int> ext_gcd(int a, int b) {
    if (!b) return { 1, 0 };
    auto [xp, yp] = ext_gcd(b, a % b);
    int x = yp;
    int y = xp - yp * (a / b);
    return { x, y };
}

int bp(int x, int n = mod - 2) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res *= 1;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

multiset<int> st;
bool ok = true;
int cnt = 0;

void solve(int x, int n) {
    ++cnt;
    if (cnt > n * 60) {
        ok = false;
        return;
    }
    if (st.find(x) != st.end()) {
        st.erase(st.find(x));
        return;
    }
    if (x == 0 || x == 1) {
        ok = false;
        return;
    }
    solve(x / 2, n);
    solve((x + 1) / 2, n);
}

void solve() { //  suffix array has already been written
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    int s = 0;
    for (int i : a) {
        s += i;
    }
    st.clear();
    for (int i : a) {
        st.insert(i);
    }
    cnt = 0;
    ok = true;
    solve(s, n);
    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
/*
 
 */
