#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <queue>
#include <deque>
#include <numeric>
#include <bitset>
#include <random>

using namespace std;

#define all(x) x.begin(), x.end()

const int maxn = 1e5 + 1; //  don't forget to change this if needed
const int mod = 998'244'353;
const int inf = 1e18;
mt19937_64 rnd;

struct dsu {
    int p[maxn];
    int sz[maxn];
    
    void init(int n) {
        fill(sz, sz + n, 1);
        iota(p, p + n, 0);
    }
    
    int color(int v) {
        return (v == p[v] ? v : p[v] = color(p[v]));
    }
    
    void unite(int u, int v) {
        u = color(u);
        v = color(v);
        if (u == v) return;
        if (sz[u] < sz[v]) swap(u, v);
        sz[u] += sz[v];
        p[v] = u;
    }
};

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

pair<int, int> ext_gcd(int a, int b) {
    if (!b) return { 1, 0 };
    auto [xp, yp] = ext_gcd(b, a % b);
    int x = yp;
    int y = xp - yp * (a / b);
    return { x, y };
}

int bp(int x, int n = mod - 2) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

const int k = 1350;
const int q = maxn / k + 1;

int32_t dd[k][maxn * 2 + 10];

void solve() { //  suffix array has already been written
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    map<int, int> mp;
    for (int i : a) {
        ++mp[i];
    }
    int ans = inf;
    for (auto [a, b] : mp) {
        ans = min(ans, n - b);
    }
    for (int d = 1; d <= k; ++d) {
        for (int i = 0; i < n; ++i) {
            ++dd[a[i] % d][a[i] / d - i + maxn];
            ans = min(ans, n - dd[a[i] % d][a[i] / d - i + maxn]);
        }
        for (int i = 0; i < n; ++i) {
            --dd[a[i] % d][a[i] / d - i + maxn];
        }
    }
    reverse(all(a));
    for (int d = 1; d <= k; ++d) {
        for (int i = 0; i < n; ++i) {
            ++dd[a[i] % d][a[i] / d - i + maxn];
            ans = min(ans, n - dd[a[i] % d][a[i] / d - i + maxn]);
        }
        for (int i = 0; i < n; ++i) {
            --dd[a[i] % d][a[i] / d - i + maxn];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i - 1; j >= i - q && j >= 0; --j) {
            int c = 1;
            if ((a[i] - a[j]) % (i - j) == 0) {
                int d = (a[i] - a[j]) / (i - j);
                if (d > k) {
                    for (int t = i - 1; t >= i - q && t >= j; --t) {
                        if (a[t] + (i - t) * 1ll * d == a[i]) ++c;
                    }
                }
            }
            ans = min(ans, n - c);
        }
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
}
/*
 
 */
