#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using ld = long double;

const int MAXN = (int)2e5;
const int MOD = 998244353;

vector<pair<int, pair<int, int>>> g[MAXN];
// unordered_map<int, int> cnts[MAXN];
// unordered_map<int, int> extra[MAXN];
unordered_map<int, int> mx;

ll powMod(ll x, int p)
{
    ll res = 1;
    while(p)
    {
        if (p & 1)
            res = (res * x) % MOD;
        x = (x * x) % MOD;
        p >>= 1;
    }
    return res;
}

void factorize(int n, vector<pair<int, int>>& c)
{
    int cnt = 0;
    for (int i = 2; i * i <= n; ++i)
    {
        while(n % i == 0)
        {
            ++cnt;
            n /= i;
        }
        if (cnt)
        {
            c.emplace_back(i, cnt);
            cnt = 0;
        }
    }
    if (n != 1)
        c.emplace_back(n, 1);
}

void init(int u, int prev, unordered_map<int, int>& cur)
{
    for (auto [v, t] : g[u])
    {
        if (v == prev)
            continue;
        auto [x, y] = t;
        vector<pair<int, int>> c1, c2;
        factorize(x, c1);
        factorize(y, c2);
        
        unordered_map<int, int> extra;
        for (auto [a, c] : c1)
            extra[a] += c;
        for (auto [a, c] : c2)
            extra[a] -= c;

        vector<pair<int, int>> backup;
        for (auto [a, c] : extra)
        {
            backup.emplace_back(a, cur[a]);
            cur[a] += c;
            if (cur[a] > mx[a])
                mx[a] = cur[a];
        }
        
        init(v, u, cur);

        for (auto [a, c] : backup)
            cur[a] = c;
    }
}

// void initVal(int u, int prev)
// {
//     for (auto [v, p] : g[u])
//     {
//         if (v != prev)
//             initVal(v, u);
//     }

//     sort(all(g[u]), [&](auto& a, auto& b){
//         if (a.first == prev || b.first == prev)
//             return b.first == prev;
//         return sz[a.first] > sz[b.first];
//     });
// }

ll countAns(int u, int prev, ll num)
{
    num %= MOD;
    ll res = num;
    for (auto [v, t] : g[u])
    {
        if (v == prev)
            continue;
        auto [x, y] = t;
        
        res = (res + countAns(v, u, (num * y) % MOD * powMod(x, MOD - 2))) % MOD;
    }
    return res;
}

void solve()
{
    int n = 0;
    cin >> n;

    for (int i = 0; i < n; ++i)
        g[i].clear();
    mx.clear();

    int i = 0, j = 0, x  =0, y = 0;
    for (int k = 0; k < n - 1; ++k)
    {
        cin >> i >> j >> x >> y;
        int d = gcd(x, y);
        x /= d, y /= d;

        g[i - 1].emplace_back(j - 1, make_pair(x, y));
        g[j - 1].emplace_back(i - 1, make_pair(y, x));
    }

    unordered_map<int, int> cnt;
    init(0, 0, cnt);

    ll num = 1;
    for (auto [a, c] : mx)
        num = (num * powMod(a, c)) % MOD;
    cout << countAns(0, -1, num) << "\n";
}

int main()
{
    // ios::sync_with_stdio(false);
    // cin.tie(0), cout.tie(0);

    int t = 0;
    cin >> t;

    while(t--)
    {
        solve();
    }

    return 0;
}