#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long

vector<bool> used;
vector<vector<int>> prim(2e5 + 1);
vector<int> p(2e5 + 1);
vector<int> root;
vector<int> now;
int ans;

int mod = 998244353;

int poww(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b == 1) {
        return a;
    }
    int res = poww(a, b / 2);
    res = res * res;
    res %= mod;
    if (b % 2 == 1) {
        res *= a;
        res %= mod;
    }
    return res;
}

void dfs(int v, vector<vector<vector<int>>> &gr) {
    used[v] = true;
    for (auto u: gr[v]) {
        if (!used[u[0]]) {
            for (auto i: prim[u[1]]) {
                now[i]--;
                if (now[i] < 0) {
                    now[i]++;
                    root[i]++;
                }
            }
            for (auto i: prim[u[2]]) {
                now[i]++;
            }
            dfs(u[0], gr);
            for (auto i: prim[u[1]]) {
                now[i]++;
            }
            for (auto i: prim[u[2]]) {
                now[i]--;
                if (now[i] < 0) {
                    now[i]++;
                    root[i]++;
                }
            }
        }
    }
}

void dfs1(int v, vector<vector<vector<int>>> &gr, int pr) {
    ans += pr;
    ans %= mod;
    used[v] = true;
    for (auto u: gr[v]) {
        if (!used[u[0]]) {
            pr *= u[2];
            pr %= mod;
            pr *= p[u[1]];
            pr %= mod;
            dfs1(u[0], gr, pr);
            pr *= u[1];
            pr %= mod;
            pr *= p[u[2]];
            pr %= mod;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    for (int i = 2; i < prim.size(); ++i) {
        if (prim[i].size() == 0) {
            for (int j = i; j < prim.size(); j += i) {
                int now1 = j;
                while (now1 % i == 0) {
                    now1 /= i;
                    prim[j].push_back(i);
                }
            }
        }
    }
    for (int i = 0; i < p.size(); ++i) {
        p[i] = poww(i, mod - 2);
    }
    while (t--) {
        int n;
        cin >> n;
        vector<vector<vector<int>>> gr(n);
        now.assign(n + 1, 0);
        root.assign(n + 1, 0);
        for (int i = 0; i < n - 1; ++i) {
            int i1, j1, x, y;
            cin >> i1 >> j1 >> x >> y;
            int gc = gcd(x, y);
            x /= gc;
            y /= gc;
            --i1;
            --j1;
            gr[i1].push_back({j1, x, y});
            gr[j1].push_back({i1, y, x});
        }
        used.assign(n, 0);
        dfs(0, gr);
        int pr = 1;
        for (int i = 1; i <= n; ++i) {
            for (int j = 0; j < root[i]; ++j) {
                pr *= i;
                pr %= mod;
            }
        }
        ans = 0;
        used.assign(n, 0);
        dfs1(0, gr, pr);
        cout << ans << "\n";
    }
}
