#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())

const int LOG_MAX_N = 2e6 + 1;
int lg[LOG_MAX_N];

void doPrecalc() {
    lg[1] = 0;
    for (int i = 2; i < LOG_MAX_N; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
}

template <typename T>
istream& operator>>(istream& is, vector <T>& v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template <typename T>
ostream& operator<<(ostream& os, const vector <vector <T> >& v) {
    for (const auto& i : v) {
        for (auto j : i) {
            os << j << " ";
        }
        os << "\n";
    }
    return os;
}

template <typename T>
ostream& operator<<(ostream& os, const vector <T>& v) {
    for (auto i : v) {
        os << i << " ";
    }
    return os << "\n";
}

class SegmentTree {
private:
    vector <int> d;
    int N;
    const int NEUTRAL = 0;
    const function<int(int, int)> func = [](int a, int b) {
        return a + b;
    };

    void upd(int i) {
        if (i < N) {
            d[i] = func(d[2 * i], d[2 * i + 1]);
        }
    }

public:
    explicit SegmentTree(const vector <int>& v) {
        N = 1;
        while (N < sz(v)) {
            N *= 2;
        }
        d.resize(2 * N, NEUTRAL);
        for (int i = 0; i < sz(v); ++i) {
            d[i + N] = v[i];
        }
        for (int i = N - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        int res = NEUTRAL;
        for (l += N, r += N; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res = func(res, d[l++]);
            }
            if (r & 1) {
                res = func(res, d[--r]);
            }
        }
        return res;
    }

    void set(int i, int x) {
        i += N;
        d[i] = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};

const int INF = 1e18 + 3;

void solve() {
    int n;
    cin >> n;
    vector <int> v(n);
    unordered_map <int, int> cnt;
    unordered_map <int, int> currCnt;
    multiset <int> currElems;
    for (auto &i : v) {
        cin >> i;
        ++cnt[i];
    }
    sort(all(v));
    int sum = accumulate(all(v), 0ll);
    currElems = {sum};
    currCnt[sum]++;
    vector <int> ans;
    int splits = 0;
    while (!currElems.empty() && splits <= n) {
        auto t = *currElems.rbegin();
        if (currCnt[t] > cnt[t]) {
            currElems.insert(t / 2);
            currElems.insert(t / 2 + t % 2);
            ++currCnt[t / 2];
            ++currCnt[t / 2 + t % 2];
            ++splits;
        } else {
            ans.push_back(t);
        }
        --currCnt[t];
        currElems.extract(t);
    }
    sort(all(ans));
    if (ans == v) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
//    cout.tie(nullptr);
    doPrecalc();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
