#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())

const int LOG_MAX_N = 2e6 + 1;
int lg[LOG_MAX_N];

void doPrecalc() {
    lg[1] = 0;
    for (int i = 2; i < LOG_MAX_N; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
}

const int INF = 1e18 + 3;
using umap = unordered_map <int, int>;

umap getDividers(int a) {
    umap ans;
    for (int i = 2; i * i <= a; ++i) {
        while (a % i == 0) {
            ++ans[i];
            a /= i;
        }
    }
    if (a > 1) {
        ++ans[a];
    }
    return ans;
}

const int MOD = 998'244'353;

int binPow(int a, int n) {
    if (!n) {
        return 1ll;
    }
    if (n & 1) {
        return (binPow(a, n - 1) * a) % MOD;
    } else {
        return binPow((a * a) % MOD, n >> 1);
    }
}

int f(int a) {
    return binPow(a, MOD - 2);
}

void solve() {
    int n;
    cin >> n;
    vector <vector <tuple <int, int, int> > > g(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, x, y;
        cin >> a >> b >> x >> y;
        int gc = __gcd(x, y);
        x /= gc, y /= gc;
        --a, --b;
        g[a].emplace_back(b, x, y);
        g[b].emplace_back(a, y, x);
    }
    auto addU = [](umap a, umap b) {
        umap ans;
        for (auto [c, d] : a) {
            ans[c] = a[c] + b[c];
        }
        for (auto [c, d] : b) {
            ans[c] = a[c] + b[c];
        }
        return ans;
    };
    auto remU = [](umap a, umap b) {
        umap ans;
        for (auto [c, d] : a) {
            ans[c] = max(0ll, a[c] - b[c]);
        }
        for (auto [c, d] : b) {
            ans[c] = max(0ll, a[c] - b[c]);
        }
        return ans;
    };
    auto mergeU = [](umap a, umap b) {
        umap ans;
        for (auto [c, d] : a) {
            ans[c] = max(a[c], b[c]);
        }
        for (auto [c, d] : b) {
            ans[c] = max(a[c], b[c]);
        }
        return ans;
    };
    vector <umap> ans(n);
    function <void(int, int)> dfs = [&](int c, int p) {
        for (auto [t, x, y] : g[c]) {
            if (p != t) {
                dfs(t, c);
                ans[c] = mergeU(ans[c], remU(addU(ans[t], getDividers(x)), getDividers(y)));
            }
        }
    };
    dfs(0, -1);
    int fVal = 1;
    for (auto [a, b] : ans[0]) {
        fVal = (fVal * binPow(a, b)) % MOD;
    }
    int rAns = 0;
    function <void(int, int, int)> restoreAns = [&](int c, int p, int cVal) {
        rAns += cVal;
        rAns %= MOD;
        for (auto [t, x, y] : g[c]) {
            if (t != p) {
                restoreAns(t, c, (cVal * y * f(x)) % MOD);
            }
        }
    };
    restoreAns(0, -1, fVal);
    cout << rAns << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
//    cout.tie(nullptr);
    doPrecalc();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
