#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const bool LOCAL = false;
const bool multitest = true;

const int mod = 998244353;
const int inf = 1000000000 + 1;
const ll infll = 1000000000000000000 + 1;
mt19937_64 rnd(20123832);

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b){
	if (a > b){
		a = b;
		return true;
	}
	return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b){
	if (a < b){
		a = b;
		return true;
	}
	return false;
}

struct mint{
	int v;
	mint(int x){
		while (x < 0){
			x += mod;
		}
		while (x >= mod){
			x -= mod;
		}
		v = x;
	}
	mint() : v(0) {}
	friend mint operator + (mint a, mint b){
		return (a.v + b.v >= mod) ? a.v + b.v - mod : a.v + b.v;
	}
	mint operator += (mint other){
		return *this = *this + other;
	}
	friend mint operator - (mint a, mint b){
		return (a.v - b.v < 0) ? a.v - b.v + mod : a.v - b.v;
	}
	mint operator -= (mint other){
		return *this = *this - other;
	}
	friend mint operator -(mint a){
		return mint(-a.v);
	}
	friend mint operator * (mint a, mint b){
		return (1ll * a.v * b.v) % mod;
	}
	mint operator *= (mint other){
		return *this = *this * other;
	}
	void normalize(){
		while (v < 0){
			v += mod;
		}
		while (v >= mod){
			v -= mod;
		}
	}
	friend mint pow(mint a, int b){
		mint res = 1;
		while (b){
			if (b & 1) res *= a;
			a *= a;
			b >>= 1;
		}
		return res;
	}
	friend mint inv(mint a){
		return pow(a, mod - 2);
	}
	friend mint operator / (mint a, mint b){
		return a * inv(b);
	}
	mint operator /= (mint other){
		return *this = *this / other;
	}
	friend ostream& operator << (ostream& out, mint a){
		out << a.v;
		return out;
	}
	friend istream& operator >> (istream& in, mint &a){
		in >> a.v;
		a.normalize();
		return in;
	}
};

const int maxn = 2e5 + 1;
vector<vector<int>> g[maxn];
int mindiv[maxn];
int cnt[maxn], cnt_mx[maxn];
vector<pair<int, int>> divs[maxn];
mint sum;
bool used[maxn];
int n;
void dfs(int v, mint pc = 1){
	used[v] = true;
	/*
	cout << v + 1 << '\n';
	for (int i = 1; i <= n; i++){
		if (mindiv[i] == i){
			cout << i << ' ' << cnt[i] << '\n';
		}
		else{
			assert(cnt[i] == 0);
		}
	}
	*/
	sum += pc;
	for (auto edg : g[v]){
		int u = edg[0], x = edg[1], y = edg[2];
		if (used[u]) continue;
		// cnt1 - числитель cnt2 - знаминатель
		// cnt1 с x, cnt2 c y
		// делим на х умножаем на y
		for (auto p : divs[x]){
			int d = p.first, c = p.second;
			pc /= pow(mint(d), c);
			cnt[d] += c;
			chmax(cnt_mx[d], cnt[d]);
		}

		for (auto p : divs[y]){
			int d = p.first, c = p.second;
			pc *= pow(mint(d), c);
			cnt[d] -= c;
		}

		dfs(u, pc);

		for (auto p : divs[y]){
			int d = p.first, c = p.second;
			pc /= pow(mint(d), c);
			cnt[d] += c;
		}

		for (auto p : divs[x]){
			int d = p.first, c = p.second;
			pc *= pow(mint(d), c);
			cnt[d] -= c;
		}
	}
}
void solve(){
	cin >> n;
	for (int i = 0; i < n; i++){
		g[i].clear();
	}
	sum = 0;
	fill(cnt, cnt + n + 1, 0);
	fill(cnt_mx, cnt_mx + n + 1, 0);
	fill(used, used + n, false);
	for (int i = 0; i < n - 1; i++){
		int u, v, x, y;
		cin >> u >> v >> x >> y;
		u--, v--;
		int gc = __gcd(x, y);
		x /= gc, y /= gc;
		g[u].push_back({v, x, y});
		g[v].push_back({u, y, x});
	}
	dfs(0);
	mint x = 1;
	for (int i = 1; i <= n; i++){
		//cout << i << ' ' << cnt_mx[i] << '\n';
		x *= pow(mint(i), cnt_mx[i]);
	}
	cout << sum * x << '\n';
}
int main(){
	clock_t START = clock();
	if (LOCAL){
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	}
	fill(mindiv, mindiv + maxn, inf);
	mindiv[1] = 1;
	for (int i = 2; i < maxn; i++){
		if (mindiv[i] == inf){
			mindiv[i] = i;
			for (int j = 2 * i; j < maxn; j += i){
				chmin(mindiv[j], i);
			}
		}
	}
	for (int i = 2; i < maxn; i++){
		int j = i;
		int pr = -1;
		while (j > 1){
			if (pr == mindiv[j]){
				divs[i].back().second++;
			}
			else{
				divs[i].push_back({mindiv[j], 1});
			}
			pr = mindiv[j];
			j /= mindiv[j];
		}
	}
	int t = 1;
	if (multitest) cin >> t;
	while (t--){
		solve();
	}
	cerr << "Finished in " << 1000 * double(clock() - START) / CLOCKS_PER_SEC << " ms\n";
}