#ifdef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <tuple>
#include <iomanip>
#include <random>
#include <cstdlib>

#define len(a) (int)a.size()
#define accuracy(a) fixed << setprecision(a)

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9;
const int MINF = (int)2e9;
const ll LINF = (ll)1e18;
const ld EPS = 1e-9;

using namespace std;

void fast_io()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

void file_in(const string& filename)
{
    freopen(filename.c_str(), "r", stdin);
}

void file_out(const string& filename)
{
    freopen(filename.c_str(), "w", stdout);
}

int randint(int a, int b)
{
    static random_device rd;
    static mt19937 rnd(rd());
    return (int)(rnd() % (b - a + 1)) + a;
}

double diff_clock(clock_t start, clock_t end)
{
    return (double)(end - start) * 1000 / CLOCKS_PER_SEC;
}

void sleep(int milliseconds)
{
    for (clock_t start = clock(); diff_clock(start, clock()) < milliseconds; ) {}
}

void run();
void gen();
void stupid();

signed main()
{
#ifdef LOCAL
    file_in("input.txt");
    file_out("output.txt");
    clock_t start = clock();
#else
    fast_io();
#endif

    run();
//    gen();
//    stupid();

#ifdef LOCAL
    cerr << "TIME = " << accuracy(3) << diff_clock(start, clock()) << '\n';
#endif
}

void gen()
{

}

void stupid()
{

}

/*void run()
{

}*/

void solve_test()
{
    int n;
    cin >> n;
    multiset<int> pieces;
    ll sum = 0;
    for (int i = 0; i < n; ++i)
    {
        int piece;
        cin >> piece;
        pieces.insert(piece);
        sum += piece;
    }
    if (n == 1)
    {
        cout << "Yes\n";
        return;
    }

    queue<ll> q;
    q.push(sum);
    while (!q.empty())
    {
        ll piece = q.front();
        q.pop();
        if (piece == 1)
        {
            cout << "No\n";
            return;
        }
        ll piece1, piece2;
        piece1 = piece / 2;
        piece2 = piece - piece1;
        if ((piece1 <= INF) && pieces.contains((int)piece1))
        {
            pieces.erase(pieces.find((int)piece1));
        }
        else
        {
            q.push(piece1);
        }
        if ((piece2 <= INF) && pieces.contains((int)piece2))
        {
            pieces.erase(pieces.find((int)piece2));
        }
        else
        {
            q.push(piece2);
        }
    }


    if (!pieces.empty())
    {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
}

void run()
{
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}
