#ifdef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <tuple>
#include <iomanip>
#include <random>
#include <cstdlib>

#define len(a) (int)a.size()
#define accuracy(a) fixed << setprecision(a)

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9;
const int MINF = (int)2e9;
const ll LINF = (ll)1e18;
const ld EPS = 1e-9;

using namespace std;

void fast_io()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

void file_in(const string& filename)
{
    freopen(filename.c_str(), "r", stdin);
}

void file_out(const string& filename)
{
    freopen(filename.c_str(), "w", stdout);
}

int randint(int a, int b)
{
    static random_device rd;
    static mt19937 rnd(rd());
    return (int)(rnd() % (b - a + 1)) + a;
}

double diff_clock(clock_t start, clock_t end)
{
    return (double)(end - start) * 1000 / CLOCKS_PER_SEC;
}

void sleep(int milliseconds)
{
    for (clock_t start = clock(); diff_clock(start, clock()) < milliseconds; ) {}
}

void run();
void gen();
void stupid();

signed main()
{
#ifdef LOCAL
    file_in("input.txt");
    file_out("output.txt");
    clock_t start = clock();
#else
    fast_io();
#endif

    run();
//    gen();
//    stupid();

#ifdef LOCAL
    cerr << "TIME = " << accuracy(3) << diff_clock(start, clock()) << '\n';
#endif
}

void gen()
{

}

void stupid()
{

}

/*void run()
{

}*/

void solve_test()
{
    int n;
    cin >> n;
    unordered_map<int, int> counts;
    ll sum = 0;
    for (int i = 0; i < n; ++i)
    {
        int piece;
        cin >> piece;
        ++counts[piece];
        sum += piece;
    }
    if (n == 1)
    {
        cout << "Yes\n";
        return;
    }

    queue< pair<ll, int> > q;
    q.push({sum, 1});
    while (!q.empty())
    {
        auto [piece, count] = q.front();
        q.pop();
        if (piece == 1)
        {
            cout << "No\n";
            return;
        }

        vector< pair<ll, int> > next_pieces;

        if (piece % 2)
        {
            next_pieces.resize(2);
            next_pieces[0] = {piece / 2, count};
            next_pieces[1] = {piece - next_pieces[0].first, count};
        }
        else
        {
            next_pieces = {{piece / 2, count * 2}};
        }
        for (auto [next_piece, next_count] : next_pieces)
        {
            if ((next_piece <= INF) && counts.contains((int)next_piece))
            {
                int minus = min(next_count, counts[(int)next_piece]);
                next_count -= minus;
                counts[(int)next_piece] -= minus;
                if (!counts[(int)next_piece])
                {
                    counts.erase((int)next_piece);
                }
                if (!next_count)
                {
                    continue;
                }
            }
            q.emplace(next_piece, next_count);
        }
    }


    if (!counts.empty())
    {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
}

void run()
{
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}
