#include <bits/stdc++.h>

using namespace std;

const int N = 200500;

const int M = 998244353;

int add(int a, int b) {
	return a + b < M ? a + b : a + b - M;
}

int mul(int a, int b) {
	return 1ll * a * b % M;
}

int pw(int a, int n) {
	int res = 1;
	for (; n > 0; n >>= 1, a = mul(a, a)) {
		if (n & 1) {
			res = mul(res, a);
		}
	}
	return res;
}

int n;
vector<pair<int, pair<int, int>>> g[N];
int lp[N];
int bal[N];
int mx[N];
int inv[N];
int ans;

vector<int> fact(int x) {
	vector<int> res;
	while (x != 1) {
		res.push_back(lp[x]);
		x /= lp[x];
	}
	return res;
}

void dfs(int v, int par = -1) {
	for (auto e : g[v]) {
		int u = e.first;
		int x = e.second.first;
		int y = e.second.second;
		if (u != par) {
			auto fx = fact(x);
			auto fy = fact(y);
			for (int p : fx) {
				--bal[p];
			}
			for (int p : fy) {
				++bal[p];
				mx[p] = max(mx[p], bal[p]);
			}
			dfs(u, v);
			for (int p : fy) {
				--bal[p];
			}
			for (int p : fx) {
				++bal[p];
			}
		}
	}
}

void dfs_ans(int v, int cur, int par = -1) {
	ans = add(ans, cur);
	for (auto e : g[v]) {
		int u = e.first;
		int x = e.second.first;
		int y = e.second.second;
		if (u != par) {
			dfs_ans(u, mul(cur, mul(x, inv[y])), v);
		}
	}
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int _ = 0; _ < n - 1; ++_) {
		int i, j, x, y;
		cin >> i >> j >> x >> y;
		--i;
		--j;
		g[i].push_back({j, {y, x}});
		g[j].push_back({i, {x, y}});
	}
	for (int i = 1; i <= n; ++i) {
		bal[i] = 0;
		mx[i] = 0;
	}
	dfs(0);
	int t = 1;
	for (int i = 1; i <= n; ++i) {
		t = mul(t, pw(i, mx[i]));
	}
	ans = 0;
	dfs_ans(0, t);
	cout << ans << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	for (int i = 1; i < N; ++i) {
		lp[i] = i;
	}
	for (int i = 2; i < N; ++i) {
		for (int j = i + i; j < N; j += i) {
			lp[j] = min(lp[j], i);
		}
	}
	for (int i = 1; i < N; ++i) {
		inv[i] = pw(i, M - 2);
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}