#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(time(0));

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(a, b) cout << #a << " = " << a << ", " << #b << " = " << b << endl;
#define trace3(a, b, x) cout << #a << " = " << a << ", " << #b << " = " << b << ", " << #x << " = " << x << endl;
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

void fast_stream() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

template <typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

const ll MOD = 998244353;

const int MAXN = 2e5 + 2;
vector<pair<int, pair<map<int, int>, map<int, int>>>> g[MAXN];
map<int, int> now_ans;

map<int, int> razlog(int n) {
    map<int, int> ans;

    for (int i = 2; i * i <= n; ++i) {
        if (n % i) continue;

        int cnt = 0;

        while (n % i == 0) {
            n /= i;
            ++cnt;
        }

        ans[i] = cnt;
    }

    if (n != 1) ++ans[n];

    return ans;
}

void nok(map<int, int> &a, map<int, int> b, map<int, int> &c, map<int, int> &d) {
    set<int> diff;

    for (auto i : c) diff.insert(i.first);
    for (auto i : d) diff.insert(i.first);

    for (auto i : diff) {
        a[i] = max(a[i], b[i]);
    }
}

void sokrah(map<int, int> &a, map<int, int> &b, map<int, int> &c, map<int, int> &d) {
    set<int> diff;

    for (auto i : c) diff.insert(i.first);
    for (auto i : d) diff.insert(i.first);

    for (auto i : diff) {
        if (a.find(i) != a.end() && b.find(i) != b.end()) {
            if (a[i] == b[i]) {
                a.erase(i);
                b.erase(i);
            }
            else if (a[i] < b[i]) {
                b[i] -= a[i];
                a.erase(i);
            }
            else {
                a[i] -= b[i];
                b.erase(i);
            }
        }
    }
}

void dfs(int v, int p, map<int, int> now_chisl, map<int, int> now_znamen) {
    for (auto i : g[v]) {
        if (i.first == p) continue;

        map<int, int> new_chisl = now_chisl, new_znamen = now_znamen;
        for (auto j : i.second.first) new_chisl[j.first] += j.second;
        for (auto j : i.second.second) new_znamen[j.first] += j.second;
        sokrah(new_chisl, new_znamen, i.second.first, i.second.second);

        nok(now_ans, new_znamen, i.second.first, i.second.second);

        dfs(i.first, v, new_chisl, new_znamen);
    }
}


int bin_pow(int a, int x) {
    if (!x) return 1;

    ll g = bin_pow(a, x / 2);
    g *= g;
    g %= MOD;

    if (x % 2) {
        g *= a;
        g %= MOD;
    }

    return g;
}

int global_ans = 0;

void dfs2(int v, int p, int now) {
    global_ans += now;
    global_ans %= MOD;

    for (auto i : g[v]) {
        if (i.first == p) continue;

        ll nowww = now;

        for (auto j : i.second.first) {
            nowww *= bin_pow(j.first, j.second);
            nowww %= MOD;
        }
        for (auto j : i.second.second) {
            int k = bin_pow(j.first, j.second);
            k = bin_pow(k, MOD - 2);

            nowww *= k;
            nowww %= MOD;
        }

        dfs2(i.first, v, nowww);
    }
}

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n - 1; ++i) {
        int ind1, ind2, x, y;
        cin >> ind1 >> ind2 >> x >> y;

        int h = __gcd(x, y);
        x /= h;
        y /= h;

        --ind1;
        --ind2;

        g[ind2].push_back({ind1, {razlog(x), razlog(y)}});
        g[ind1].push_back({ind2, {razlog(y), razlog(x)}});
    }

    dfs(0, -1, {}, {});

    ll a_0 = 1;

    for (auto i : now_ans) {
        a_0 *= bin_pow(i.first, i.second);
        a_0 %= MOD;
    }

    dfs2(0, -1, a_0);
    cout << global_ans << '\n';

    for (int i = 0; i < n; ++i) {
        g[i].clear();
        now_ans.clear();
        global_ans = 0;
    }
}

signed main() {
    fast_stream();

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}