#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(time(0));

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(a, b) cout << #a << " = " << a << ", " << #b << " = " << b << endl;
#define trace3(a, b, x) cout << #a << " = " << a << ", " << #b << " = " << b << ", " << #x << " = " << x << endl;
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

template <typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

ld logarifm(ld a, ld b) {
    return log(a) / log(b);
}

const ll K = 447;

void solve() {
    ll n;
    cin >> n;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    ll max_len = -1;
    ll fir = 100000 / K;

    for (ll shag = -fir; shag <= fir; ++shag) {
        vector<ll> ht;

        for (ll i = 0; i < n; ++i) {
            ht.push_back(a[i] - shag * i);
        }

        sort(all(ht));

        ll prosh = 0;

        for (ll i = 0; i < n; ++i) {
            if (ht[i] != ht[prosh]) prosh = i;

            max_len = max(max_len, i - prosh + 1);
        }
    }

    if (max_len >= K) {
        cout << max_len << '\n';
        return;
    }

    for (ll i = 0; i < n; ++i) {
        vector<ll> ht;

        for (ll j = i + 1; j < min(n, i + K + 3); ++j) {
            if (abs(a[j] - a[i]) % abs(j - i)) continue;

            ht.push_back((a[i] - a[j]) / (i - j));
        }

        sort(all(ht));

        ll prosh = 0;

        for (ll i = 0; i < ht.size(); ++i) {
            if (ht[i] != ht[prosh]) prosh = i;

            max_len = max(max_len, i - prosh + 1 + 1);
        }
    }

    cout << n - max_len << '\n';
}

signed main() {
    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}