#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) { return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) { return a < b ? a = b, true : false; }

const int N = 2e5+7;
const ll MOD = 998244353;

struct edge{
    int u, a, b;
};

vector<edge> g[N];

ll inv(ll a, ll m) {
    return a == 1 ? a : m - m*inv(m%a, a)/a;
}

vector<int> up, res, ans;

void dfs(int v, int p = -1) {
    for (auto tmp : g[v]) {
        int u = tmp.u, a = tmp.a, b = tmp.b;
        if (u == p) continue;
        ll ja = a, jb = b;
        vector<pair<int, int>> change, res_change;
        ll j = 2;
        while (j*j <= ja) {
            while (ja%j == 0) ja/=j, up[j]++, change.push_back({1, j});
            j++;
        }
        if (ja > 1) {
            up[ja]++; change.push_back({1, ja});
        }
        j = 2;
        while (j*j <= jb) {
            if (jb%j == 0) {
                int k = 0;
                while (jb%j == 0) jb/=j, k++;
                while (up[j] && k) k--, up[j]--, change.push_back({-1, j});
                res[j] += k;
                ckmax(ans[j], res[j]);
                res_change.push_back({j, k});
            }
            j++;
        }
        if (jb > 1) {
            int k = 1;
            while (up[jb] && k) k--, up[jb]--, change.push_back({-1, jb});
            res[jb] += k;
            ckmax(ans[jb], res[jb]);
            res_change.push_back({jb, k});
        }
        dfs(u, v);
        for (auto ch : change) up[ch.S] -= 1*ch.F;
        for (auto ch : res_change) res[ch.F] -= ch.S;
    }
}

ll binpow(ll a, ll p) {
    ll r = 1;
    for (int j = 0; j < 30; ++j, a = a*a%MOD) {
        if ((p>>j)&1) r=r*a%MOD;
    }
    return r;
}

ll answer = 0;

void calc(int v, ll x, int p = -1) {
    for (auto tmp : g[v]) {
        ll u = tmp.u, a = tmp.a, b = tmp.b;
        if (u == p) continue;
        ll y = x*a%MOD*inv(b, MOD)%MOD;
        answer = (answer + y)%MOD;
        calc(u, y, v);
    }
}

void solve() {
    int n; cin >> n;
    up.resize(n+1); res.resize(n+1); ans.resize(n+1);
    for (int i = 0; i <= n; ++i) g[i].clear(), up[i] = res[i] = ans[i] = 0;
    for (int i = 0; i < n-1; ++i) {
        int u, v, a, b; cin >> u >> v >> a >> b;
        int d = __gcd(a, b); a/=d; b/=d;
        g[--u].push_back({--v, b, a});
        g[v].push_back({u, a, b});
    }
    dfs(0);
    ll p = 1;
    for (int i = 1; i <= n; ++i) p = p*binpow(i, ans[i])%MOD;
    answer = p;
    calc(0, p);
    cout << answer << "\n";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}