#include <bits/stdc++.h>
using namespace std;

const long long MAXN = 2e5 + 10;
vector <long long> p;
vector <long long> c, a;

struct edge {
    long long u, x, y;

    edge() {}

    edge(long long u, long long x, long long y) : u(u), x(x), y(y) {}
};
vector <vector <edge>> g;
long long gcd(long long a, long long b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

void dfs(int v, int p) {
    for (auto u : g[v]) {
        if (u.u != p) {
            int x = u.x;
            int y = u.y;
            //cout << v << " " << u.u << " " << x << " " << y << endl;
            for (int i = 2; i * i <= x; ++i) {
                while (x % i == 0) {
                    c[i] += 1;
                    x /= i;
                }
            }
            if (x > 1) {
                c[x] += 1;
            }
            vector <pair <int, int>> r;
            for (int i = 2; i * i <= y; ++i) {
                if (y % i == 0) {
                    int k = 0;
                    while (y % i == 0) {
                        k += 1;
                        y /= i;
                    }
                    if (c[i] < k) {
                        //cout << "+ " << i << " " << k - c[i] << endl;
                        a[i] += k - c[i];
                        r.push_back({i, k - c[i]});
                    }
                }
            }
            if (y > 1) {
                if (c[y] < 1) {
                    //cout << "+ " << y << " " << 1 << endl;
                    a[y] += 1 - c[y];
                    r.push_back({y, 1 - c[y]});
                }
            }
            y = u.y;
            vector <pair <int, int>> e;
            for (int i = 2; i * i <= y; ++i) {
                if (y % i == 0) {
                    long long k = 0;
                    while (y % i == 0) {
                        k += 1;
                        y /= i;
                    }
                    e.push_back({i, min(k, c[i])});
                    c[i] -= min(k, c[i]);
                }
            }
            if (y > 1) {
                e.push_back({y, min(1 * 1ll, c[y])});
                c[y] -= min(1 * 1ll, c[y]);
            }
            dfs(u.u, v);
            for (auto i : e) {
                c[i.first] += i.second;
            }
            for (auto i : r) {
                c[i.first] += i.second;
            }
            r.clear();
            e.clear();
            x = u.x;
            for (int i = 2; i * i <= x; ++i) {
                while (x % i == 0) {
                    c[i] -= 1;
                    x /= i;
                }
            }
            if (x > 1) {
                c[x] -= 1;
            }

        }
    }
}

const long long mod = 998244353;

long long bpow(long long a, long long n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        long long b = bpow(a, n / 2);
        return (b * b) % mod;
    }
    return (a * bpow(a, n - 1)) % mod;
}

vector <long long> revmod;

long long s = 0;
void get(long long v, long long p, long long k) {
    s = (s + k) % mod;
    for (auto u : g[v]) {
        if (u.u != p) {
            long long q = ((k * u.x) % mod * revmod[u.y]) % mod;
            get(u.u, v, q);
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    revmod.resize(MAXN, 0);
    for (long long i = 1; i < MAXN; ++i) {
        revmod[i] = bpow(i, mod - 2);
    }
    vector <int> pr(MAXN, 1);
    pr[0] = 0;
    pr[1] = 0;
    c.resize(MAXN, 0);
    a.resize(MAXN, 0);
    for (long long i = 2; i < MAXN; ++i) {
        if (!pr[i]) {
            continue;
        }
        p.push_back(i);
        if (i * 1ll * i >= MAXN) {
            continue;
        }
        for (long long j = i * i; j < MAXN; j += i) {
            pr[j] = 0;
        }
    }
    while (t--) {
        long long n;
        cin >> n;
        g.clear();
        g.resize(n);
        for (int i = 0; i < n - 1; ++i) {
            long long u, v, x, y;
            cin >> u >> v >> x >> y;
            --u;
            --v;
            long long q = gcd(x, y);
            x /= q;
            y /= q;
            g[u].push_back({v, y, x});
            g[v].push_back({u, x, y});
        }
        //cout << endl;
        s = 0;
        dfs(0, -1);
        long long ans = 1;
        for (auto i : p) {
            if (a[i] > 0) {
                //cout << i << " " << a[i] << endl;
                long long q = bpow(i, a[i]);
                ans = (ans * q) % mod;
                a[i] = 0;
            }
            c[i] = 0;
        }
        //cout << ans << endl;
        get(0, -1, ans);
        cout << s << '\n';
    }
}
