#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const ll MOD = 998244353;

ll Pow(ll x, ll p) {
    if (p == 1)
        return x;
    ll y = Pow(x, p / 2);
    if (p % 2 == 0)
        return y * y % MOD;
    else
        return y * y % MOD * x % MOD;
}

vector<pair<ll, int>> Div(ll x) {
    vector<pair<ll, int>> res;
    ll y = 2;
    while (y * y <= x) {
        int c = 0;
        while (x % y == 0) {
            ++c;
            x /= y;
        }
        if (c > 0)
            res.emplace_back(y, c);
        ++y;
    }
    if (x > 1)
        res.emplace_back(x, 1);
    return res;
}

struct Edge {
    int v;
    ll x, y;
    Edge(int v = -1, ll x = 0, ll y = 1): v(v), x(x), y(y) {}
};

vector<vector<Edge>> g;
gp_hash_table<ll, int> mx, curr;

void Dfs1(int u = 0, int p = -1, ll x = 0, ll y = 1) {
    vector<pair<ll, int>> d1, d2;
    if (u != 0) {
        d1 = Div(x);
        d2 = Div(y);
        for (auto q: d2)
            curr[q.first] -= q.second;
        for (auto q: d1) {
            curr[q.first] += q.second;
            mx[q.first] = max(mx[q.first], curr[q.first]);
        }
    }
    for (auto to: g[u]) {
        if (to.v != p)
            Dfs1(to.v, u, to.x, to.y);
    }
    if (u != 0) {
        for (auto q: d1)
            curr[q.first] -= q.second;
        for (auto q: d2)
            curr[q.first] += q.second;
    }
}

ll d, ans;
vector<ll> b;

void Dfs2(int u = 0, int p = -1, ll x = 0, ll y = 1) {
    vector<pair<ll, int>> d1, d2;
    if (u != 0) {
        d1 = Div(x);
        d2 = Div(y);
        for (auto q: d1)
            d = d * Pow(b[q.first], q.second) % MOD;
        for (auto q: d2)
            d = d * Pow(q.first, q.second) % MOD;
        ans = (ans + d) % MOD;
    }
    for (auto to: g[u]) {
        if (to.v != p)
            Dfs2(to.v, u, to.x, to.y);
    }
    if (u != 0) {
        for (auto q: d1)
            d = d * Pow(q.first, q.second) % MOD;
        for (auto q: d2)
            d = d * Pow(b[q.first], q.second) % MOD;
    }
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        b.resize(n + 1);
        sfor(i, 0, n) b[i] = Pow(i, MOD - 2);
        g.assign(n, vector<Edge>(0));
        mx.clear();
        sfor(i, 0, n - 2) {
            int u, v;
            ll x, y;
            cin >> u >> v >> x >> y;
            --u;
            --v;
            g[u].emplace_back(v, x, y);
            g[v].emplace_back(u, y, x);
        }
        Dfs1();
        d = 1;
        for (auto p: mx) {
            if (p.second > 0)
                d = d * Pow(p.first, p.second) % MOD;
        }
        ans = d;
        Dfs2();
        cout << ans << '\n';
    }
}
